package com.hamaf.hikyaku.access;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.utils.Dto2SqlUtils;
import com.hamaf.hikyaku.dataobject.utils.ResultSetUtil;

import static com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;

/**
 * <p>^CgFAccessBase is Accessor Class base.</p>
 * <p>FANZXNXp̃x[XNXB</p>
 * <br>DBRlNV̓RXgN^TomcatConnection Pool擾܂B
 * <br>TomcatłResource"dbc/Hikyaku"ƂȂ܂B
 * <br>ȉ̃\bh`Ă܂B
 * <ol>
 *   <li>getStatement() - <code>Statement</code>擾
 *   <li>closeStatement() - <code>Statement</code>N[Y
 *   <li>destroy() - DataBase <code>Connection</code>J
 *      <br>StatementJĂ΁A܂B
 *   <li>exclusion() - r`FbNsArG[̏ꍇO𓊂
 * </ol>
 *
 * <p>쌠: Copyright (c) 2004/06/16</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class AccessBase {

  protected DbConnectInterface _DbConnect = null;
  protected Connection _conn = null;
  protected Statement _stmt = null;

  /**
   * Describe <code>getConnection</code> method : get DB Connection from pool.
   * <br>DB̃RlNVv[ANeBuȐڑIuWFNg擾B
   *
   * @param param a <code>String</code> : p[^
   * @param sysId a <code>String</code> : VXeID
   */
  protected final void setConnection(String param, String sysId){
    try{
      if (_conn != null) {
        return;
      }
      if (_DbConnect != null) {
        _conn = _DbConnect.getConnection(param);
        return;
      }
      _conn = ConnectFactory.getConnect(param, sysId);
      _conn.setAutoCommit(false);
    }catch(Exception e){
      e.printStackTrace();
    }
  }

  /**
   * Describe <code>getStatement</code> method : get DB Statement.
   * <br>Xe[gg@IuWFNg𐶐Ė߂B
   * <br>
   * @return a <code>Statement</code> : Statment
   * @throws SQLException
   */
  protected Statement getStatement() throws SQLException {
    if (_conn == null) {
      throw new SQLException("has not Connection");
    }
    if (_stmt == null) {
      _stmt = _conn.createStatement();
    }
    return _stmt;
  }

  /**
   * Describe <code>closeStatement</code> method : close Statement.
   * <br>gpς݂Statement ObjectB
   * <br>
   * @throws SQLException
   */
  protected final void closeStatement() throws SQLException {
    if (_stmt != null) {
      _stmt.close();
      _stmt = null;
    }
  }

  /**
   * Describe <code>destroy</code> method : close Connection.
   * <br>gpς݂DB ConnectionJB
   * <br>
   * @throws SQLException a <code>void</code> :
   */
  protected final void destroy() throws SQLException {
    if (_conn == null) {
      return;
    }
    closeStatement();
    _conn.close();
    _conn = null;
  }

  private static final String SQL1 =
    "Select " + COMMFLD.UPDT.getVal() + ", " + COMMFLD.UPTM.getVal() +
    " From {0} {1}{2}";
  /**
   * Describe <code>exclusion</code> method : check exclusion.
   * <br>K̍ږ̂pāA<code>AbstDataObj</code>A<code>DaoSelectBase</code>ɔrsB
   * <br>rG[ꍇAOiExclusionExceptionj𓊂܂B
   * @param dataObj a <code></code> : XVsData Object
   * @param sb a <code>String</code> : XVse[u
   * @throws ExclusionException : rG[̏ꍇAO
   * @throws SQLException
   */
  protected final void exclusion(DetailItemsInterface dii,String tableName)
   throws ExclusionException, SQLException {
    if (_conn == null) {
      throw new SQLException("has not Connection");
    }

    String opt = "";
    if (getProductName().toLowerCase().startsWith("oracle")) {
      opt = " FOR UPDATE";
    }
    Object[] prm = {tableName, Dto2SqlUtils.getWhereString(dii, getPkeys(tableName)), opt};
    Statement exStm = _conn.createStatement();
    try {
      ResultSet rs = exStm.executeQuery(MessageFormat.format(SQL1, prm));
      if(rs.next()){
        if(!ResultSetUtil.getString(rs, 1).trim().equals(dii.getCommFld(COMMFLD.UPDT).trim())
        || !ResultSetUtil.getString(rs, 2).trim().equals(dii.getCommFld(COMMFLD.UPTM).trim())) {
          throw new ExclusionException("Change Update Date or Time. \n DB : " +
              ResultSetUtil.getString(rs, 1) + " " + ResultSetUtil.getString(rs, 2) +
              "\n Data : " + dii.getCommFld(COMMFLD.UPDT) + " " + dii.getCommFld(COMMFLD.UPTM));
        }
      }else{
        throw new ExclusionException("Update Data Not Found.");
      }
      rs.close();
    } finally {
//      exStm.cancel();
      exStm.close();
    }
  }

  /**
   * Describe <code>pkeys</code> method : return PrimaryKeys name.
   * PrimaryKey ̃J`ɐݒ肳B
   * @param table a <code>String</code> : PrimaryKey 擾e[u
   * @return a <code>List</code> : 擾PrimaryKeyږ̈ꗗ
   * @throws java.lang.Exception
   */
  protected final List<String> getPkeys(String tableName) throws SQLException {
    if (_conn == null) {
      return null;
    }
    List<String> reslt = new ArrayList<String>();
    DatabaseMetaData dbmd = _conn.getMetaData();
    ResultSet rs;
    if (dbmd.getDatabaseProductName().startsWith("Oracle")) {
      rs = dbmd.getPrimaryKeys(null, dbmd.getUserName(), tableName);
    }
    else if (dbmd.getDatabaseProductName().startsWith("Postgre")) {
      rs = dbmd.getPrimaryKeys(null, null, tableName.toLowerCase());
    }
    else {
      rs = dbmd.getPrimaryKeys(null, null, tableName);
    }
    while (rs.next()) {
      reslt.add(rs.getString("COLUMN_NAME"));
    }
    rs.close();
    return reslt;
  }

  /**
   * Describe <code>getProductName</code> method : get DatabaseProductName.
   * <br>DatabaseProductName擾B
   * <br>
   * @return@a <code>String</code> : atabaseProductName
   * @throws SQLException
   */
  protected final String getProductName() throws SQLException {
    return _conn.getMetaData().getDatabaseProductName();
  }

}
