package com.hamaf.hikyaku.containar;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>^CgFDiFactory is DiContainer Factory class.</p>
 * <p>FDiRei[ێ</p>
 * <br>VOgł̎Ƃ܂B
 * 
 * <p>쌠: Copyright (c) 2007/05/18</p>
 * @author y-hamanaka
 * @version 1.0
 */
public final class DiFactory {
  
  private static DiFactory _myObj = new DiFactory();
  private Map<String, DiContainer> _diObj = new HashMap<String, DiContainer>();
  
  private DiFactory() {
  }

  /**
   * Describe <code>getInstance</code> method : get DiFactory instance.
   * <br>VOgɂACX^X擾\bhB
   * 
   * @return a <code>DiFactory</code> : 
   */
  public static DiFactory getInstance() {
    return _myObj;
  }
  
  /**
   * Describe <code>setContainar</code> method : setting DiContainer Class.
   * <br>SystemId, DiTypeL[ɂ<b>DiContainer</b>NXݒ肷B
   * <br>NX̎w肪(<code>null</code>)ꍇ́Apicocontainar+nanocontainarɂȂB
   * <br>ɕێĂꍇ́A܂B
   * 
   * @param cls a <code>String</code> : NX
   * @param parm a <code>String</code> : ݒt@C̃p[^
   * @param sysId a <code>String</code> : SystemId
   */
  public void setContainar(String cls, String parm, String sysId) {
    if (_diObj.get(sysId) == null) {
      reSetContainer(cls, parm, sysId);
    }
  }
  
  /**
   * Describe <code>setContainar</code> method : reset DiContainer Class.
   * <br>SystemId, DiTypeL[ɂ<b>DiContainer</b>NXݒ肷B
   * <br>NX̎w肪(<code>null</code>)ꍇ́Apicocontainar+nanocontainarɂȂB
   * 
   * @param cls a <code>String</code> : NX
   * @param parm a <code>String</code> : ݒt@C̃p[^
   * @param sysId a <code>String</code> : SystemId
   */
  public void reSetContainer(String cls, String parm, String sysId) {
    DiContainer dt = null;
    
    if (cls == null || cls.length() == 0) {
      dt = getDefault(parm);
    }
    else {
      dt = getContainarCls(cls, parm);
    }
    _diObj.put(sysId, dt);
  }
  
  /**
   * Describe <code>getContainer</code> method : get DiContaine class.
   * <br>SystemId, DiTypeL[ɂ<b>DiContainer</b>NX擾B
   * 
   * @param sysId a <code>String</code> : SystemId
   * @return a <code>DiContainer</code> : 
   * @throws ClassNotFoundException
   */
  public DiContainer getContainer(String sysId) throws ClassNotFoundException {
    DiContainer ret = _diObj.get(sysId);
    if (ret == null) {
      throw new ClassNotFoundException("Type  data not found. id is " + sysId);
    }
    return ret;
  }
  
  private DiContainer getDefault(String flnm) {
    DiContainer diCont = new DiPicoContainar();
    diCont.initialize(flnm);
    return diCont;
  }
  
  private DiContainer getContainarCls(String cls, String parm) {
    try {
      Object obj = Class.forName(cls).newInstance();
      if (obj instanceof DiContainer) {
        DiContainer diCont = (DiContainer) obj;
        diCont.initialize(parm);
        return diCont;
      }
    } catch (Exception xe) {
      xe.printStackTrace();
    }
    return null;
  }
  
  
}
