package com.hamaf.hikyaku.dataobject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import com.hamaf.hikyaku.util.TextUtil;


/**
 * <p>^CgFKeyList is Keep Key List Information.</p>
 * <p>Fꗗ\pKeyzǗNX</p>
 * <br>ۊǂ鍀ڂ
 * <ol>
 *   <li>Retrieve : ڂێMap &lt;String, String&gt;
 *   <li>KeyData : ꗗΏۃf[^KeyIuWFNgێList &lt;List&lt;String&gt;&gt;
 *   <li>Spare : ꗗΏۃf[^keyɑΉA⏕GA
 *   <li>PageCount : Pł̃C
 *   <li>LastAccess : Ōɖ߂KeyIuWFNg̈ʒu
 *   <li>Process : vZXID
 *   <li>SysId : VXeID
 *   <li>CharCD : R[h
 * </ol>
 * <br>󋵎擾\bhƂĈȉ̃\bhpӂĂ܂
 * <ul>
 *   <li>boolean hasNextPage() : ̕ł̗L iłƂ<code>true</code>)
 *   <li>boolean hasBackPage() : O̕ł̗L iOłƂ<code>true</code>)
 *   <li>int getDataCount() : Key Object̑
 *   <li>int getStartPos() : Key Object擾Jnʒu
 *   <li>int getLastPos() : Key Object擾Iʒu
 * </ul>
 * <br>iterator()KeyDataIterator߂܂B
 * <p>[팸Ƃ<b>KeyData</b>ꎞt@Cɑޔ@\܂B
 * <ul>
 *  <li>saveKeyData : L[l̈ꗗꎞt@Cɏo
 *  <li>releaseKeyData : KeyDataNA
 *  <li>resetKeyData : ޔꎞt@CKeyData𐶐
 *  <li>svfl : ꎞt@CێGA
 * </ul>
 *
 * <p>쌠: Copyright (c) 2003/12/26</p>
 * @author Hamanaka
 * @version 1.0
 */
public class KeyList implements Iterable<List<String>>{

  public enum PAGE_ACT {FORWARD (1), BACK (-1), SAME (0);
    private final int val;
    PAGE_ACT(int v) {val = v;}
    public int getVal() {return val;}
  }

  private Map<String, String> _retrieve = null;
  private int _pageCount = 30;

  private List<List<String>> _keyData = new ArrayList<List<String>>();
  private List<String> _keyFields = null;
  private Map<Integer, Object> _spare = new HashMap<Integer, Object>();
  private File _svfl = null;
  private int _keyCnt = 0;
  
  private int _lastAccess = -1;
  private int _strPos = 0;
  private int _currentPage = -1;
  
  /**
   * Describe process,sysId and charCd here.
   */
  private String _process = null;
  private String _sysId;
  private String _charCD;

  /**
   *  Creates a new <code>KeyList.java</code> instance.
   * <br>Default Constructor
   * @param key
   */
  public KeyList(Map<String, String> key) {
    _retrieve = new HashMap<String, String>();
    _retrieve.putAll(key);
    init();
  }

  /**
   * Describe <code>init</code> method : save area initialize.
   * <be>Keyڕۑp̈NA[B
   */
  public final void init() {
    _keyData = new ArrayList<List<String>>();
    _keyFields = null;
    _spare.clear();
    _lastAccess = -1;
    _strPos = 0;
    _currentPage = -1;
    _keyCnt = 0;
  }

  /**
   * Describe <code>getStartKey</code> method : get start position item.
   * <br>̕ɑΉȉ̍ڂ߂B
   * <ol>
   *   <li>FORWARD - ŌɎ擾f[^̎̃f[^
   *   <li>BACK - Py[WO̍ŏ̃f[^
   *   <li>SAME - y[W̍ŏ̃f[^
   * </ol>
   * @param direction an <code>int</code> : of[^̕
   * @return an <code>List&lt;String&gt;</code> : Y鍀
   * @throws IllegalArgumentException : FORWARD,BACK,SAME ȊȌꍇɓO
   * @throws IndexOutOfBoundsException : 擾ʒuz𒴂ꍇɓO
   */
  public final List<String> getStartKey(PAGE_ACT direction)
  throws IndexOutOfBoundsException {
    _currentPage += direction.getVal();
    _strPos = _currentPage * _pageCount;
    if (_strPos < 0 || _strPos >= _keyCnt) {
      throw new IndexOutOfBoundsException
               ("position Error : " + Integer.toString(_strPos));
    }
    _lastAccess = _strPos;
    return _keyData.get(_lastAccess);
  }

  /**
   * Describe <code>getNextKeyt</code> method : net item at last access.
   * <br>ŌɎ擾f[^̎̃f[^߂܂B
   * @return a <code>List&lt;String&gt;</code> : Y鍀
   * @throws IndexOutOfBoundsException : 擾ʒuz𒴂ꍇɓO
   */
  public final List<String> getNextKey() throws IndexOutOfBoundsException {
    _lastAccess++;
    if (_lastAccess >= _keyCnt) {
      _lastAccess--;
      throw new IndexOutOfBoundsException("at End");
    }
    return _keyData.get(_lastAccess);
  }

  /**
   * Describe <code>hasNext</code> method : check next position.
   * <br>Ɏ擾f[^ꍇ<code>true</code>߂܂B
   * <br>̈ʒuڐȉłPy[W̍sȉ̂ƂɎ擾ڂƔf܂B
   * @return a <code>boolean</code> : 擾f[^ꍇ "^"
   */
  public final boolean hasNext() {
    return _lastAccess + 1 < getLastLineCount()? true : false;
  }

  /**
   * Describe <code>getLastLineCount</code> method : return max position.
   * <br>z̍őĺi<b>getLastAccess</b>Ŏ擾ʒu + Py[W̍sĵꂩق߂܂B
   * @return an <code>int</code> : 擾ʒu̍ől
   */
  private int getLastLineCount() {
    int pos = _strPos + _pageCount;
    return pos < _keyCnt ? pos : _keyCnt;
  }

  /**
   * Describe <code>hasBack</code> method : check back page ok.
   * <br>O̕łŎ擾f[^ꍇ<code>true</code>߂܂B
   * <br>gbṽf[^̈ʒuPȏ̂Ƃɉ\Ɣf܂B
   * @return a <code>boolean</code> : 擾f[^ꍇ "^"
   */
  public final boolean hasBackPage() {
    return _strPos > 0;
  }
  /**
   * Describe <code>hasNextPage</code> method : check next page ok.
   * <br>̕łŎ擾f[^ꍇ<code>true</code>߂܂B
   * <br>Ō̃f[^̈ʒuL[ȉ̂Ƃɉ\Ɣf܂B
   * @return a <code>boolean</code> : 擾f[^ꍇ "^"
   */
  public final boolean hasNextPage() {
    return _lastAccess + 1 < _keyCnt;
  }

  /**
   * Describe <code>getKey</code> method : get Item at position.
   * <br>w肳ꂽʒũf[^߂܂B
   * @param idx a <code>Object</code> :  f[^擾ʒu
   * @return a <code>List&lt;String&gt;</code> :  w肳ꂽʒũf[^
   * @throws IndexOutOfBoundsException : 擾ʒuz𒴂ꍇɓO
   */
  public final List<String> getKey(int idx) throws IndexOutOfBoundsException {
    if (idx < 0 || idx >= _keyCnt) {
      throw new IndexOutOfBoundsException(Integer.toString(idx));
    }
    if (_keyData != null) {
      return _keyData.get(idx);
    }
    resetKeyData();
    List<String> ret = _keyData.get(idx);
    _keyData = null;
    return ret;
  }

  /**
   * Describe <code>getPageCount</code> method : return line count per page.
   * <br>y[W̍s߂܂B
   * @return an <code>int</code> : Py[W̍s
   */
  public final int getPageCount() {
    return _pageCount;
  }

  /**
   * Describe <code>getDataCount</code> method : return total count.
   * <br>keyf[^̌߂B
   * @return a <code>int</code> :@f[^
   */
  public final int getDataCount() {
    return _keyCnt;
  }
  /**
   * Describe <code>getStartPos</code> method : return start position.
   * <br>L[f[^擾Jnʒu߂B
   * @return a <code>int</code> : Jnʒu
   */
  public final int getStartPos() {
    return _strPos + 1;
  }
  /**
   * Describe <code>getLastPos</code> method : return end position.
   * <br>L[f[^擾Iʒu߂B
   * @return a <code>int</code> : Iʒu
   */
  public final int getLastPos() {
    return _lastAccess + 1;
  }

  /**
   * Describe <code>getRetrieve</code> method : get retrieve item at key.
   * <br>ڂMapw肳ꂽkeyl̍ڂ߂B
   * <br>l݂Ȃ<code>(== null)</code>ƂA0̕<code>("")</code>߂B
   * @param key a <code>String</code> : 擾鍀ڂ̖
   * @return a <code>String</code> : 擾l
   */
  public final String getRetrieve(String key) {
    String rv = _retrieve.get(key);
    if (rv == null) {
      rv = "";
    }
    return rv;
  }
  
  /**
   * Describe <code>getRetrieve2Jsp</code> method : get JSP format retrieve item at key.
   * <br>ڂMapw肳ꂽkeyl̍ڂJSP̕\p̌`Ŗ߂B
   * <br>JSPł̕\pɃR[hϊA^Oϊs܂B
   * <br>l݂Ȃ<code>(== null)</code>ƂA0̕<code>("")</code>߂B
   * @param key a <code>String</code> : 擾鍀ڂ̖
   * @return a <code>String</code> : ϊl
   */
  public String getRetrieve4Jsp(String key) {
    return TextUtil.cnvJsp(getRetrieve(key), _charCD);
  }

  /**
   * Describe <code>getRetrieveAll</code> method : return retrieve Map.
   * <br>ڂۑ<code>Map</code>߂܂B
   * @return a <code>Map</code> : ڂۑĂMap
   */
  public final Map<String, String> getRetrieveAll() {
    return _retrieve;
  }

  /**
   * Describe <code>addKey</code> method : add key item.
   * <br>keyzɃf[^o^B
   * @param key a <code>Object</code> : o^f[^
   */
  public final void addKey(List<String> key) {
    _keyData.add(key);
    _keyCnt = _keyData.size();
  }
  /**
   * Keyf[^ꗗIterator߂.
   * @see java.lang.Iterable#iterator()
   */
  public final ListIterator<List<String>> iterator() {
    return _keyData.listIterator();
  }

  /**
   * Describe <code>setKeyDataAll</code> method : set all items changed key List.
   * <br>keyznꂽList Object̒lŒu܂B
   * @param argList a <code>List</code> : ݒ肷keyl̔z
   */
  public final void setKeyDataAll(List<List<String>> argList) {
    _keyData.clear();
    _keyData.addAll(argList);
    _keyCnt = _keyData.size();
  }

  /**
   * Describe <code>setPageCount</code> method : set line count par page.
   * <br>Py[W̍sݒ肵܂B
   * @param argI an <code>int</code> : Py[W̍s
   */
  public final void setPageCount(int argI) {
    _pageCount = argI;
  }

  /**
   * Describe <code>setPageCount</code> method : set line count par page.
   * <br>Py[W̍sݒ肵܂B
   * @param argS a <code>String</code> : Py[W̍s
   */
  public final void setPageCount(String argS) {
    if (argS == null || argS.length() == 0) {
      return;
    }
    try {
      setPageCount(Integer.parseInt(argS));
    }
    catch (NumberFormatException e) {
    }
  }
  
  /**
   * Describe <code>setSpare</code> method : setting value in spareMap.
   * <br>ʒuwŗ\̈ɒlݒ肷B
   * @param pos an <code>int</code> : ΏۂƂȂf[^̈ʒu
   * @param val an <code>Object</code> : ۑl
   */
  public final void setSpare(int pos, Object val) {
    _spare.put(pos, val);
  }
  
  /**
   * Describe <code>getSpare</code> method : get value from spareMap.
   * <br>\̈悩w肳ꂽʒu̒l擾B
   * @param pos an <code>int</code> : 擾l̈ʒu
   * @return an <code>Object</code> : 擾l
   */
  public final Object getSpare(int pos) {
    return _spare.get(pos);
  }
  
  /**
   * Describe <code>getSpareMap</code> method : return spareMap.
   * <br>\̈(<code>Map</code>)߂B
   * @return a <code>Map</code> : \̈
   */
  public final Map<Integer, Object> getSpareMap() {
    return _spare;
  }
  
  /**
   * Describe <code>setCurrentPage</code> method : reset current page.
   * <br>݂̕ňʒuw肳ꂽlɕύXB
   * @param page a <code>void</code> : ύXňʒu
   */
  public final void setCurrentPage(String page) {
    if (page == null || page.length() == 0) {
      return;
    }
    try {
      _currentPage = Integer.parseInt(page);
    } catch (Exception ex) { }
  }
  
  /**
   * Describe <code>getCurrentPage</code> method : get current page.
   * <br>݂̕ňʒu擾B
   * @return a <code>int</code> : ݂̕ňʒu
   */
  public final int getCurrentPage() {
    return _currentPage;
  }

  /**
   * Describe <code>getMaxPageNo</code> method : get Max Page No.
   * <br>őy[W߂B
   * 
   * @return a <code>int</code> : őy[W
   */
  public final int getMaxPageNo() {
    return (getDataCount() - 1 + _pageCount) / _pageCount;
  }
  
  /**
   * Get the <code>SysId</code> value.
   *
   * @return a <code>String</code> : 
   */
  public final String getSysId() {
    return _sysId;
  }

  /**
   * Set the <code>SysId</code> value.
   *
   * @param newSysId The new SysId value.
   */
  public final void setSysId(String newSysId) {
    this._sysId = newSysId;
  }

  /**
   * @return charCD
   */
  public final String getCharCD() {
    return _charCD;
  }

  /**
   * @param charCD charCD ݒ肵܂B
   */
  public final void setCharCD(String charCD) {
    _charCD = charCD;
  }

  /**
   * @return process
   */
  public final String getProcess() {
    return _process;
  }

  /**
   * @param process process ݒ肵܂B
   */
  public final void setProcess(String process) {
    _process = process;
  }

  /**
   * @return keyFields
   */
  public final List<String> getKeyFields() {
    return _keyFields;
  }

  /**
   * @param keyFields keyFields ݒ肵܂B
   */
  public final void setKeyFields(List<String> keyFields) {
    _keyFields = keyFields;
  }
  
  /**
   * Describe <code>saveKeyData</code> method : write Key Data to temp file.
   * <br>KeyData̓eꎞt@CɏoB
   */
  public final void saveKeyData() {
    try {
      if (_svfl == null) {
        _svfl = File.createTempFile("KeyList", ".dat");
        _svfl.deleteOnExit();
      }
      BufferedWriter bw = new BufferedWriter(new FileWriter(_svfl));
      for(List<String> kldt : _keyData) {
        StringBuilder sb = new StringBuilder();
        for (String kdt: kldt) {
          sb.append(kdt);
          sb.append("\t");
        }
        bw.write(sb.toString());
        bw.newLine();
      }
      bw.close();
    } catch (Exception xe) {
      _svfl = null;
      xe.printStackTrace();
    }
  }
  /**
   * Describe <code>releaseKeyData</code> method : KeyData release.
   * <br>KeyData ̈JB
   */
  public final void releaseKeyData() {
    _keyData = null;
  }
  
  /**
   * Describe <code>resetKeyData</code> method : set KeyData from temp file.
   * <br>ꎞt@C KeyData 𕜌B
   */
  public final void resetKeyData() {
    List<List<String>> ldt = new ArrayList<List<String>>();
    if (_svfl == null) {
      if (_keyData == null) _keyData = ldt;
      return;
    }
    
    try {
      BufferedReader br = new BufferedReader(new FileReader(_svfl));
      String bf = br.readLine();
      while (bf != null) {
        String[] dts = bf.split("\t");
        List<String> kls = new ArrayList<String>();
        for (int i = 0; i < dts.length; i++) {
          kls.add(dts[i]);
        }
        ldt.add(kls);
        bf = br.readLine();
      }
      br.close();
    } catch (Exception xe) {
      xe.printStackTrace();
    }
    _keyData = ldt;
  }

  // ---------- toString Methods ----------
  /**
   * Describe <code>toStatusString</code> method : 󋵕ێڂ̕l߂.
   * <br>ȉ̍ڂ̕l𐶐܂B
   * <ul>
   *   <li>Page Count : 1ʂ̕\s
   *   <li>Current Page : ݂̕ňʒu
   *   <li>Start Position : \f[^̊Jnʒu
   *   <li>System ID, Character Code
   *   <li>Save Conditions : ڂ̕ێe
   * </ul>
   * 
   * @return a <code>String</code> : 
   */
  public String toStatusString() {
    StringBuilder sb = new StringBuilder();
    sb.append("\nPage Count is ");
    sb.append(_pageCount);
    sb.append("\nCurrent Page is ");
    sb.append(_currentPage);
    sb.append("\nStart Position is ");
    sb.append(_strPos);
    sb.append("\nSystem ID is ");
    sb.append(_sysId);
    sb.append("\nCharacter Encode is ");
    sb.append(_charCD);
    sb.append("\nSave Conditions value Start -----\n");
    for (String keys : _retrieve.keySet()) {
      sb.append(keys);
      sb.append(" = ");
      sb.append(_retrieve.get(keys));
      sb.append(".\n");
    }
    sb.append("Save Conditions value End -----\n");
    return sb.toString();
  }
  /**
   * Describe <code>toKeysString</code> method : L[ꗗ̕ێe߂.
   * <br>ȉ̍ڂ̕l𐶐܂B
   * <ul>
   *   <li>Keys Items : L[ڂ̍ږƂ̒l
   *   <li>Spare Items : ۑ̈̓e
   * </ul>
   * 
   * @return a <code>String</code> : 
   */
  public String toKeysString() {
    if (_keyData == null) {
      if (_svfl == null) {
        return "\nKeyData is null";
      }
      return "\nKeyData saved " + _svfl.getPath();
    }
    
    StringBuilder sb = new StringBuilder();
    int[] ml = maxLen();
    sb.append("\nKeys Items Start -----\n");
    int i = 0;
    for (String keys : _keyFields) {
      sb.append(addSpace(keys, ml[i]));
      sb.append(", ");
      i++;
    }
    sb.setLength(sb.length() -2);
    sb.append(".\n");
    for (List<String> ldt : _keyData) {
      i = 0;
      for (String dt : ldt) {
        sb.append(addSpace(dt, ml[i]));
        sb.append(", ");
        i++;
      }
      sb.setLength(sb.length() -2);
      sb.append(".\n");
    }
    sb.append("Keys Items End -----\n");
    sb.append("\nSpare Items Value Start -----\n");
    for (i=0; i < _spare.size(); i++) {
      sb.append("No. ");
      sb.append(i);
      sb.append(". = ");
      sb.append(_spare.get(i).toString());
      sb.append(".\n");
    }
    sb.append("\nSpare Items Value End -----\n");
    return sb.toString();
  }
  private int[] maxLen() {
    int[] l = new int[_keyFields.size()];
    for (int i=0; i < _keyFields.size(); i++) {
      for (String dt : _keyData.get(i)) {
        if (dt.length() > l[i]) l[i] = dt.length();
      }
      if (_keyFields.get(i).length() > l[i]) l[i] = _keyFields.get(i).length();
    }
    return l;
  }
  private String addSpace(String val, int l) {
    StringBuilder sb = new StringBuilder(val);
    sb.setLength(l);
    return sb.toString().replace('\u0000', ' ');
  }
}
