package com.hamaf.hikyaku.dataobject;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;

/**
 * <p>^CgFRetrieveKeysBase is RetrieveKeysInterface implementation base class.</p>
 * <p>FvC}L[ꗗ擾p̃x[XNXB</p>
 * <br>pNX́Aȉ̒`s܂B
 * <ol>
 *   <li><b>public final static int</b>Ŏgp鍀ڂ`B
 *   <li>RXgN^[ɂ<b>String[] keyItems</b>Ŏ擾L[̍ږ`B
 * </ol>
 * pꍇ̍l
 * <br> Elݒ肳Ăi󕶎("")ȊOĵ̂݁AΏۂƂȂ܂B
 * <br> E͐ݒ肪ꍇA<b>("=")</b>ɂȂ܂B
 * <br><code>constCond</code>ɏݒ肷ƁAꂪt܂Bi<code>AND</code>j
 * i"AND"͕svłj
 * Tv
 * <pre>
 * public class XxxxxRetrieveKeyInstance extends RetrieveKeysBase {
 *
 *    // DBږ̂ŃtB[h` (l 0 珇Ԃɐݒ肷邱)
 *    public final static int USER_NAME = 0;
 *    public final static int MAIL_ADDR = 1;
 *    public final static int Sample = 2;
 *    // DBږƈقȂꍇ iL Samplejȉ̂悤ɂāADBږw肷
 *    // ꍀڂʂ̃tB[hŕ`邱Ƃ\łB
 *    public final static String Sample_FIELD = "ۂ̍ږ";
 *
 *    public XxxxxRetrieveKeyInstance() {
 *      // 擾DBږw肷(w\)iȗj
 *      // ȗ̓e[u`PrimaryKeyڂ擾܂
 *      keyItems = new String[]{"USER_ID"};
 *    }
 * }
 * </pre>
 *
 * <p>쌠: Copyright (c) 2004/06/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public abstract class RetrieveKeysBase implements RetrieveKeysInterface {

  protected String[] keyItems = null;

  private Map<Integer, String> _items = new HashMap<Integer, String>();
  private Map<Integer, String> _retrieveItem = new TreeMap<Integer, String>();
  private Map<Integer, String> _conditionValue = new HashMap<Integer, String>();
  private Map<Integer, String> _orderItem = new TreeMap<Integer, String>();
  private Map<Integer, Integer> _orderPos = new TreeMap<Integer, Integer>();
  private String _constCond = "";
  private String _sysId = null;
  private USE_FLG _del = null;
  private List<String> _pkeyFld = null;

  private List<List<String>> _kval = new ArrayList<List<String>>(50);

  public RetrieveKeysBase() {
    init();
  }

  private void init() {
    Field[] flds = this.getClass().getFields();
    Map<String, Integer> _itemNo = new HashMap<String, Integer>();
    for (Field fld : flds) {
      if (fld.getType().getName().equals("int")) {
        try {
          int p = fld.getInt(this);
          if (!_items.containsKey(p)) {
            _itemNo.put(fld.getName(), p);
            _items.put(p, fld.getName());
          }
        } catch (Exception xe) { }
      }
    }
    for (Field fld : flds) {
      if (fld.getType().getName().endsWith("String")) {
        StringBuilder nm = new StringBuilder(fld.getName());
        if (nm.toString().toUpperCase().endsWith("_FIELD")) {
          nm.setLength(nm.length() - 6);
          if (_itemNo.containsKey(nm.toString())) {
            try {
              _items.put(_itemNo.get(nm.toString()), (String)fld.get(this));
            } catch (Exception xe) { }
          }
        }
      }
    }
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.RetrieveKeysInterface#setRetrieveValue(int, java.lang.String)
   */
  public final void setRetrieveValue(int item, String val)
    throws IllegalArgumentException {
      _retrieveItem.put(item, val);
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.RetrieveKeysInterface#setCondition(int, java.lang.String)
   */
  public final void setCondition(int item, String cond)
    throws IllegalArgumentException {
      _conditionValue.put(item, cond);
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.RetrieveKeysInterface#setOrderItem(int, int)
   */
  public final void setOrderItem(int item, int seq) throws IllegalArgumentException {
    if (seq == 0) {
      return;
    }
    Integer absSeq = new Integer(Math.abs(seq));
    StringBuilder sb = new StringBuilder();
    sb.append(_items.get(item));
    if (seq < 0) {
      sb.append(" DESC");
    }
    _orderItem.put(absSeq, sb.toString());
    _orderPos.put(item, seq);
  }


  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#clearKeys()
   */
  public final void clearKeys() {
    _kval.clear();
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.RetrieveKeysInterface#addKey(java.lang.Object)
   */
  public final void addKey(List<String> key) {
    _kval.add(key);
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.RetrieveKeysInterface#setKeys(java.util.List)
   */
  public final void setKeys(List<List<String>> keys) {
    _kval = keys;
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.RetrieveKeysInterface#getKeys()
   */
  public final List<List<String>> getKeys() {
    return _kval;
  }

  /**
   * L[Xg<b>Iterator</b>߂.
   * @see java.lang.Iterable#iterator()
   */
  public final Iterator<List<String>> iterator() {
    return _kval.iterator();
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobj.RetrieveKeysInterface#itemCount()
   */
  public final int itemCount() {
    return _items.size();
  }

  /* (non-Javadoc)
   * @see com.hamaf.hikyaku.dataobj.RetrieveKeysInterface#keyCount()
   */
  public final int keyCount() {
    if (keyItems == null) {
      return 0;
    }
    return keyItems.length;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getOrderItems()
   */
  public final Map<Integer, String> getOrderItems() {
    return _orderItem;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getOrderPos()
   */
  public final Map<Integer, Integer> getOrderPos() {
    return _orderPos;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getRetriveValues()
   */
  public final Map<Integer, String> getRetriveValues() {
    return _retrieveItem;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getConditions()
   */
  public final Map<Integer, String> getConditions() {
    return _conditionValue;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getConstCond()
   */
  public final String getConstCond() {
    return _constCond;
  }
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#setConstCond(java.lang.String)
   */
  public final void setConstCond(String constCond) {
    _constCond = constCond;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getItem(int)
   */
  public final String getItem(int pos) throws IllegalArgumentException {
    if (pos < 0 || pos > itemCount()) {
      throw new IllegalArgumentException("over renge pos is " + pos);
    }
    return _items.get(pos);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getKeyItem(int)
   */
  public final String getKeyItem(int pos) throws IllegalArgumentException {
    if (pos < 0 || pos > keyCount()) {
      throw new IllegalArgumentException("over renge pos is " + pos);
    }
    return keyItems[pos];
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getDel(int)
   */
  public final USE_FLG getDel() {
    return _del;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#setDel(int)
   */
  public final void setDel(USE_FLG del) {
    _del = del;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getSysId(int)
   */
  public final String getSysId() {
    return _sysId;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#setSysId(int)
   */
  public final void setSysId(String sysId) {
    _sysId = sysId;
  }
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#getPkeyFld()
   */
  public final List<String> getPkeyFld() {
    return _pkeyFld;
  }
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.dataobject.RetrieveKeysInterface#setPkeyFld(java.util.List)
   */
  public final void setPkeyFld(List<String> keys) {
    _pkeyFld = keys;
  }

	/* ( Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(this.getClass().getName());
		sb.append("\n----- items -----\n");
		sb.append(_items.toString());
		sb.append("----- retrieve values -----\n");
		sb.append(_retrieveItem.toString());
		sb.append("----- conditions -----\n");
		sb.append(_conditionValue.toString());
		sb.append("----- order items -----\n");
		sb.append(_orderItem.toString());
		sb.append("----- order podition -----\n");
		sb.append(_orderPos.toString());
		if (_pkeyFld != null) {
			sb.append("----- primarikey value -----\n");
			sb.append(_kval.toString());
			sb.append("----- primarikey fields -----\n");
			sb.append(_pkeyFld.toString());
		}
		sb.append("\n----- expansion fields -----");
		sb.append("\n  sysId : ");
		sb.append(_sysId);
		sb.append("\n  Cond  : ");
		sb.append(_constCond);
		return super.toString();
	}

}
