package com.hamaf.hikyaku.dataobject.utils;

import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.DtoMapping;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;

import static com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;

/**
 * <p>^CgFCopyDtoUtil is create new Dto with corresponding definition.</p>
 * <p>F}bsO`ɏ]āAʌ̃NX獀ڒl𕡎ʂVf[^IuWFNgĐB</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2007/06/05</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class CopyDtoUtil {

  /**
   * Describe <code>copy</code> method : copy DetailItemsInterface object.
   * <br>}bsO`ɏ]āAʌ <code>DetailItemsInterface</code> V <code>DetailItemsInterface</code> 𐶐܂B
   *
   * @param dmp a <code>DtoMapping</code> : }bsO`
   * @param org a <code>DetailItemsInterface</code> : ʌ̃IuWFNg
   * @return a <code>DetailItemsInterface</code> : IuWFNg
   * @exception Exception if an error occurs
   */
  public static final synchronized DetailItemsInterface newDto(DtoMapping dmp,
      DetailItemsInterface org) throws Exception {
    DetailItemsInterface ndto =
      (DetailItemsInterface)dmp.createCorrespondingClass(org.getClass());
    return copy(dmp, org, ndto);
  }
  /**
   * Describe <code>copy</code> method : copy DetailItemsInterface object.
   * <br>}bsO`ɏ]āAʌ <code>DetailItemsInterface</code> V <code>DetailItemsInterface</code> 𐶐܂B
   * <br>VNXDiContainarɂA܂B
   * 
   * @param dmp a <code>DtoMapping</code> : }bsO`
   * @param org a <code>DetailItemsInterface</code> : ʌ̃IuWFNg
   * @return a <code>DetailItemsInterface</code> : IuWFNg
   * @exception Exception if an error occurs
   */
  public static final synchronized DetailItemsInterface newDiDto(DtoMapping dmp,
      DetailItemsInterface org) throws Exception {
    DetailItemsInterface ndto =
      (DetailItemsInterface)dmp.createCorrespondingClass(org.getSysId(), org.getClass());
    return copy(dmp, org, ndto);
  }
  private static final DetailItemsInterface copy(DtoMapping dmp, DetailItemsInterface org,
    DetailItemsInterface ndto) throws Exception {
    for (int ops : dmp.getItemNoList(org)) {
      if (org.isRequestItem(ops)) {
        ndto.setItemValue(dmp.getCorrespondingPos(org, ops),
                          org.getItemValue(ops));
      }
    }
    for (COMMFLD fld : COMMFLD.values()) {
      ndto.setCommFld(fld, org.getCommFld(fld));
    }
    ndto.setSysId(org.getSysId());
    if (org.isNotFound()) ndto.setNotFound();
    
    return ndto;
  }
  
  /**
   * Describe <code>addition</code> method : additional DetailItemsInterface values.
   * <br>}bsO`ɏ]āA{ <code>DetailItemsInterface</code> 
   * <br>ʂƂ <code>DetailItemsInterface</code> ̒l𕡎ʂB
   * 
   * @param dmp a <code>DtoMapping</code> : }bsO`
   * @param base a <code>DetailItemsInterface</code> : {ƂȂf[^IuWFNg
   * @param copy a <code>DetailItemsInterface</code> : l𕡎ʂf[^IuWFNg
   * @return a <code>DetailItemsInterface</code> : ʌ̃f[^IuWFNg
   */
  public static final DetailItemsInterface addition(DtoMapping dmp,
      DetailItemsInterface base, DetailItemsInterface copy) {
    for (int ops : dmp.getItemNoList(copy)) {
      if (copy.isRequestItem(ops)) {
        base.setItemValue(dmp.getCorrespondingPos(copy, ops),
            copy.getItemValue(ops));
      }
    }
    return base;
  }

  /**
   * Describe <code>copy</code> method : copy RetrieveKeysInterface Object.
   * <br>}bsO`ɏ]āAʌ <code>RetrieveKeysInterface</code> V <code>RetrieveKeysInterface</code> 𐶐܂B
   *
   * @param dmp a <code>DtoMapping</code> : }bsO`
   * @param org a <code>RetrieveKeysInterface</code> : ʌ̃IuWFNg
   * @return a <code>RetrieveKeysInterface</code> : IuWFNg
   * @exception Exception if an error occurs
   */
  public static final synchronized RetrieveKeysInterface newDto(DtoMapping dmp,
      RetrieveKeysInterface org) throws Exception {
    RetrieveKeysInterface ndto =
      (RetrieveKeysInterface)dmp.createCorrespondingClass(org.getClass());
    return copy(dmp, org, ndto);
  }
  /**
   * Describe <code>copy</code> method : copy RetrieveKeysInterface Object.
   * <br>}bsO`ɏ]āAʌ <code>RetrieveKeysInterface</code> V <code>RetrieveKeysInterface</code> 𐶐܂B
   * <br>VNXDiContainarɂA܂B
   *
   * @param dmp a <code>DtoMapping</code> : }bsO`
   * @param org a <code>RetrieveKeysInterface</code> : ʌ̃IuWFNg
   * @return a <code>RetrieveKeysInterface</code> : IuWFNg
   * @exception Exception if an error occurs
   */
  public static final synchronized RetrieveKeysInterface newDiDto(DtoMapping dmp,
      RetrieveKeysInterface org) throws Exception {
    RetrieveKeysInterface ndto =
      (RetrieveKeysInterface)dmp.createCorrespondingClass(org.getSysId(), org.getClass());
    return copy(dmp, org, ndto);
  }
  private static final RetrieveKeysInterface copy(DtoMapping dmp,RetrieveKeysInterface org,
      RetrieveKeysInterface ndto) throws Exception {
    for (int ops : dmp.getItemNoList(org)) {
      int cps = dmp.getCorrespondingPos(org, ops);
      ndto.setRetrieveValue(cps, org.getRetriveValues().get(ops));
      ndto.setCondition(cps, org.getConditions().get(ops));
      if (org.getOrderPos().containsKey(ops)) {
        ndto.setOrderItem(cps, org.getOrderPos().get(ops));
      }
    }
    if (org.getKeys() != null) {
      ndto.setKeys(new ArrayList<List<String>>(org.getKeys()));
    }
    ndto.setSysId(org.getSysId());
    ndto.setDel(org.getDel());
    return ndto;
  }

}
