package com.hamaf.hikyaku.dataobject.utils;

import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;

import static com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;

/**
 * <p>^CgFDtoUtils is create SQL by DataObject.</p>
 * <p>Ff[^IuWFNgSQL𐶐郆[eBeBW</p>
 * <br>ȉ̑<b>static</b>Œ񋟂B
 * <br><b>RetrieveKeysInterface,DetailItemsInterface</b>ɋʂȋ@\
 * <ol>
 *   <li>getWhereString() : iwhereȍ~j𐶐
 *   <li>getSelectString() : Select𐶐
 * </ol>
 * <br><b>DetailItemsInterface</b>݂̂ɒ񋟂@\
 * <ol>
 *   <li>getSelectStringWithExclusion : ʍڕtSelect𐶐
 *   <li>getInsertItem : insert𐶐
 *   <li>getInsertItemWithExclusion : ʍڕtinsert𐶐
 *   <li>getInsertValue : insertpvalues𐶐
 *   <li>getInsertValueWithExclusion : ʍڕtinsertpvalues𐶐
 *   <li>getUpdateString : update𐶐
 *   <li>getUpdateStringWithExclusion : ʍڕtupdate𐶐
 * </ol>
 *
 * <p>쌠: Copyright (c) 2007/05/31</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class Dto2SqlUtils {

  /**
   * Method getWhereString is return SQL String Where and Order By.
   * <br>AяSQLXe[gg߂B
   * <br>ɂAl̕ҏWsB
   * <ul>
   *   <li>"LIKE" - Ō"%"t
   *   <li>"IN" - O"(",")"t
   *   <li>"IS","BETWEEN" - ҏWs͂Ȃ
   *   <li>LȊO - O"'"t
   * </ul>
   * <br>쐬SQL"<b>WHERE .... ORDER BY ....</b>"
   *
   * @param rki <code>RetrieveKeysInterface</code>
   * @return String : AяpSQL
   */
  public static final String getWhereString(RetrieveKeysInterface rki) {
    StringBuilder sb = new StringBuilder();
    Map<Integer, String> items = rki.getRetriveValues();
    for (Integer key : items.keySet()) {
      if (items.get(key).length() > 0) {
        sb.append(rki.getItem(key));
        sb.append(" ");
        String cond = checkCondition(rki.getConditions().get(key));
        sb.append(cond);
        sb.append(" ");
        sb.append(getRetrieveValue(cond, key, items));
        sb.append(" AND ");
      }
    }
    if (sb.length() > 0 && rki.getConstCond().equals("")) {
      sb.setLength(sb.length() - 5);
    }
    sb.append(rki.getConstCond());
    if (rki.getDel() != null) {
      if (sb.length() > 0) {
        sb.append(" AND ");
      }
      sb.append(COMMFLD.DEL.getVal());
      sb.append(" = '");
      if (USE_FLG.DEL.getVal().equals(rki.getDel())) {
        sb.append(USE_FLG.DEL.getVal());
      } else {
        sb.append(USE_FLG.USE.getVal());
      }
      sb.append("'");
    }
    if (sb.length() > 0) {
      sb.insert(0, "WHERE ");
    }

    sb.append(toOrder(rki.getOrderItems()));

    return sb.toString();
  }
  /**
   * Describe <code>getRetCondition</code> method : check Condition.
   * <br><b>null</b>̏ꍇɁA("=")߂B
   * @param key an <code>String</code> : ̕
   * @return a <code>String</code> : ̕
   */
  private static String checkCondition(String condition) {
    if (condition == null){
      return "=";
    }
    return condition;
  }
  /**
   * Describe <code>getRetrieveValue</code> method : return retrieve value.
   * <br>ڂ̌l߂B
   * <ol>
   *   <li>"between","is" - ݒ肳Ăl̂܂ܖ߂B
   *   <li>"in" - O"("A")"tĖ߂B
   *   <li>"like" - "'"OɕtA"%"̎w肪ꍇɂ́AŌ"%"tB
   *   <li>LȊO - "'"OɕtĖ߂B
   * </ol>
   *
   * @param cond a <code>String</code> : 
   * @param key an <code>int</code> : ڔԍ
   * @param items a <code>Map&lt;Integer, String&gt;</code> : ڃe[u
   * @return a <code>String</code> : ̕
   */
  private static String getRetrieveValue(String cond, Integer key, Map<Integer, String> items) {
    String cndVal = cond.toUpperCase();
    StringBuilder value = new StringBuilder();
    if (cndVal.equals("BETWEEN") || cndVal.equals("IS")) {
      value.append(items.get(key));
      value.append(" ");
    }
    else if (cndVal.endsWith("IN")) {
      value.append("(");
      value.append(items.get(key));
      value.append(")");
    }
    else if (cndVal.endsWith("LIKE")) {
      value.append("'");
      value.append(items.get(key).replaceAll("'","''"));
      if (value.indexOf("%") < 0) {
        value.append("%");
      }
      value.append("'");
    }
    else {
      value.append("'");
      value.append(items.get(key).replaceAll("'","''"));
      value.append("'");
    }
    return value.toString();
  }
  /**
   * Describe <code>toOrder</code> method : create Order By String.
   * <br><b>ORDER BY</b>𐶐Ė߂B
   * <br>\ݒ肳ĂȂꍇ́A̕("")߂B
   *
   * @param order a <code>Map&lt;Integer, String&gt;</code> : \e[u
   * @return a <code>String</code> : <code>ORDER BY</code> ̕
   */
  private static String toOrder(Map<Integer, String> order) {
    if(order.size() == 0){
      return "";
    }
    StringBuilder sb = new StringBuilder();
    sb.append(" ORDER BY ");
    Collection<String> col = order.values();
    for (Iterator<String> iter = col.iterator(); iter.hasNext();) {
      sb.append(iter.next());
      sb.append(",");
    }
    sb.setLength(sb.length() - 1);
    return sb.toString();
  }

  /**
   * Method getSelectItems is return SQL String Select.
   * <br>L[ڂݒ肵SELECTpږSQLXe[gg߂B
   * <br>RetrieveKeysInterfaceŖ`̏ꍇ́AL[ږ̃Xg琶B
   *
   * @param rki <code>RetrieveKeysInterface</code>
   * @param pkeys <code>List</code> : L[ږ̃Xg
   * @return String : SELECTpSQL
   */
  public static String getSelectItems(RetrieveKeysInterface rki, List<String> pkeys) {
    if (rki.keyCount() > 0) {
      List<String> pks = new ArrayList<String>();
      for (int i = 0; i < rki.keyCount(); i++) {
        pks.add(rki.getKeyItem(i));
      }
      return createSelect(rki, pks);
    }
    return createSelect(rki, pkeys);
  }

  /**
   * Method createSelect is return SQL String Select.
   * <br>L[ڂݒ肵SELECTpږSQLXe[gg߂B
   * <br>쐬SQL"<b>L[ږ, ....</b>"
   *
   * @param rki <code>RetrieveKeysInterface</code>
   * @param pkeys <code>List</code> : L[ږ̃Xg
   * @return String : SELECTpSQL
   */
  private static String createSelect(RetrieveKeysInterface rki, List<String> pkeys) {
    if (pkeys == null || pkeys.size() == 0) {
      return "";
    }

    StringBuilder sb = new StringBuilder();
    for (String fld : pkeys) {
      sb.append(fld);
      sb.append(",");
    }
    sb.setLength(sb.length() - 1);
    return sb.toString();
  }

  /**
   * Method getWhereString is return SQL Where String.
   * <br>vC}L[ŌWhereSQL߂B
   * <br>DetailItemsInterfaceŒ`ĂȂꍇ́AL[ږ̃Xg琶B
   *
   * @param dii a <code>DetailItemsInterface</code> :
   * @param keys a <code>List</code> : PrimaryKeyږ̃Xg
   * @return String
   */
  public static final String getWhereString(DetailItemsInterface dii, List<String> keys) {
    if (dii.getKeyFlds() != null) {
      List<String> flds = new ArrayList<String>();
      for (int p : dii.getKeyFlds()) {
        flds.add(dii.getField(p));
      }
      return createWhere(dii, flds);
    }
    return createWhere(dii, keys);
  }

  /**
   * Method createWhere is return SQL Where String.
   * <br>vC}L[ŌWhereSQL߂B
   * <br>쐬SQL"<b>pkey1 = '__' AND pkey2 = '__'</b>"
   *
   * @param dii a <code>DetailItemsInterface</code> :
   * @param keys a <code>List</code> : PrimaryKeyږ̃Xg
   * @return String
   */
  private static final String createWhere(DetailItemsInterface dii, List<String> keys) {
    StringBuilder sb = new StringBuilder();
    for (String fld : keys) {
      sb.append(fld);
      sb.append(" = '");
      sb.append(dii.getFldValue(fld).replaceAll("'","''"));
      sb.append("' AND ");
    }
    if (sb.length() > 0 && dii.getConstCond().equals("")) {
      sb.setLength(sb.length() - 5);
    }
    sb.append(dii.getConstCond());
    if (sb.length() > 0) {
      sb.insert(0, "WHERE ");
    }

    if(dii.getGroup() != null && dii.getGroup().length() > 0) {
      sb.append(" GROUP BY ");
      sb.append(dii.getGroup());
    }
    return sb.toString();
  }

  /**
   * Method getSelectItems is return get item string.
   * <br>擾鍀ږ","ŘASelectpږSQL߂B
   * <br>쐬SQL"<b>ږ, ....</b>"
   * @return String
   */
  public static final String getSelectItems(DetailItemsInterface dii) {
    StringBuilder sb = new StringBuilder();
    for (int i : dii.getItemNoList()) {
      if (dii.isRequestItem(i) && !dii.isKeyFld(i)) {
        sb.append(dii.getField(i));
        sb.append(",");
      }
    }
    sb.setLength(sb.length() - 1);
    return sb.toString();
  }

  /**
   * Method getSelectItemsWithExclusion is return Select string added Exclusion items.
   * <br>K̔rp̍ځi"UPD_DATE,UPD_TIME")ǉA
   * <br>擾鍀ږ","ŘASelectpږSQL߂B
   * <br>쐬SQL"<b>SELECT ږ, ...., UPD_DATE, UPD_TIME</b>"
   * @return String
   */
  public static final String getSelectItemsWithExclusion(DetailItemsInterface dii) {
    StringBuilder sb = new StringBuilder();
    sb.append(getSelectItems(dii));
    for (COMMFLD cfld : COMMFLD.values()) {
      sb.append(",");
      sb.append(cfld.getVal());
    }
    return sb.toString();
  }

  /**
   * Method getInsertItem is return insert item string.
   * <br>o^p̍ږ","ŘA߂B
   * @return String
   */
  public static final String getInsertItem(DetailItemsInterface dii) {
    return toInsertString(false, dii);
  }

  /**
   * Method getInsertItemWithExclusion is return insert item string added Exclusion.
   * <br>rp̋K̍ږƓo^p̍ږ","ŘA߂B
   * @return String
   */
  public static final String getInsertItemWithExclusion(DetailItemsInterface dii) {
    StringBuilder sb = new StringBuilder(getInsertItem(dii));
    for (COMMFLD fld : COMMFLD.values()) {
      sb.append(",");
      sb.append(fld.getVal());
    }
    return sb.toString();
  }

  /**
   * Method getInsertValue is return insert value string.
   * <br>o^p̍ڂ̒l","ŘA߂B
   * @return String
   */
  public static final String getInsertValue(DetailItemsInterface dii) {
    return toInsertString(true, dii);
  }

  /**
   * Method getInsertValue is return insert value string added Exclusion.
   * <br>rp̍ڂƓo^p̍ڂ̒l","ŘA߂B
   * @return String
   */
  public static final String getInsertValueWithExclusion(DetailItemsInterface dii) {
    StringBuilder sb = new StringBuilder(getInsertValue(dii));
    Date curdt = new Date();
    DateFormat dfd = DateFormat.getDateInstance(DateFormat.MEDIUM, Locale.JAPAN);
    dii.setCommFld(COMMFLD.UPDT, dfd.format(curdt));
    DateFormat dfm = DateFormat.getTimeInstance(DateFormat.MEDIUM, Locale.JAPAN);
    dii.setCommFld(COMMFLD.UPTM, dfm.format(curdt));
    dii.setCommFld(COMMFLD.DEL, USE_FLG.USE.getVal());
    for (COMMFLD fld : COMMFLD.values()) {
      sb.append(",'");
      sb.append(dii.getCommFld(fld).trim());
      sb.append("'");
    }
    return sb.toString();
  }

  /**
   * Method getUpdateItems is return update item string.
   * <br>XVp<b>SET</b>p̕߂B
   * <br>쐬SQL"<b>ږ='l', ....</b>"
   * @return String
   */
  public static final String getUpdateItems(DetailItemsInterface dii) {
    StringBuilder sb = new StringBuilder("");
    for (int i : dii.getItemNoList()) {
      if (dii.isRequestItem(i) && !dii.isKeyFld(i)) {
        sb.append(dii.getField(i));
        sb.append(" = ");
        String val = dii.getItemValue(i);
        if (val == null || val.length() == 0) {
          sb.append("null");
        }
        else {
          sb.append("'");
          sb.append(val.replaceAll("'","''"));
          sb.append("'");
        }
        sb.append(",");
      }
    }
    if (sb.length() > 0) {
      sb.setLength(sb.length() - 1);
      sb.insert(0, "SET ");
    }
    return sb.toString();
  }

  /**
   * Method getUpdateItemsWithExclusion is return update item string added Exclusion.
   * <br>K̔rp̍ڂݒ肵XVp<b>SET</b>p̕߂B
   * <br>쐬SQL"<b>ږ='l', ...., UPD_DATE='yyyy/mm/dd', UPD_TIME='hh:mm:ss'</b>"
   * @return String
   */
  public static final String getUpdateItemsWithExclusion(DetailItemsInterface dii) {
    StringBuilder sb = new StringBuilder(getUpdateItems(dii));
    Date curdt = new Date();
    DateFormat dfd = DateFormat.getDateInstance(DateFormat.MEDIUM, Locale.JAPAN);
    dii.setCommFld(COMMFLD.UPDT, dfd.format(curdt));
    DateFormat dfm = DateFormat.getTimeInstance(DateFormat.MEDIUM, Locale.JAPAN);
    dii.setCommFld(COMMFLD.UPTM, dfm.format(curdt));
    for (COMMFLD fld : COMMFLD.values()) {
      if (sb.indexOf(fld.getVal()) < 0) {
        String val = dii.getCommFld(fld);
        if (val != null && val.length() > 0) {
          sb.append(",");
          sb.append(fld.getVal());
          sb.append("='");
          sb.append(val.trim());
          sb.append("'");
        }
      }
    }
    return sb.toString();
  }

  /**
   * Describe <code>toInsertString</code> method : create insert string.
   * <br>ڒlݒ肳Ă鍀ڂΏۂɂInsert SQLp̕𐶐B
   * <br>val<code>true</code>̏ꍇ́Al̈ꗗA
   * <br><code>false</code>̏ꍇ́Aږ̈ꗗ߂܂B
   * @param val a <code>boolean</code> : ږ̂Ƃfalse
   * @param dii a <code>DetailItemsInterface</code>
   * @return a <code>String</code> : 
   */
  private static String toInsertString(boolean val, DetailItemsInterface dii) {
    StringBuilder sb = new StringBuilder();
    for (int i : dii.getItemNoList()) {
      if (dii.isRequestItem(i)) {
        if (!dii.getItemValue(i).trim().equals("")) {
          if (val) {
            sb.append("'");
            sb.append(dii.getItemValue(i).replaceAll("'","''"));
            sb.append("'");
          }
          else {
            sb.append(dii.getField(i));
          }
          sb.append(",");
        }
      }
    }
    sb.setLength(sb.length() - 1);
    return sb.toString();
  }

}
