package com.hamaf.hikyaku.dataobject.utils;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Types;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;


/**
 * <p>^CgFResultSetUtil is ResultSetGetterpUiltNX.</p>
 * <p>FResultSet邽߂̃[eBeBNXB</p>
 * <ul>
 *   <li>getString() - ResultSetw肳ꂽڂ̒l<code>String</code>Ŗ߂B
 *     <br>݂́A<code>CHAR,NUMBER,VERCHAR</code>^̂ݑΉĂ܂B
 * </ul>
 *
 * <p>쌠: Copyright (c) 2004/06/15</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ResultSetUtil {

  /** ResultSetAw肳ꂽIndex̒l𕶎Ŗ߂
  * @param rs SQLsɍ쐬ꂽResultSetݒ肷
  * @param fieldIndex Select̍Indexw(1`)
  * @return Number(_܂),Char,Varchar̍ڒlׂStringɕϊ߂<br>
  *    _^̃tB[h̏ꍇA_ȉɒlȂꍇ͐lŖ߂
  */
  public static final String getString(ResultSet rs,int fieldIndex) throws SQLException{
    String ret = null;
    switch(rs.getMetaData().getColumnType(fieldIndex)){
      case Types.NUMERIC:
        if (rs.getBigDecimal(fieldIndex) == null) {
          ret = "";
        }
        else {
          ret = rs.getBigDecimal(fieldIndex).toString();
        }
        if (ret.length() == 0) {
          ret = rs.getString(fieldIndex);
        }
        break;
      case Types.DATE:
			case Types.TIME:
				DateFormat df = DateFormat.getDateInstance(DateFormat.LONG, Locale.JAPAN);
				ret = df.format(rs.getDate(fieldIndex));
        if (ret.length() == 0) {
          ret = rs.getString(fieldIndex);
        }
				break;
      default:
        ret = rs.getString(fieldIndex);
    }
    return ret;
  }

  /** ResultSetAw肳ꂽږ̒l𕶎Ŗ߂
  * @param rs SQLsɍ쐬ꂽResultSetݒ肷
  * @param fieldName Select̍ږw(String)
  * @return Number(_܂),Char,Varchar̍ڒlׂStringɕϊ߂<br>
  *    _^̃tB[h̏ꍇA_ȉɒlȂꍇ͐lŖ߂
  */
  public static final String getString(ResultSet rs,String fieldName) throws SQLException{
    return getString(rs, rs.findColumn(fieldName));
  }

  /**
   * Describe <code>getFieldNM</code> method : get field name List.
   * <br>tB[hList𐶐B
   *
   * @param rs a <code>ResultSet<String></code> :
   * @return a <code>List<String></code> : tB[hList
   * @throws SQLException
   */
  public static final List<String> getFieldNM(ResultSet rs) throws SQLException {
    List<String> ret = new ArrayList<String>();
    ResultSetMetaData rsmd = rs.getMetaData();
    for (int i = 1; i <= rsmd.getColumnCount(); i++) {
      ret.add(rsmd.getColumnClassName(i).toUpperCase());
    }
    return ret;
  }

  /**
   * Describe <code>setValues</code> method : set fiels value.
   * <br><b>ResultSet</b><b>DetailItemsInterface</b>֒lݒ肷B
   *
   * @param rs a <code>ResultSet</code> :
   * @param dii a <code>DetailItemsInterface</code> :
   * @return a <code>DetailItemsInterface</code> :
   * @throws SQLException
   */
  public static final DetailItemsInterface setValues(ResultSet rs, DetailItemsInterface dii)
    throws SQLException {
    ResultSetMetaData rsmd = rs.getMetaData();
    for (int i = 1; i <= rsmd.getColumnCount(); i++) {
      dii.setFldValue(rsmd.getColumnName(i), getString(rs, i));
    }
    return dii;
  }

  /**
   * Describe <code>setExclusion</code> method : set commonfiels value.
   * <br>ȉ̋ʍڂ<b>ResultSet</b><b>DetailItemsInterface</b>֐ݒ肷B
   * <ol>
   *   <li>UPD_DATE : XV
   *   <li>UPD_TIME : XV
   *   <li>UPD_USER : XV
   *   <li>UPD_PGM  : XVNX
   *   <li>DEL_FLG  : 폜tO
   * </ol>
   *
   * @param rs a <code>ResultSet</code> :
   * @param dii a <code>DetailItemsInterface</code> :
   * @return a <code>DetailItemsInterface</code> :
   */
  public static final DetailItemsInterface setExclusion(ResultSet rs, DetailItemsInterface dii)
    throws SQLException {
    for (COMMFLD fld : COMMFLD.values()) {
      dii.setCommFld(fld, ResultSetUtil.getString(rs, fld.getVal()));
    }
    return dii;
  }

}
