package com.hamaf.hikyaku.distribute;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

import java.util.Enumeration;
import java.io.ByteArrayOutputStream;
import java.util.Map;
import java.util.Vector;

/**
 * <p>^Cg: MultipartpHttpServletRequest.</p>
 * <p>: <code>multipart/form-data</code>postꂽꍇɎgpAHttpServletRequestłB</p>
 * <br>multipart̑Mɑ΂<code>getParameter()</code>Ă܂B
 * <br><code>application</code>̑MƓlɎ舵悤ɂȂĂ܂B
 * <br>
 * <br>݂̂ƂPt@C̑MɂΉĂ܂B
 *
 * <p>쌠: Copyright (c) 2004</p>
 * @author Hamanaka
 * @version 1.0
 */
public final class MultipartServletRequest extends HttpServletRequestWrapper {

  private Map<String, String> _myParameter = null;
  private Vector<String> _keyList = new Vector<String>();

  private ByteArrayOutputStream _savefl = null;
  private String _sfName = null;
  private String _contType = null;
  
  /**
   *  Creates a new <code>MultipartServletRequest.java</code> instance.
   * <br>ƂȂHttpServletRequest󂯎RXgN^[
   * @param req a <code>HttpServletRequest</code> : HttpServletRequest
   */
  public MultipartServletRequest(HttpServletRequest req) {
  	super(req);
    setParameter();
  }

  public String getParameter(String parm1) {
    return _myParameter.get(parm1);
  }
  public String[] getParameterValues(String parm1) {
    return new String[]{getParameter(parm1)};
  }
  public Enumeration<String> getParameterNames() {
    return _keyList.elements();
  }
  public Map<String, String> getParameterMap() {
    return _myParameter;
  }
  
  private void setParameter() {
    MultipartSetAttribute mas = new MultipartSetAttribute((HttpServletRequest)super.getRequest());
    _myParameter = mas.getParameter();
    _keyList.addAll(_myParameter.keySet());
    
    _savefl = mas.getSavefl();
    _sfName = mas.getSfName();
    _contType = mas.getCtntType();
  }


  /**
   * Describe <code>getSavefl</code> method : return send file image.
   * <br>Mt@CByteArrayOutputStreamɏ񂾂̂߂B
   * @return a <code>ByteArrayOutputStream</code> : Mt@C
   */
  public ByteArrayOutputStream getSavefl() {
    return _savefl;
  }

  /**
   * Describe <code>getSfName</code> method : return send file name.
   * <br>Mꂽt@C߂B
   * @return a <code>String</code> : t@C
   */
  public String getSfName() {
    return _sfName;
  }

  /**
   * Describe <code>getContType</code> method : return content-type.
   * <br>Mt@CContent-Type߂B
   * @return a <code>String</code> : Content-Type
   */
  public String getContType() {
    return _contType;
  }

}
