package com.hamaf.hikyaku.distribute;

import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Map;
import java.util.HashMap;

/**
 * <p>^Cg: Multipart̑Mf[^B</p>
 * <p>: MultipartőMꂽf[^ȉ̒lo܂B</p>
 * <ol>
 *   <li> Content-Disposition:name - ParameterƂĈ悤MapɕϊB
 *   <li> Content-Type - t@C̓eByteArrayOutputStreamƂĈnB
 * </ol>
 * <br>݂̂ƂPt@C̑MɂΉĂ܂B
 *
 * <p>쌠: Copyright (c) 2004</p>
 * @author Hamanaka
 * @version 1.0
 */

public final class MultipartSetAttribute {

  private static final String DISPOS = "Content-Disposition:";
  private static final String DISTYP = "Content-Type: ";
  private static final String MLTCHK = "multipart/form-data";
  private static final String SEP_BOUD = "boundary=";
  private static final String ATRNM = "name=\"";
  private static final String ATREND = "\"";
  private static final String ATRFL = "filename=\"";
//  private static final int BSIZE = 8*1024;
  private static final int SEPLEN = 2;

  private HttpServletRequest _req;

  private ByteArrayOutputStream _savefl = null;
  private String _sfName = null;
  private String _ctntType = null;

  /**
   *  Creates a new <code>MultipartSetAttribute</code> instance.
   * <br>HttpServletRequest󂯎RXgN^[
   * @param req a <code>HttpServletRequest</code> : HttpServletRequest
   */
  public MultipartSetAttribute(HttpServletRequest req) {
    _req = req;
  }

  /**
   * Describe <code>getParameter</code> method : Create Parameter image.
   * <br>namelParameterC[WMapɕϊB
   * @return a <code>Map</code> : ParameterC[WMap
   */
  public Map<String, String> getParameter() {
    Map<String, String> rdt = new HashMap<String, String>();
    String seprt = getSeparator(_req);
    if (seprt == null) {
      return rdt;
    }
    
    try {
      ServletInputStream sis = _req.getInputStream();
      String[] atr;
      while ((atr = MultiRead(sis, seprt, _req.getContentLength())) != null) {
        if (atr[0].length() > 0) {
          rdt.put(atr[0], atr[1]);
        }
      }
      sis.close();
    } catch (Exception e) {
      e.printStackTrace();
      return rdt;
    }
    return rdt;
  }

  /**
   * Describe <code>getSeparator</code> method : Get Boundary String.
   * <br>Zp[^ReLXg^Cv擾B
   * @param req a <code>HttpServletRequest</code> : HttpServletRequest
   * @return a <code>String</code> : 擾؂蕶
   */
  private String getSeparator(HttpServletRequest req) {
    String type = req.getContentType();
    if (type == null || !type.startsWith(MLTCHK)) {
        return null;
    }
    int p = type.indexOf(SEP_BOUD);
    if (p < 0) {
      return null;
    }
    return "--" + type.substring(p + SEP_BOUD.length());
  }

  /**
   * Describe <code>MultiRead</code> method : read data until separeter string.
   * <br>؂蕶Ԃł̃f[^擾Anamê̖Ƃ̒lStringzŖ߂B
   * @param sis a <code>ServletInputStream</code> : ServletInputStream
   * @param seprt a <code>String</code> : ؂蕶
   * @return a <code>String[]</code> : name,l
   */
  private String[] MultiRead(ServletInputStream sis, String seprt, int dl)
  throws IOException {
    String[] val = {"",""};
    int gl;
    byte[] buf = new byte[dl];
    StringBuilder pdt = new StringBuilder();
    boolean nfst = false;
    boolean fldt = false;

    while ((gl = sis.readLine(buf, 0, dl)) > 0) {
      dl -= gl;
      String gdt = new String(buf, 0, gl, DistributeServlet.CHAR);
      if (gdt.startsWith(seprt)) {
        break;
      }
      
      if (gdt.startsWith(DISPOS)) {
        val[0] = getAtrValue(gdt, ATRNM);
        if (gdt.indexOf(ATRFL) >= 0) {
          _sfName = getAtrValue(gdt, ATRFL);
          pdt.append(_sfName);
        }
      }
      else if (gdt.startsWith(DISTYP)) {
        fldt = true;
        _savefl = new ByteArrayOutputStream();
        setContentType(gdt.substring(DISTYP.length()));
      }
      else if (fldt) {
        if (nfst || gl > SEPLEN) {
          _savefl.write(buf, 0, gl);
        }
        nfst = true;
      }
      else if (gl > SEPLEN) {
        pdt.append(gdt);
      }
    }

    if (gl <= 0) {
      return null;
    }
    if (pdt.length() > 2) {
      if (pdt.charAt(pdt.length() - 1) == '\n') {
        pdt.setLength(pdt.length() - SEPLEN);
      }
      val[1] = pdt.toString();
    }

    return val;
  }

  private String getAtrValue(String gdt, String atr) {
    int pos = gdt.indexOf(atr);
    int eps = gdt.indexOf(ATREND, pos+atr.length());
    if (eps < 0) {
      eps = atr.length();
    }
    return gdt.substring(pos + atr.length(), eps);
  }

  private void setContentType(String s) {
    int pos = s.indexOf(";");
    if (pos > 0) {
      s = s.substring(0, pos);
    }
    _ctntType = s.trim();
  }

  /**
   * Describe <code>getCtntType</code> method : return Content-Type.
   * <br>Mt@CContent-Type߂B
   * @return a <code>String</code> : Content-Type
   */
  public String getCtntType() {
    return _ctntType;
  }

  /**
   * Describe <code>getSavefl</code> method : return request file.
   * <br>Mt@CByteArrayOutputStreamɕϊ̂߂B
   * @return a <code>ByteArrayOutputStream</code> : Mt@C
   */
  public ByteArrayOutputStream getSavefl() {
    return _savefl;
  }

  /**
   * Describe <code>getSfName</code> method : return reuest file path.
   * <br>Mt@C̃pX߂B
   * @return a <code>String</code> : Mt@C̃pX
   */
  public String getSfName() {
    return _sfName;
  }

}
