package com.hamaf.hikyaku.distribute;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.text.MessageFormat;
import java.util.List;
import java.util.Map;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import com.hamaf.hikyaku.containar.DiContainer;
import com.hamaf.hikyaku.containar.DiFactory;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.plugIn.PlugInUtils;
import com.hamaf.hikyaku.system.LogOnCheck;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.ComUtils;
import com.hamaf.hikyaku.util.StopControl;


import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import static com.hamaf.hikyaku.distribute.ControlXml.ACTCONT;
import static com.hamaf.hikyaku.distribute.ControlXml.CLS_ATR;
import static com.hamaf.hikyaku.distribute.ControlXml.PROCCONT;
import static com.hamaf.hikyaku.distribute.DistributeServlet.SVAL;

/**
 * <p>^CgFServletUtils is e폈`NX.</p>
 * <p>F<b>DistributeServlet</b>gp郆[eBeBNXłB</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2007/05/18</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ServletUtils {

  private static final String SYS = "System";
  private static final String PLUGIN_BASE = "/plugins/";
  private static final String COMMON_BASE = "/control/";

  private static DistributeServlet _parent = null;

  /**
   * Describe <code>setParent</code> method : save parent DistributeServlet.
   * <br>ẽT[ubg̃CX^XێB
   *
   * @param prm a <code>DistributeServlet</code> : DistributeServlet
   */
  public static final void setParent(DistributeServlet prm) {
    _parent = prm;
  }

  /**
   * Describe <code>setControl</code> method : setting ControlXml.
   * <br>XMLێB
   * <br>ݒς݂̏ꍇ͓ւȂAmode  "all"̏ꍇ́AĐݒsB
   *
   * @param pluginId a <code>String</code> : vOCW[ID
   * @param cntf a <code>String</code> : XML̃pX
   * @param mode a <code>String</code> : "all"̂ƂAĐݒsB
   */
  public static final void setControl(String pluginId, String cntf, String mode) {
    ControlXml cntX = ControlXml.newInstance();
    if (cntX.getDoc(pluginId) == null
        || "all".equals(mode.toLowerCase())) {
      cntX.setControl(pluginId, cntf, _parent.getResource());
      MasterXmlFactory.newInstance().resetMaster(pluginId);
      String msgval = cntf;
      if (cntf == null) {
        msgval = cntX.getDoc(pluginId).getDocumentElement().getNodeName();
      }
      Object[] msg = {pluginId, msgval};
      _parent.getLog().logPut(MessageFormat.format(_parent.getResource().getString("setControlXml"),msg), 1);
    }
  }

  /**
   * Describe <code>clearSession</code> method : Old Process Session info Clear.
   * <br>vOCID,vZXhcςꍇɁAȑÕvZXhc̃ZbVNA܂B
   * <br>vOCŐXMLŊYvZXSaveNotDel"yes"̏ꍇANAȂB
   * <br>vOCIDCMSC̏ꍇAΏۊOƂB
   *
   * @param sval a <code>Map</code> : SVAL
   * @param svSession a <code>HttpSession</code>
   */
  public static final void clearSession(Map<SVAL, String> sval, HttpSession session) {
    String previousPID = (String)session.getAttribute(DistributeServlet.KEY_SAVE_ID);
    StringBuilder sb = new StringBuilder();
    sb.append(sval.get(SVAL.sysId));
    sb.append("_");
    sb.append(sval.get(SVAL.ProcId));
    session.setAttribute(DistributeServlet.PLUGIN_ID, sval.get(SVAL.sysId));
    session.setAttribute(DistributeServlet.KEY_SAVE_ID, sb.toString());

    if (DistributeServlet.SYSID.equals(sval.get(SVAL.sysId))) return;
    String rs = sval.get(SVAL.Reserve);
    if (rs != null && rs.length() > 0 && rs.toLowerCase().startsWith("y")) return;

    List<String> ndlst = PlugInUtils.getPplist();
  	if (ndlst.contains(sb.toString())) return;

    try {
      Boolean clr = true;
      if (sval.get(SVAL.sysId).equals(session.getAttribute(DistributeServlet.PLUGIN_ID))) {
        String chk = ControlXml.newInstance().
        getProcDef(sval.get(SVAL.ProcId), sval.get(SVAL.sysId), PROCCONT.SaveNotDel);
        if (chk != null && chk.toLowerCase().equals("yes")) clr = false;
      }
      if (clr) {
        if (previousPID != null && !previousPID.equals(sb.toString())) {
          session.removeAttribute(previousPID);
          for (String key : ndlst) {
            session.removeAttribute(key);
          }
        }
      }
    } catch (Exception ex) {
    }
  }

  /**
   * Describe <code>checkLogin</code> method : call LogIn check.
   * <br>OC̃`FbNĂяoB
   * <br>G[̏ꍇAĂяoJSP߂B
   * <br>vZXID "System" ̏ꍇA`FbNΏۊOƂB
   *
   * @param proc a <code>String</code> : vZXID
   * @param chkCls a <code>String</code> : OI@`FbN@NX
   * @param di a <code>String</code> : Dicontainer𗘗pꍇÃ^Cvw肷
   * @param pluginId a <code>String</code> : Ĉhc
   * @param request a <code>HttpServletRequest</code> :
   * @return a <code>String</code> : m[}̏ꍇ null
   */
  public static final String checkLogin(String proc, String chkCls, String di, String pluginId,
      HttpServletRequest request, ResourceBundle resource) {
    if (SYS.equals(proc)) {
      return null;
    }

    StopControl stc = StopControl.newInstance();
    if (stc.check()) {
      return stc.getJspUrl();
    }

    if (chkCls == null) {
      return null;
    }

    try {
      LogOnCheck lochk = newCheckCls(chkCls, di, pluginId);
      if (lochk.check(request)) {
        return lochk.getJspUrl(request, resource);
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return null;
  }
  private static LogOnCheck newCheckCls(String chkCls, String di, String pluginId) throws Exception {
    Class<?> chkc = Class.forName(chkCls);
    if (di == null || di.length() == 0) {
      return (LogOnCheck)chkc.newInstance();
    }
    DiContainer dc = DiFactory.getInstance().getContainer(pluginId);
    return (LogOnCheck) dc.getComponent(chkc);
  }

  /**
   * Describe <code>getJspNm</code> method : get JSP name by status.
   * <br>vZXhcAANVɑΉAiro߂܂B
   *
   * @param sval a <code>Map</code> : SVAL
   * @param sts a <code>STATUS</code> : Status
   * @return a <code>String</code> : jsp
   * @exception ServletException
   */
  public static final String getJspNm(Map<SVAL, String> sval, STATUS sts)
    throws ServletException {
    ControlXml cntX = ControlXml.newInstance();
    String pid = sval.get(SVAL.ProcId);
    String act = sval.get(SVAL.Act);
    String pluginId = sval.get(SVAL.sysId);
    try {
      String ret =null;
      switch (sts) {
        case NORMAL:
          ret = cntX.getActDef(pid, act, pluginId, ACTCONT.NextPage);
          break;
        case CAUTION:
          ret = cntX.getActDef(pid, act, pluginId, ACTCONT.CautionPage);
          break;
        case WARNING:
          ret = cntX.getActDef(pid, act, pluginId, ACTCONT.WarningPage);
          break;
        case ERROR:
          ret = cntX.getActDef(pid, act, pluginId, ACTCONT.ErrorPage);
          break;
      }
      if (DistributeServlet.SYSID.equals(pluginId)) return ret;

      if (ret.startsWith(PLUGIN_BASE)) return ret;
      if (ret.startsWith(COMMON_BASE)) return ret;

      StringBuilder sb = new StringBuilder();
      sb.append(PLUGIN_BASE);
      sb.append(pluginId);
      if (ret.charAt(0) != '/') sb.append("/");
      sb.append(ret);
      return sb.toString();
    } catch (Exception ex) {
      throw new ServletException(ex);
    }
  }

  /**
   * Describe <code>procNew</code> method : ProcessBase new Instance.
   * <br>vZXhcAANVɑΉsNX̃CX^X𐶐܂B
   *
   * @param sval a <code>Map</code> : SVAL
   * @param req a <code>HttpServletRequest</code>
   * @param res a <code>HttpServletResponse</code>
   * @return a <code>ProcessBase</code> : sNX̃CX^X
   * @throws IOException
   * @throws ServletException
   */
  public static final ProcessBase procNew(Map<SVAL, String> sval)
    throws  IllegalArgumentException, ClassNotFoundException, ClassCastException {
    String[] clsVal = getExecClassValue(sval);

    if (clsVal[1] != null && clsVal[1].toLowerCase().startsWith("y")) {
      return getClassByDi(clsVal, sval.get(SVAL.sysId));
    }
    return getClassByName(clsVal[0]);
  }

  /**
   * Describe <code>getResource</code> method : get resource.
   * <br>\[X܂̓t@C <code>InputStream</code> 擾B
   *
   * @param fnm a <code>String</code> : \[X
   * @return a <code>InputStream</code> : 擾InputStream
   */
  public final static InputStream getResource(String fnm) {
    String path = ComUtils.convPath(fnm, false);
    InputStream is = _parent.getConfig().getServletContext().getResourceAsStream(path);
    if (is != null) return is;

    File fl = new File(path);
    if (!fl.exists()) return null;
    try {
      return new FileInputStream(fl);
    } catch (Exception xe) { }
    return null;
  }

  /**
   * Describe <code>whichFile</code> method : Change Full Path from file.
   * <br>΃pX΃pXɕϊB
   * @param fileName a <code>String</code> : ΃pXŎꂽt@C
   * @return a <code>String</code> : ΃pXɕϊ
   * @throws MalformedURLException : t@C݂܂
   * @throws UnsupportedEncodingException : VXevpeB file.encoding 擾ł܂
   */
  public static final String whichFile(String fileName) {
    return _parent.getConfig().getServletContext().getRealPath(ComUtils.convPath(fileName, false));
  }

  private static String[] getExecClassValue(Map<SVAL, String> sval)
    throws IllegalArgumentException {
    try {
      String[] ret = new String[4];
      String pid = sval.get(SVAL.ProcId);
      String act = sval.get(SVAL.Act);
      String sid = sval.get(SVAL.sysId);

      ret[0] = ControlXml.newInstance().getActDef(pid, act, sid, ACTCONT.ExecClass);
      ret[1] = ControlXml.newInstance().getExecAtrValue(CLS_ATR.UseDi, pid, act, sid);
      ret[2] = ControlXml.newInstance().getExecAtrValue(CLS_ATR.keyVal, pid, act, sid);
      return ret;
    }
    catch (Exception de) {
      de.printStackTrace();
      throw new IllegalArgumentException("ExecClass", de);
    }
  }
  private static ProcessBase getClassByDi(String[] atr, String sysId)
    throws ClassNotFoundException, ClassCastException {
    try {
      DiContainer di;
      Object obj;
      di = DiFactory.getInstance().getContainer(sysId);
      if (atr[2].toLowerCase().startsWith("clas")) {
        obj = di.getComponent(Class.forName(atr[0]));
      }
      else {
        obj = di.getComponent(atr[2]);
      }
      if (obj instanceof ProcessBase) {
        return (ProcessBase)obj;
      }
      throw new ClassCastException("ProcessBase (" + atr[0] + ")");
    }
    catch (Exception e) {
      throw new ClassNotFoundException(atr[0], e);
    }
  }
  private static ProcessBase getClassByName(String classNm)
    throws ClassNotFoundException, ClassCastException {
    try {
      Object processObj = Class.forName(classNm).newInstance();
      if (processObj instanceof ProcessBase) {
        return (ProcessBase)processObj;
      }
      throw new ClassCastException("ProcessBase (" + classNm + ")");
    }
    catch (Exception e) {
      throw new ClassNotFoundException(classNm, e);
    }
  }

}
