package com.hamaf.hikyaku.distribute;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import org.w3c.dom.Document;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.util.XmlUtil;


/**
 * <p>^CgFXmlTransForm is XML process for Xsl.</p>
 * <p>FXSLɂXMLϊ</p>
 * <br>CommonMessagẽ[NAÄ悩Document Object(Dom)擾܂B
 * <br>HttpRequestHeader<b>user-agent</b>̒lclassestH_[ AgentSuffix.properties
 * <br>̐ݒɊÂw肳ꂽt@Cϊ܂B
 *
 * <p>쌠: Copyright (c) 2004/04/18</p>
 * @author Hamanaka
 * @version 1.0
 */
public class XmlTransForm extends HttpServlet {
  
  private static final long serialVersionUID = -2540878053222823373L;
  
  private static final String DEF_FILE = "AgentSuffix";

  public void init() {
  }

  public void service(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

    response.setContentType("text/html; charset=Shift_JIS");

    CommonMessage cmm = (CommonMessage)request.getAttribute(DistributeServlet.MAPPING_KEY);
    if (!(cmm.getWorkBuff() instanceof Document)) {
      throw new ServletException("Data is not Document Object !!!");
    }
    Document doc = (Document)cmm.getWorkBuff();

    ResourceBundle rb = ResourceBundle.getBundle(DEF_FILE);
    String fl = (String)request.getAttribute(DistributeServlet.XSLPATH);
    String ua = request.getHeader("user-agent");
    
    StringBuilder sb = new StringBuilder();
    sb.append(fl.substring(0, fl.length() - 4));
    for (Enumeration<String> en = rb.getKeys(); en.hasMoreElements();) {
      String ky = en.nextElement();
      if (ua.length() > ky.length() && ua.startsWith(ky)) {
        sb.append(rb.getString(ky));
        break;
      }
    }
    sb.append(".xsl");

    // TransformerFactoryCX^X擾
    TransformerFactory factory = TransformerFactory.newInstance();

    PrintWriter out = response.getWriter();
    try {
      //Document Object  InputStream ɕϊ
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      XmlUtil.writeXml(doc, baos, null);
      ByteArrayInputStream xmldt = new ByteArrayInputStream(baos.toByteArray());

      // XSLt@Ctranceformer擾
      Transformer transformer = factory.newTransformer(new StreamSource(sb.toString()));
      // o͂GR[fBOݒ
      transformer.setOutputProperty("encoding", DistributeServlet.CHAR);
      // XMLt@CXSLTŕϊďo
      transformer.transform(new StreamSource(xmldt), new StreamResult(out));
    } catch(Exception te) {
      throw new ServletException(te);
    }
  }

}
