package com.hamaf.hikyaku.extension;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.File;
import java.util.Properties;
import com.hamaf.hikyaku.distribute.ServletUtils;

/**
 * <p>^Cg: VOgAppLogInfo֌W̃vpeBێB</p>
 * <p>: AppLogOutproperties̕ێsB</p>
 * <br> vpeBƂĕێ鍀
 * <ul>
 *  <li>AvP[VO@t@C̃vtBbNX
 *  <li>AvP[VO@o͐@pX
 *  <li>AvP[VO@o̓x̋Kl
 *  <li>AvP[VO@Pt@C̏o͍s
 *  <li>AvP[VOWo͂ɂo͂邩ۂ
 * </ul>
 * <br>ڍׂ<b>AppLogOut.properties file</b>QƁB
 *
 * <p>쌠: Copyright (c) 2004</p>
 * @author Hamanaka
 * @version 1.0
 */

public class AppLogSingleInfo {

  private static final String FLNAME = "AppLogOut.properties";
  private static AppLogSingleInfo myObj = new AppLogSingleInfo();
  private Properties property = null;

  /**
   * Not Creates a new <code>PreserveBSLinfo</code> instance.
   * <br> new R}hł̃CX^X}~B
   *
   */
  private AppLogSingleInfo() {
    init();
  }

  /**
   * Describe <code>newInstance</code> method : create new Instance.
   * <br>g̃CX^X߂B
   * <br>JavaVM ň̃CX^XsȂB
   *
   * @return an <code>AppLogInfo</code> :
   */
  public static AppLogSingleInfo newInstance() {
    return myObj;
  }

  /**
   * Get the value of LogOutName return Log file Prefix Name .
   * <br>fobOO@t@C̃vtBbNX nB
   * @return an <code>String</code> value of LogOutName.
   */
  public String getLogName() {
    return property.getProperty("LogOutName");
  }

  /**
   * Get the value of LogOutPath return LogOut path .
   * <br>fobOO@o͐@pX nB
   * @return an <code>String</code> value of XmlOutPath.
   */
  public String getLogPath() {
    return property.getProperty("LogOutPath");
  }

  /**
   * Describe <code>getLogLine</code> method : return Max outlin count a file.
   * <br><b>1 File</b>̏o͌߂
   * @return an <code>int</code> : max outline count
   */
  public int getLogLine() {
    int mli = 0;
    try {
      mli = Integer.parseInt(property.getProperty("LogLineCount"));
    } catch (Exception e) {
      mli = 1;
    }
    mli = Math.max(mli, 100);
    return mli;
  }

  /**
   * Describe <code>getLogOutLevel</code> method : return Log output level.
   * <br>Ȍo̓x߂B
   * @return a <code>String</code> : Log output level
   */
  public String getLogOutLevel() {
    return property.getProperty("LogOutLevel");
  }

  /**
   * Describe <code>getSystemOut</code> method : get SystemOut.
   * <br><b>SystemOut Property</b>̒lpɕϊĖ߂B
   * @return a <code>String</code> : value of SystemOut.toLowerCase
   */
  public String getSystemOut() {
    return property.getProperty("SystemOut").toLowerCase();
  }

  /**
   * Describe <code>getPropertyByName</code> method : get property by Name.
   * <br> vpeBw肵āAvpeBt@C̒l擾B
   * <br> Y閼OȂꍇ́A<b>null</b>߂܂B
   * <br> <b>Properties class</b>  <b>getProperty</b> Ăяo܂B
   *
   * @see java.util.Properties
   * @param argName a <code>String</code> :
   * @return a <code>String</code> :
   */
  public String getPropertyByName(String argName) {
    return property.getProperty(argName);
  }

  /**
   * Describe <code>init</code> method : clear & get properties file.
   * <br>ێ̈AvpeBt@CǂݍށB
   */
  public void init() {
    getProperties();
  }

  //--------------------------------------------------------------------
  //      private Methods
  //--------------------------------------------------------------------

  /**
   * Describe <code>getProperties</code> method : get properties file.
   * <br><b>propertis File</b> eݒ擾B
   * <br>ݒt@C̓Ǎ "AppLogOut.properties" łB
   */
  private void getProperties() {
    property = new Properties();
    InputStream is = this.getClass().getClassLoader().getResourceAsStream(FLNAME);
    File fl = null;    
    try {
      if (is == null) {
        fl = new File(FLNAME);
        is = new FileInputStream(fl.getAbsolutePath());
      }
      property.load(is);
      is.close();
    } catch (FileNotFoundException ffe) {
      System.out.println("w肳ꂽ properties File [" + fl.getAbsolutePath() +
                         "] ݂܂Blgp܂B");
    } catch (Exception fex) {
      System.out.println("properties File̎擾Ɏs܂B\n" + 
                         fex.getMessage() +
                         "\nlgp܂B");
    }

    String bpath = ServletUtils.whichFile("/");
    String lpath = property.getProperty("LogOutPath");
    if (lpath == null || lpath.length() == 0) {
      property.setProperty("LogOutPath", bpath);
    } else {
      StringBuilder ps = new StringBuilder();
      ps.append(bpath);
      if (lpath.length() > 0 && lpath.charAt(0) == File.separatorChar) lpath = lpath.substring(1);
      ps.append(lpath);
      if (lpath.length() > 0 && lpath.charAt(lpath.length() -1) != File.separatorChar) ps.append(File.separator);
      property.setProperty("LogOutPath", ps.toString());
    }
    if (property.getProperty("LogOutName") == null) {
      property.setProperty("LogOutName", "ApplicationLog");
    }
    if (property.getProperty("LogLineCount") == null) {
      property.setProperty("LogLineCount", "5000");
    }
    if (property.getProperty("LogOutLevel") == null) {
      property.setProperty("LogOutLevel", "debug");
    }
    if (property.getProperty("SystemOut") == null) {
      property.setProperty("SystemOut", "Yes");
    }
  }

}
