package com.hamaf.hikyaku.plugIn;

import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.containar.DiFactory;
import com.hamaf.hikyaku.distribute.ServletUtils;
import com.hamaf.hikyaku.plugIn.access.PluginAccess;
import com.hamaf.hikyaku.plugIn.access.VReserveSessionAccess;
import com.hamaf.hikyaku.plugIn.dto.PluginInfDto;
import com.hamaf.hikyaku.plugIn.dto.VReserveSessionSearchDto;

/**
 * <p>^CgFPlugInUtils is plugIn process utilities.</p>
 * <p>FvOCpbP[Wp̊e탆[eBeB</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/01/20</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PlugInUtils {

  /**
   * BASE_DIR a <code>String</code> : vOCݒupX
   */
  public static final String BASE_DIR = "/plugins";

  private static List<String> _pplist = null;

  /**
   * Describe <code>setControlXml</code> method : setting control xml.
   * <br>w肳ꂽvOC̐XMLݒ肷B
   *
   * @param pluginId a <code>String</code> : vOCID
   * @throws Exception
   */
  public static final void setControlXml(String pluginId) throws Exception {
    PluginAccess dta = new PluginAccess();
    PluginInfDto psd = new PluginInfDto();
    psd.setItemValue(PluginInfDto.PLUGIN_ID, pluginId);
    psd.setRequestItem(PluginInfDto.CONTROL_XML_PASS);
    psd.setRequestItem(PluginInfDto.RESET_XML);
    psd.setRequestItem(PluginInfDto.DI_CLASS);
    psd.setRequestItem(PluginInfDto.DI_FILE);
    psd.setAllRequest();
    dta.findByPrimaryKey(psd);
    if (psd.isNotFound()) throw new IllegalArgumentException("PlugIn (" + pluginId + ")");

    ServletUtils.setControl(pluginId, psd.getItemValue(PluginInfDto.CONTROL_XML_PASS),
                            psd.getItemValue(PluginInfDto.RESET_XML));

    DiFactory dif = DiFactory.getInstance();
    String fl = psd.getItemValue(PluginInfDto.DI_FILE);
    String cls = psd.getItemValue(PluginInfDto.DI_CLASS);
    if ((fl != null && fl.length() > 0) || (cls != null && cls.length() > 0)) {
      dif.setContainar(cls, fl, pluginId);
    }

    dta = null;
    psd = null;
  }

  /**
   * Describe <code>clearPplist</code> method : .
   * <br>ZbVۑXgNAB
   */
  public static void clearPplist() {
    _pplist = null;
  }

  /**
   * Describe <code>getPplist</code> method : .
   * <br>ZbVۑ "PluginId_ProcessID" ̃Xg߂B
   *
   * @return a <code>List&lt;String&gt;</code> : ZbVۑ郊Xg
   */
  public static List<String> getPplist() {
    if (_pplist != null) return _pplist;

    VReserveSessionAccess vrsa = new VReserveSessionAccess();
    VReserveSessionSearchDto vrssd = new VReserveSessionSearchDto();
    try {
      vrssd = (VReserveSessionSearchDto)vrsa.find(vrssd);
    }
    catch (Exception ex) {
      ex.printStackTrace();
      return new ArrayList<String>();
    }
    _pplist = new ArrayList<String>();
    for (List<String> keys : vrssd) {
      _pplist.add(keys.get(0));
    }
    return _pplist;
  }
}
