package com.hamaf.hikyaku.plugIn.process;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.plugIn.access.InitAccess;
import com.hamaf.hikyaku.plugIn.access.ViewInitAccess;
import com.hamaf.hikyaku.plugIn.dto.InitDto;
import com.hamaf.hikyaku.plugIn.dto.VInitDto;
import com.hamaf.hikyaku.plugIn.dto.VInitSearchDto;
import com.hamaf.hikyaku.plugIn.ui.InitDispCreate.INIT_ITEMS;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.access.PossibleAccess.POSS_KUBUN;
import com.hamaf.hikyaku.security.dto.UserDto;

/**
 * <p>^CgFInitInfAcquisition is .</p>
 * <p>Fʕ\񏈗</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/02/22</p>
 * @author Yoshinori
 * @version 1.0
 */
public class InitInfAcquisition {
	
	private ViewInitAccess _via;
	private InitAccess _ia;

	/**
	 *  Creates a new <code>InitViewAcquisition.java</code> instance.
	 * <br>Default Constructor
	 */
	public InitInfAcquisition(InitAccess ia, ViewInitAccess via) {
		_ia = ia;
		_via = via;
	}
	
	/**
	 * Describe <code>find</code> method : .
	 * <br>ViewB
	 * <br>
	 * @param visd a <code>VInitSearchDto</code> : 
	 * @throws Exception
	 * @return a <code>VInitSearchDto</code> : 
	 */
	public VInitSearchDto find(VInitSearchDto visd) throws Exception {
		return (VInitSearchDto)_via.find(visd);
	}
	
	/**
	 * Describe <code>findByPrimarykey</code> method : .
	 * <br>ʃr[̏ڍ׏擾B
	 * <br>
	 * @param vid a <code>VInitDto</code> :
	 * @throws Exception
	 * @return a <code>VInitDto</code> : 
	 */
	public VInitDto findByPrimarykey(VInitDto vid) throws Exception {
		return (VInitDto)_via.findByPrimaryKey(vid);
	}
	
	/**
	 * Describe <code>update</code> method : .
	 * <br>ʃe[uXVB
	 * <br>
	 * @param idt a <code>InitDto</code> : 
	 * @throws Exception
	 */
	public void update(InitDto idt) throws Exception {
		_ia.update(idt);
	}

	/**
	 * Describe <code>getCenterDsp</code> method : .
	 * <br>ɕ\鏉ʏ擾B
	 * 
	 * @return a <code>List<Map<String,String>></code> : 
	 * @throws Exception
	 */
	public List<Map<String, String>> getCenterDsp(UserDto ud) throws Exception {
	  VInitSearchDto visd = new VInitSearchDto();
	  visd.setRetrieveValue(VInitSearchDto.POSITION, "C");
	  return getDspInf(visd, ud);
	}
	
  /**
   * Describe <code>getCenterDsp</code> method : .
   * <br>Eɕ\鏉ʏ擾B
   * 
   * @return a <code>List<Map<String,String>></code> : 
   * @throws Exception
   */
  public List<Map<String, String>> getRightDsp(UserDto ud) throws Exception {
    VInitSearchDto visd = new VInitSearchDto();
    visd.setRetrieveValue(VInitSearchDto.POSITION, "R");
    return getDspInf(visd, ud);
  }
  
	private List<Map<String, String>> getDspInf(VInitSearchDto visd, UserDto ud) throws Exception {
    SecurityCheckUtils scu = new SecurityCheckUtils();
	  List<Map<String, String>> ret = new ArrayList<Map<String,String>>();
    visd.setRetrieveValue(VInitSearchDto.USE_FLG, "1");
    visd.setOrderItem(VInitSearchDto.SEQ, 1);
    visd.setOrderItem(VInitSearchDto.PLUGIN_ID, 2);
    visd.setOrderItem(VInitSearchDto.INIT_ID, 3);
    visd = find(visd);
    for (List<String> keys : visd.getKeys()) {
      VInitDto vid = new VInitDto();
      vid.setAllRequest();
      vid.setItemValue(VInitDto.PLUGIN_ID, keys.get(0));
      vid.setItemValue(VInitDto.INIT_ID, keys.get(1));
      vid = findByPrimarykey(vid);
      if (!vid.isNotFound()) {
        if (scu.checkPossible(POSS_KUBUN.IDSP, vid.getItemValue(VInitDto.PLUGIN_ID),
            vid.getItemValue(VInitDto.INIT_ID), ud)) {
          Map<String, String> dt = new HashMap<String, String>();
          INIT_ITEMS[] items = INIT_ITEMS.values();
          for (int i = 0; i < items.length; i++) {
            String val = vid.getItemValue(items[i].getVal());
            if (items[i] == INIT_ITEMS.opt && val.length() > 0) {
              if (!val.startsWith("&")) val = "&" + val;
            }
            dt.put(items[i].name(), val);
          }
          ret.add(dt);
        }
      }
    }
    return ret;
	}
}
