package com.hamaf.hikyaku.plugIn.process;

import java.util.HashMap;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.PreparedItems;
import com.hamaf.hikyaku.plugIn.PlugInUtils;
import com.hamaf.hikyaku.plugIn.access.InitAccess;
import com.hamaf.hikyaku.plugIn.access.MenuAccess;
import com.hamaf.hikyaku.plugIn.access.PluginAccess;
import com.hamaf.hikyaku.plugIn.access.RetrieveAccess;
import com.hamaf.hikyaku.plugIn.access.SqlExec;
import com.hamaf.hikyaku.plugIn.dto.InfoXml;
import com.hamaf.hikyaku.plugIn.dto.InitDto;
import com.hamaf.hikyaku.plugIn.dto.MenuDto;
import com.hamaf.hikyaku.plugIn.dto.PluginInfDto;
import com.hamaf.hikyaku.plugIn.dto.RetrieveDto;
import com.hamaf.hikyaku.plugIn.dto.InfoXml.INIT_TAG;
import com.hamaf.hikyaku.plugIn.dto.InfoXml.MENU_TAG;
import com.hamaf.hikyaku.plugIn.dto.InfoXml.RETRIEVE_TAG;
import com.hamaf.hikyaku.security.access.PossibleAccess;
import com.hamaf.hikyaku.security.access.PossibleAccess.POSS_KUBUN;
import com.hamaf.hikyaku.security.access.PossibleAccess.POSS_TARGET;
import com.hamaf.hikyaku.security.dto.PossibleDto;


/**
 * <p>^CgFRegisterPlugIn.</p>
 * <p>FvOC̓o^</p>
 * <br>ȉ̃e[uɃvOCo^
 * <ol>
 *   <li>M_PLUGIN : vOC{
 * </ol>
 *
 * <p>쌠: Copyright (c) 2010/01/25</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class RegisterPlugIn {

  private PluginAccess _pa = null;
  private MenuAccess _ma = null;
  private InitAccess _ia = null;
  private SqlExec _se = null;
  private PossibleAccess _ps = null;
  private RetrieveAccess _ra = null;

  /**
   *  Creates a new <code>RegisterPlugIn.java</code> instance.
   * <br>Default Constructor
   */
  public RegisterPlugIn(PluginAccess pa, MenuAccess ma, InitAccess ia,
      SqlExec se, PossibleAccess ps, RetrieveAccess ra) {
    _pa = pa;
    _ma = ma;
    _ia = ia;
    _se = se;
    _ps = ps;
    _ra = ra;
  }

  public void register(PluginInfDto pid, String xmlpass) throws Exception {
    registerMaster(pid);
    InfoXml ix = new InfoXml();
    ix.setXml(xmlpass);
    registerMenu(ix, pid.getItemValue(PluginInfDto.PLUGIN_ID));
    registerInit(ix, pid.getItemValue(PluginInfDto.PLUGIN_ID));
    registerRetrieve(ix, pid.getItemValue(PluginInfDto.PLUGIN_ID));
    PlugInUtils.clearPplist();
  }
  private void registerMaster(PluginInfDto pid) throws Exception {
    _pa.regist(pid);
  }
  private final String MENU_KBN = "P";
  private void registerMenu(InfoXml ix, String pid) throws Exception {
		int max = ix.getMenuCount();
		for (int i = 0; i < max; i++) {
			MenuDto md = new MenuDto();
			md.setItemValue(MenuDto.KUBUN, MENU_KBN);
			md.setItemValue(MenuDto.PLUGIN_ID, pid);
			md.setItemValue(MenuDto.MENU_ID, ix.getMenuVal(MENU_TAG.ID, i+1));
			md.setItemValue(MenuDto.DISPLAY, ix.getMenuVal(MENU_TAG.DISP, i+1));
			md.setItemValue(MenuDto.PROCESS, ix.getMenuVal(MENU_TAG.PROC, i+1));
			md.setItemValue(MenuDto.ACTION, ix.getMenuVal(MENU_TAG.ACT, i+1));
      md.setItemValue(MenuDto.TARGET, ix.getMenuVal(MENU_TAG.TGT, i+1));
			_ma.regist(md);
			registerPossible(POSS_KUBUN.MENU, pid, ix.getMenuVal(MENU_TAG.ID, i+1));
		}
	}
  private void registerInit(InfoXml ix, String pid) throws Exception {
		int max = ix.getInitCount();
		for (int i = 0; i < max; i++) {
			InitDto md = new InitDto();
			md.setItemValue(InitDto.PLUGIN_ID, pid);
			md.setItemValue(InitDto.INIT_ID, ix.getInitVal(INIT_TAG.ID, i+1));
			md.setItemValue(InitDto.DISPLAY, ix.getInitVal(INIT_TAG.DISP, i+1));
			md.setItemValue(InitDto.PROCESS, ix.getInitVal(INIT_TAG.PROC, i+1));
			md.setItemValue(InitDto.ACTION, ix.getInitVal(INIT_TAG.ACT, i+1));
      md.setItemValue(InitDto.ADD_OPTION, ix.getInitVal(INIT_TAG.OPT, i+1));
      md.setItemValue(InitDto.USE_FLG, "0");
      _ia.regist(md);
      registerPossible(POSS_KUBUN.IDSP, pid, ix.getInitVal(INIT_TAG.ID, i+1));
		}
	}
  private void registerRetrieve(InfoXml ix, String pid) throws Exception {
    int max = ix.getRetrieveCount();
    for (int i = 0; i < max; i++) {
      RetrieveDto rd = new RetrieveDto();
      rd.setItemValue(RetrieveDto.PLUGIN_ID, pid);
      rd.setItemValue(RetrieveDto.RETRIEVE_ID, ix.getRetrieveVal(RETRIEVE_TAG.ID, i+1));
      rd.setItemValue(RetrieveDto.DISPLAY, ix.getRetrieveVal(RETRIEVE_TAG.DISP, i+1));
      rd.setItemValue(RetrieveDto.PROCESS, ix.getRetrieveVal(RETRIEVE_TAG.PROC, i+1));
      rd.setItemValue(RetrieveDto.ACTION, ix.getRetrieveVal(RETRIEVE_TAG.ACT, i+1));
      rd.setItemValue(RetrieveDto.ADD_OPTION, ix.getRetrieveVal(RETRIEVE_TAG.OPT, i+1));
      rd.setItemValue(RetrieveDto.USE_FLG, "1");
      _ra.regist(rd);
      registerPossible(POSS_KUBUN.SEARCH, pid, ix.getRetrieveVal(RETRIEVE_TAG.ID, i+1));
    }
  }
  private void registerPossible(POSS_KUBUN kbn, String pid, String val) throws Exception {
    PossibleDto pd = new PossibleDto();
    pd.setItemValue(PossibleDto.PLUGIN_ID, pid);
    pd.setItemValue(PossibleDto.KUBUN, kbn.getVal());
    pd.setItemValue(PossibleDto.KEY_ITEM, val);
    pd.setItemValue(PossibleDto.TARGET_KUBUN, POSS_TARGET.ALL.getVal());
    _ps.regist(pd);
  }

  public void delete(PluginInfDto pid) throws Exception {
    deleteMaster(pid);
    deleteMenu(pid.getItemValue(PluginInfDto.PLUGIN_ID));
    deleteInit(pid.getItemValue(PluginInfDto.PLUGIN_ID));
    deleteRetrieve(pid.getItemValue(PluginInfDto.PLUGIN_ID));
    deletePossible(pid.getItemValue(PluginInfDto.PLUGIN_ID));
    PlugInUtils.clearPplist();
  }
  private void deleteMaster(PluginInfDto pid) throws Exception {
    _pa.delete(pid);
  }
  private void deleteMenu(String pid) throws Exception {
  	PreparedItems pi = new PreparedItems();
    pi.setSysId(pid);
    Map<String, Object> pm = new HashMap<String, Object>();
    pm.put("PLGID", pid);
    pi.addParam(pm);
    _se.delMenu(pi);
  }
  private void deleteInit(String pid) throws Exception {
  	PreparedItems pi = new PreparedItems();
    pi.setSysId(pid);
    Map<String, Object> pm = new HashMap<String, Object>();
    pm.put("PLGID", pid);
    pi.addParam(pm);
    _se.delInit(pi);
  }
  private void deleteRetrieve(String pid) throws Exception {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(pid);
    Map<String, Object> pm = new HashMap<String, Object>();
    pm.put("PLGID", pid);
    pi.addParam(pm);
    _se.delRetrieve(pi);
  }
  private void deletePossible(String pid) throws Exception {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(pid);
    Map<String, Object> pm = new HashMap<String, Object>();
    pm.put("PLGID", pid);
    pi.addParam(pm);
    _se.delPossible(pi);
  }
}
