package com.hamaf.hikyaku.plugIn.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.plugIn.dto.PluginInfDto;
import com.hamaf.hikyaku.plugIn.dto.PluginSearchDto;
import com.hamaf.hikyaku.plugIn.process.PluginInfoAcquisition;
import com.hamaf.hikyaku.plugIn.ui.mapping.PluginInfMap;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFExistSearch is .</p>
 * <p>F</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/02/08</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ExistSearch extends StandardListProcess {

  private PluginInfoAcquisition _pa = null;
  /**
   *  Creates a new <code>ExistSearch.java</code> instance.
   * <br>Default Constructor
   */
  public ExistSearch(PluginInfMap pim, PluginInfoAcquisition pa) {
    _jim = pim;
    _pa = pa;
  }

  private final String PLGID = "pldid";
  private final String MSEQ = "mseq";
  private final String UPDT = "update";
  private final String UPSEQMSG = "UpdateMSeqMsg";
  /* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.ListProcessBase#spareAction(com.hamaf.hikyaku.dataobject.CommonMessage, java.lang.String)
	 */
	@Override
	protected CommonMessage spareAction(CommonMessage msg, String act)
			throws Exception {
		if (!"yes".equals(msg.getReqStr(UPDT))) return super.spareAction(msg, act);
		
		for (int i = 0; i < _keys.getDataCount(); i++) {
			String pid = msg.getReqStr(PLGID + i);
			String msq = msg.getReqStr(MSEQ + i);
			if (msq.length() == 0) msq = "0";
			try {
				_pa.updateMenuSeq(pid, Integer.parseInt(msq));
			} catch (Exception ex) { }
		}
		msg.addMessage(resource.getString(UPSEQMSG));
		return super.spareAction(msg, act);
	}

	/* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _pa.findByPrimary((PluginInfDto)dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    return null;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _pa.find((PluginSearchDto)rki);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new PluginInfDto();
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    PluginSearchDto psd = new PluginSearchDto();
    psd.setCondition(PluginSearchDto.DISPLAY_NAME, "LIKE");
    psd.setRetrieveValue(PluginSearchDto.DISPLAY_NAME, keyl.getRetrieve("displayname"));
    return psd;
  }

}
