package com.hamaf.hikyaku.report.excel2003;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import javax.xml.xpath.XPathExpression;

/**
 * <p>^CgF ExcelRow is Excel row object.</p>
 * <p>FGNZ̍s(Row)B</p>
 * <br>ȉ̋@\񋟂B
 * <ol>
 *   <li>init(Document, String, int) : ݒiVK쐬pj
 *   <li>init(Element) : ݒi̍sf[^j
 *   <li>getColumnCount : s߂
 *   <li>getValue : Z̒l擾
 *   <li>setValues : s̊eZɒlݒ肷
 *   <li>setStyle : w͈͂̃Zɑݒ肷
 *   <li>getRow : sGg߂
 * </ol>
 *
 *
 * <p>Created: Tue Nov 25 17:48:47 2008</p>
 * @author y-hamanaka - <i>Hamanaka</i>
 * @version 1.0
 */
public class ExcelRow {
  
  private Document _doc = null;
  private Element _row = null;
  private XPath _xp = null;
  private XPathExpression _getCell = null;

  private static final String IDX = "ss:Index";
  private static final String MRG = "ss:MergeAcross";

  public ExcelRow() {
    _xp = XPathFactory.newInstance().newXPath();
    try {
      _getCell = _xp.compile("Cell");
    } catch (Exception xe) {
      xe.printStackTrace();
    }
  }
  
  /**
   * Describe <code>init</code> method : initialize.
   * <br>sGg̏ݒs
   *
   * @param doc a <code>Document</code> : 
   * @param hight a <code>String</code> : Ƃ̍il̏ꍇA̕""j 
   * @exception Exception if an error occurs
   */
  public void init(Document doc, String hight) throws Exception {
    _doc = doc;
    _row = _doc.createElement("Row");
    _row.setAttribute("ss:AutoFitHeight", "0");
    if (hight != null && hight.length() > 0) {
      _row.setAttribute("ss:Height", hight);
    }
  }

  /**
   * Describe <code>init</code> method : set row element.
   * <br>̍sGgێ
   *
   * @param row an <code>Element</code> : s(Row)Gg
   */
  public void init(Element row) throws Exception {
    _doc = row.getOwnerDocument();
    _row = row;
    checkCell();
  }
  private void checkCell() throws Exception {
    NodeList ndl = (NodeList)_getCell.evaluate(_row, XPathConstants.NODESET);
    int p = 0;
    for (int i = 0; i < ndl.getLength(); i++) {
      p++;
      Element cell = (Element)ndl.item(i);
      String sln = cell.getAttribute(IDX);
      if (sln.length() > 0) {
        int ix = Integer.parseInt(sln);
        for (int j = p; j < ix; j++) {
          Element ncell = _doc.createElement("Cell");
          _row.insertBefore(ncell, cell);
          p++;
        }
        cell.removeAttribute(IDX);
      }
      String mrg = cell.getAttribute(MRG);
      if (mrg.length() > 0) {
        try {
          int mp = Integer.parseInt(mrg);
          p += mp;
        } catch (Exception ex) { }
      }
    }
  }

  /**
   * Describe <code>getColumnCount</code> method : get column count.
   * <br>J߂
   *
   * @return an <code>int</code> : J
   */
  public int getColumnCount() {
    try {
      NodeList ndl = (NodeList)_getCell.evaluate(_row, XPathConstants.NODESET);
      return ndl.getLength();
    } catch (Exception xe) {
      xe.printStackTrace();
    }
    return 0;
  }
  
  /**
   * Describe <code>getValue</code> method : get cell value.
   * <br>w肳ꂽ̒l擾
   *
   * @param col an <code>int</code> : l擾
   * @return a <code>String</code> : 擾l̕
   */
  public String getValue(int col) {
    try {
      return _xp.evaluate("Cell[" + col + "]/Data", _row);
    } catch (Exception xe) {
      xe.printStackTrace();
    }
    return "";
  }
    
  /**
   * Describe <code>setValues</code> method : set cell values.
   * <br>̍sɂZ̒lݒ肷
   * <br>l͊eZƂ̒lXgɐݒ肵Ďw肷
   * <br>ݒ\Ȓl̃NX͈ȉɂȂ܂
   * <ol>
   *  <li>CharSequenceNX : String,StringBuffer,StringBuilder ...
   *  <li>NumberNX : Short,Integer,Long,Float,Double ...
   *  <li>Date,CalendarNX
   * </ol>
   *
   * @param vals a <code>List&lt;Object&gt;</code> : lݒ肵Xg
   * @param str an <code>int</code> : VK쐬̂݁AݒJnʒu
   * @exception Exception if an error occurs
   */
  public void setValues(List<Object> vals, int str) throws Exception {
    if (str < 1) str = 1;
    int max = getColumnCount();
    for (int p = max + 1; p < str; p++) {
      addCell(null);
    }
    
    for (int p = 0; p < vals.size(); p++) {
      int pos = str + p;
      if (pos <= max) {
        changeVal(pos, vals.get(p));
      } else {
        addCell(vals.get(p));
      }
    }
  }

  private static final String STYID = "ss:StyleID";
  /**
   * Describe <code>setStyle</code> method : w肳ꂽ͈͂CellɃX^Cݒ肷.
   *
   * @param styId a <code>String</code> : X^Cl
   * @param str an <code>int</code> : Jnʒu
   * @param end an <code>int</code> : Iʒu
   * @exception Exception if an error occurs
   */
  public void setStyle(String styId, int str, int end) throws Exception {
    for (int p = str; p <= end; p++) {
      Element cell = (Element)_xp.evaluate("Cell[" + p + "]",
                                           _row, XPathConstants.NODE);
      if (cell != null) {
        if (cell.hasAttribute(STYID)) {
          cell.removeAttribute(STYID);
        }
        cell.setAttribute(STYID, styId);
      }
    }
  }
  
  private static final String STY_ID = "ss:StyleID";
  private void changeVal(int pos, Object val) throws Exception {
    String[] dt = checkVal(val);
    Element cell = (Element)_xp.evaluate("Cell[" + pos + "]",
                                         _row, XPathConstants.NODE);
    if (cell.hasChildNodes()) {
      Node data = cell.getFirstChild();
      if (dt[1] == null) {
        cell.removeChild(data);
      } else {
        data.replaceChild(_doc.createTextNode(dt[1]),
            data.getFirstChild());
      }
    } else {
      if (dt[1] == null) return;
      if (TYP_DATE.equals(dt[0]) && cell.getAttribute(STY_ID).length() == 0) {
        cell.setAttribute(STY_ID, ExcelDoc.STYL_DATE);
      }
      Element data = _doc.createElement("Data");
      data.setAttribute("ss:Type", dt[0]);
      data.appendChild(_doc.createTextNode(dt[1]));
      cell.appendChild(data);
    }
  }
  private void addCell(Object val) throws Exception {
    Element cell = _doc.createElement("Cell");
    if (val != null) {
      String[] dt = checkVal(val);
      if (TYP_DATE.equals(dt[0])) {
        cell.setAttribute(STY_ID, ExcelDoc.STYL_DATE);
      }
      Element data = _doc.createElement("Data");
      data.setAttribute("ss:Type", dt[0]);
      data.appendChild(_doc.createTextNode(dt[1]));
      cell.appendChild(data);
    }
    _row.appendChild(cell);
  }
  private static final String TYP_DEF = "String";
  private static final String TYP_NUM = "Number";
  private static final String TYP_DATE = "DateTime";
  private String[] checkVal(Object val) {
    String[] ret = new String[2];
    ret[0] = TYP_DEF;
    if (val == null) {
      ret[1] = null;
      return ret;
    }
    ret[1] = val.toString();
    if (val instanceof Number) {
      ret[0] = TYP_NUM;
    } else if (val instanceof Date ||
               val instanceof Calendar) {
      ret[0] = TYP_DATE;
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS");
      if (val instanceof Calendar) {
        ret[1] = df.format(((Calendar)val).getTime());
      } else {
        ret[1] = df.format((Date)val);
      }
    }
    return ret;
  }

  /**
   * Gets the value of row
   *
   * @return the value of row
   */
  public final Element getRow() {
    return this._row;
  }

}
