package com.hamaf.hikyaku.report.excel2003;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * <p>^CgF ExcelStyle is Excel Style Object.</p>
 * <p>FExcel̃Z̃X^CɑΉIuWFNgB</p>
 * <br>ȉ̋@\񋟂B
 * <ol>
 *   <li>setLine : rݒ肷
 *   <li>setHorizontalAlignment : ̔zuݒ肷
 *   <li>setVerticalAlignment : c̔zuݒ肷
 *   <li>setBackColor : Z̐Fݒ肷
 *   <li>setFontColor : ̐Fݒ肷
 *   <li>setFontStyle : ̌`ݒ肷
 *   <li>setFontName : ̃tHgݒ肷
 *   <li>setFontSize : TCYݒ肷
 *   <li>setWrapText : u܂Ԃĕ\vɐݒ肷
 *   <li>setShrinkToFit : ukĕ\vɐݒ肷
 *   <li>setNumberFormat : lAt̕\`ݒ肷
 *   <li>getStyle : X^CEGg߂
 * </ol>
 *
 * <p>Created: Wed Dec 03 15:12:33 2008</p>
 * @author y-hamanaka - <i>hamanaka</i>
 * @version 1.0
 */
public class ExcelStyle {

  public enum POSITION {Top, Bottom, Right, Left};
  public enum LINE_STYLE {
    Single("Continuous", "1"),
    Bould("Continuous", "2"),
    Double("Double", "3");
    private String _type = null;
    private String _weight = null;
    LINE_STYLE(String type, String weight) {
      _type = type;
      _weight = weight;
    }
    public String getType() {
      return _type;
    }
    public String getWeight() {
      return _weight;
    }
  };
  public enum ALIGNMENT {Center, Right, Left, Top, Bottom, Justify, Distributed};
  public enum FONT_STYLE {Bold, Italic, Underline, StrikeThrough};
  
  private Document _doc = null;
  private LINE_STYLE _top = null;
  private LINE_STYLE _bot = null;
  private LINE_STYLE _lft = null;
  private LINE_STYLE _rit = null;
  private ALIGNMENT _horizontal = null;
  private ALIGNMENT _vertical = null;
  private String _backCor = null;
  private String _fontCor = null;
  private FONT_STYLE _fst = null;
  private String _font = "lr oSVbN";
  private String _size = "11";
  private boolean _wrap = false;
  private boolean _fit = false;
  private String _num = null;

  public ExcelStyle(Document doc) {
    _doc = doc;
  }

  /**
   * Describe <code>setLine</code> method : set line style.
   * <br>r̃X^Cݒ肷
   *
   * @param pos a <code>POSITION</code> : 
   * @param style a <code>LINE_STYLE</code> : 
   */
  public void setLine(POSITION pos, LINE_STYLE style) {
    switch (pos) {
      case Top :
        _top = style;
        break;
      case Bottom :
        _bot = style;
        break;
      case Right :
        _rit = style;
        break;
      case Left :
        _lft = style;
        break;
    default:
      break;
    }
  }

  /**
   * Describe <code>setHorizontalAlignment</code> method : ̔zuݒ肷.
   *
   * @param align an <code>ALIGNMENT</code> : 
   */
  public void setHorizontalAlignment(ALIGNMENT align) {
    _horizontal = align;
  }
  /**
   * Describe <code>setVerticalAlignment</code> method : c̔zuݒ肷.
   *
   * @param align an <code>ALIGNMENT</code> : 
   */
  public void setVerticalAlignment(ALIGNMENT align) {
    _vertical = align;
  }
  /**
   * Describe <code>setBackColor</code> method : Z̐Fݒ肷.
   *
   * @param color a <code>String</code> : RGBԍ(#0000FF(),#008000 )
   */
  public void setBackColor(String color) {
    _backCor = color;
  }
  /**
   * Describe <code>setFontColor</code> method : ̐Fݒ肷.
   *
   * @param color a <code>String</code> : RGBԍ(#0000FF(),#008000 )
   */
  public void setFontColor(String color) {
    _fontCor = color;
  }
  /**
   * Describe <code>setFontStyle</code> method : ̃X^Cݒ肷.
   *
   * @param fst a <code>FONT_STYLE</code> : 
   */
  public void setFontStyle(FONT_STYLE fst) {
    _fst = fst;
  }
  /**
   * Describe <code>setFontName</code> method : tHgݒ肷.
   *
   * @param fname a <code>String</code> : "lr oSVbN","lr o" Ȃ
   */
  public void setFontName(String fname) {
    if (fname != null) {
      _font = fname;
    }
  }
  /**
   * Describe <code>setFontSize</code> method : TCYݒ肷.
   *
   * @param size a <code>String</code> : 
   */
  public void setFontSize(String size) {
    if (size != null) {
      _size = size;
    }
  }
  /**
   * Describe <code>setWrapText</code> method : u܂Ԃĕ\vݒ肷.
   *
   * @param val a <code>boolean</code> : 
   */
  public void setWrapText(boolean val) {
    _wrap = val;
  }
  /**
   * Describe <code>setShrinkToFit</code> method : ukĕ\vݒ肷.
   *
   * @param val a <code>boolean</code> : 
   */
  public void setShrinkToFit(boolean val) {
    _fit = val;
  }

  /**
   * Describe <code>setNumberFormat</code> method : NumberFormatݒ肷.
   *
   * @param fmt a <code>String</code> : \`
   */
  public void setNumberFormat(String fmt) {
    _num = fmt;
  }
  
  /**
   * Describe <code>getStyle</code> method : X^C̃Gg𐶐.
   *
   * @param id a <code>String</code> : ̃X^CID
   * @return an <code>Element</code> : Style Gg
   * @exception Exception if an error occurs
   */
  public Element getStyle(String id) throws Exception {
    Element style = _doc.createElement("Style");
    style.setAttribute("ss:ID", id);
    Element border = creBorders();
    if (border != null) {
      style.appendChild(border);
    }
    Element font = creFont();
    if (font != null) {
      style.appendChild(font);
    }
    Element align = creAlign();
    if (align != null) {
      style.appendChild(align);
    }
    Element interior = creInterior();
    if (interior != null) {
      style.appendChild(interior);
    }
    Element numfmt = creNumFmt();
    if (numfmt != null) {
      style.appendChild(numfmt);
    }

    return style;
  }

  private Element creNumFmt() throws Exception {
    if (_num == null || _num.length() == 0) {
      return null;
    }
    Element numfmt = _doc.createElement("NumberFormat");
    numfmt.setAttribute("ss:Format", _num);
    return numfmt;
  }
  private Element creInterior() throws Exception {
    if (_backCor == null) {
      return null;
    }
    Element interior = _doc.createElement("Interior");
    interior.setAttribute("ss:Color", _backCor);
    interior.setAttribute("ss:Pattern", "Solid");
    return interior;
  }
  private Element creAlign() throws Exception {
    if (_vertical == null && _horizontal == null && !_wrap && !_fit) {
      return null;
    }
    Element align = _doc.createElement("Alignment");
    if (_vertical != null) {
      align.setAttribute("ss:Vertical", _vertical.name());
    }
    if (_wrap) {
      align.setAttribute("ss:WrapText", "1");
    } else if (_fit) {
      align.setAttribute("ss:ShrinkToFit", "1");
    } else if (_horizontal != null) {
      align.setAttribute("ss:Horizontal", _horizontal.name());
    }
    return align;
  }
  private Element creFont() throws Exception {
    if (_fontCor == null && _fst == null && _font == null && _size == null) {
      return null;
    }
    Element font = _doc.createElement("Font");
    font.setAttribute("ss:FontName", _font);
    font.setAttribute("x:CharSet", "128");
    font.setAttribute("x:Family", "Modern");
    font.setAttribute("ss:Size", _size);
    if (_fontCor != null) {
      font.setAttribute("ss:Color", _fontCor);
    }
    if (_fst != null) {
      String val = "1";
      if (_fst == FONT_STYLE.Underline) {
        val = "Single";
      }
      font.setAttribute(_fst.name(), val);
    }
    return font;
  }
  private Element creBorders() throws Exception {
    if (_top == null && _bot == null && _rit == null && _lft == null) {
      return null;
    }
    Element bdrs = _doc.createElement("Borders");
    if (_top != null) {
      bdrs.appendChild(creBdr(POSITION.Top, _top));
    }
    if (_bot != null) {
      bdrs.appendChild(creBdr(POSITION.Bottom, _bot));
    }
    if (_lft != null) {
      bdrs.appendChild(creBdr(POSITION.Left, _lft));
    }
    if (_rit != null) {
      bdrs.appendChild(creBdr(POSITION.Right, _rit));
    }
    return bdrs;
  }
  private Element creBdr(POSITION pos, LINE_STYLE sty) throws Exception {
    Element bdr = _doc.createElement("Border");
    bdr.setAttribute("ss:Position", pos.name());
    bdr.setAttribute("ss:LineStyle", sty.getType());
    bdr.setAttribute("ss:Weight", sty.getWeight());
    return bdr;
  }
  
}
