package com.hamaf.hikyaku.security;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.PreparedItems;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.security.access.BelongSql;
import com.hamaf.hikyaku.security.access.GroupAccess;
import com.hamaf.hikyaku.security.access.GroupUserSql;
import com.hamaf.hikyaku.security.access.PossibleAccess;
import com.hamaf.hikyaku.security.access.UserAccess;
import com.hamaf.hikyaku.security.access.PossibleAccess.POSS_KUBUN;
import com.hamaf.hikyaku.security.access.PossibleAccess.POSS_TARGET;
import com.hamaf.hikyaku.security.access.UserAccess.USER_TYPE;
import com.hamaf.hikyaku.security.dto.GroupDto;
import com.hamaf.hikyaku.security.dto.PossibleDto;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.dto.UserSearchDto;

/**
 * <p>^CgFSecurityCheckUtils is .</p>
 * <p>FZLeB֌W̃T|[g@\񋟂</p>
 * <br>ȉ̋@\L܂B
 * <ul>
 *   <li> getUserInf : [U[IDŃ[U[擾
 *   <li> getGroupInf : O[vIDŃO[v擾
 *   <li> getUserInGP : O[vɎw肳Ă郆[U[擾
 *   <li> checkPossible : }X^[ɂAp\𔻒肷
 *   <li> getAllChildren : zɑSẴO[v擾
 *   <li> getAllUserInGp : zɑSẴ[U[擾
 *   <li> getAllParents : O[vSẴO[v擾
 *   <li> getGroupByUser : [U[O[v擾
 *   <li> getAllGroupByUser : [U[SẴO[v擾
 *   <li> checkUserInGroup : [U[O[vɑĂ邩`FbN
 * </ul>
 *
 * <p>쌠: Copyright (c) 2010/06/01</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class SecurityCheckUtils {

  /**
   * Describe <code>getUserInf</code> method : .
   * <br>[U[IDŃ[U[擾B
   *
   * @param uid a <code>String</code> : 擾郆[U[ID
   * @param requser a <code>String</code> : v҂̃[U[ID
   * @return a <code>UserDto</code> :
   * @throws Exception
   */
  public UserDto getUserInf(String uid, String requser) throws Exception {
    UserDto ud = new UserDto();
    ud.setItemValue(UserDto.USER_ID, uid);
    ud.setCommFld(COMMFLD.UUSR, requser);
    ud.setAllRequest();
    ud.setSysId(DistributeServlet.SYSID);
    UserAccess ua = new UserAccess();
    return (UserDto)ua.findByPrimaryKey(ud);
  }

  /**
   * Describe <code>getGroupInf</code> method : .
   * <br>O[vIDŃO[v擾B
   *
   * @param gid a <code>String</code> : 擾O[vID
   * @param requser a <code>String</code> : v҂̃[U[ID
   * @return a <code>GroupDto</code> :
   * @throws Exception
   */
  public GroupDto getGroupInf(String gid, String requser) throws Exception {
    GroupDto gd = new GroupDto();
    gd.setItemValue(GroupDto.GROUP_ID, gid);
    gd.setCommFld(COMMFLD.UUSR, requser);
    gd.setAllRequest();
    gd.setSysId(DistributeServlet.SYSID);
    GroupAccess ga = new GroupAccess();
    return (GroupDto)ga.findByPrimaryKey(gd);
  }

  /**
   * Describe <code>checkPossible</code> method : .
   * <br>}X^Ƃɗp\`FbNB
   * <br>Ώێ҂̏ꍇA'^'߂B
   *
   * @param kbn a <code>POSS_KUBUN</code> :
   * @param plgId a <code>String</code> : vOCID
   * @param keyVal a <code>String</code> : ΏۂƂȂL[l
   * @param udt a <code>UserDto</code> :
   * @return a <code>boolean</code> : Ώێ҂̏ꍇAtrue
   */
  public boolean checkPossible(POSS_KUBUN kbn, String plgId, String keyVal, UserDto udt) {
    PossibleDto pd = new PossibleDto();
    PossibleAccess pa = new PossibleAccess();
    pd.setItemValue(PossibleDto.KUBUN, kbn.getVal());
    pd.setItemValue(PossibleDto.PLUGIN_ID, plgId);
    pd.setItemValue(PossibleDto.KEY_ITEM, keyVal);
    pd.setAllRequest();
    pd.setSysId(DistributeServlet.SYSID);
    try {
      pd = (PossibleDto)pa.findByPrimaryKey(pd);
    } catch (Exception xe) {
      xe.printStackTrace();
      return true;
    }
    if (pd.isNotFound()) return true;
    return checkType(pd.getItemValue(PossibleDto.TARGET_KUBUN), udt, pd.getItemValue(PossibleDto.GROUP_ID));
  }
  private boolean checkType(String typ, UserDto udt, String gid) {
    if (typ.equals(POSS_TARGET.ALL.getVal())) return true;
    if (typ.equals(POSS_TARGET.NGEST.getVal())) {
      if (udt.getItemValue(UserDto.USER_TYPE).equals(USER_TYPE.GUEST.getVal())) {
        return false;
      } else {
        return true;
      }
    }
    if (typ.equals(POSS_TARGET.MANAGER.getVal())) {
      if ("1".equals(udt.getItemValue(UserDto.ADMIN_FLG))) {
        return true;
      } else {
        return false;
      }
    }
    if (typ.equals(POSS_TARGET.GROUP.getVal())) {
      return checkUserInAllGroup(udt.getItemValue(UserDto.USER_ID), gid);
    }
    return true;
  }

  /**
   * Describe <code>getAllChildren</code> method : .
   * <br>z̃O[v̑SĂ擾B
   *
   * @param gid a <code>String</code> : O[vID
   * @return a <code>List&lt;String&gt;</code> : z̃O[vSẴO[vID
   * @throws Exception
   */
  public List<String> getAllChildren(String gid) throws Exception {
    List<String> ret = new ArrayList<String>();
    List<String> key = new ArrayList<String>();
    key.add(gid);
    BelongSql bs = new BelongSql();
    while (key.size() >0) {
      PreparedItems pi = createPreAll(key);
      bs.getChildren(pi);
      key.clear();
      for (Map<String, String> dt : pi.getRetVal()) {
        String val = dt.get("BELONG_ID");
        if (gid.indexOf(val) < 0 && !ret.contains(val)) {
          ret.add(val);
          key.add(val);
        }
      }
    }
    return ret;
  }

  /**
   * Describe <code>getUserAll</code> method : .
   * <br>S[ŨXg擾B
   *
   * @return a <code>List&lt;String&gt;</code> : [U[ID̃Xg
   * @throws Exception
   */
  public List<String> getUserAll() throws Exception {
    UserSearchDto usd = new UserSearchDto();
    usd.setRetrieveValue(UserSearchDto.USER_TYPE, "g");
    usd.setSysId(DistributeServlet.SYSID);
    UserAccess ua = new UserAccess();
    usd = (UserSearchDto)ua.find(usd);
    List<String> ret = new ArrayList<String>();
    for (List<String> keys : usd) {
      ret.add(keys.get(0));
    }
    return ret;
  }

  /**
   * Describe <code>getUserInGP</code> method : .
   * <br>O[vɎw肳Ă郆[U[擾B
   *
   * @param gid a <code>String</code> : O[vID
   * @return a <code>List&lt;String&gt;</code> : [U[ID̃Xg
   * @throws Exception
   */
  public List<String> getUserInGP(String gid) throws Exception {
    if (gid == null) gid = "";
    PreparedItems pi = new PreparedItems();
    pi.setSysId(DistributeServlet.SYSID);
    pi.addDelLine("in");
    if (gid.length() == 0) pi.addDelLine("eq");
    Map<String, String> vals = new HashMap<String, String>();
    vals.put("GroupId", gid);
    pi.addParam(vals);
    GroupUserSql gus = new GroupUserSql();
    pi = gus.getUsers(pi);
    List<String> ret = new ArrayList<String>();
    for (Map<String, String> dt : pi.getRetVal()) {
      ret.add(dt.get("USER_ID"));
    }
    return ret;
  }
  /**
   * Describe <code>getUserInGp</code> method : .
   * <br>O[vɎw肳Ă郆[U[擾B
   *
   * @param gid a <code>List&lt;String&gt;</code> : O[vID̃Xg
   * @return a <code>List&lt;String&gt;</code> : [U[ID̃Xg
   * @throws Exception
   */
  public List<String> getUserInGp(List<String> gids) throws Exception {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(DistributeServlet.SYSID);
    pi.addDelLine("eq");
    int j = 0;
    while ( j < gids.size()) {
      Map<String, String> vals = new HashMap<String, String>();
      for (int i = 0; i < 10; i++) {
        String key = "Gid" + i;
        if (gids.size() > j) {
          vals.put(key, gids.get(j));
        } else {
          vals.put(key, "");
        }
        j++;
      }
      pi.addParam(vals);
    }
    GroupUserSql gus = new GroupUserSql();
    pi = gus.getUsers(pi);
    List<String> ret = new ArrayList<String>();
    for (Map<String, String> dt : pi.getRetVal()) {
      ret.add(dt.get("USER_ID"));
    }
    return ret;
  }

  /**
   * Describe <code>getAllUserInGp</code> method : .
   * <br>w肳ꂽO[vƔz̃O[vɑSẴ[U[擾B
   *
   * @param gid a <code>String</code> : O[vID
   * @return a <code>List&lt;String&gt;</code> : SẴ[U[ID
   * @throws Exception
   */
  public List<String> getAllUserInGp(String gid) throws Exception {
    List<String> allgp = getAllChildren(gid);
    PreparedItems pi = createPreAll(allgp);
    GroupUserSql gus = new GroupUserSql();
    pi = gus.getUsers(pi);
    List<String> ret = new ArrayList<String>();
    for (Map<String, String> dt : pi.getRetVal()) {
      ret.add(dt.get("USER_ID"));
    }
    return ret;
  }

  private PreparedItems createPreAll(List<String> gids) {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(DistributeServlet.SYSID);
    pi.addDelLine("eq");
    int j = 0;
    while (j < gids.size()) {
      Map<String, String> vals = new HashMap<String, String>();
      for (int i = 0; i < 10; i++) {
        String key = "GId" + i;
        if (gids.size() > j) {
          vals.put(key, gids.get(j));
        } else {
          vals.put(key, "");
        }
        j++;
      }
      pi.addParam(vals);
    }
    return pi;
  }

  /**
   * Describe <code>getAllParents</code> method : .
   * <br>O[vSĂ̐ẽO[v擾B
   *
   * @param gid a <code>String</code> : O[vID
   * @return a <code>List&lt;String&gt;</code> : 邷SẴO[vID
   * @throws Exception
   */
  public List<String> getAllParents(String gid) throws Exception {
    List<String> ret = new ArrayList<String>();
    List<String> key = new ArrayList<String>();
    key.add(gid);
    BelongSql bs = new BelongSql();
    while (key.size() >0) {
      PreparedItems pi = createPrePar(key);
      bs.getParents(pi);
      key.clear();
      for (Map<String, String> dt : pi.getRetVal()) {
        String val = dt.get("GROUP_ID");
        if (gid.indexOf(val) < 0 && !ret.contains(val)) {
          ret.add(val);
          key.add(val);
        }
      }
    }
    return ret;
  }

  private PreparedItems createPrePar(List<String> gids) {
    PreparedItems pi = new PreparedItems();
    pi.setSysId(DistributeServlet.SYSID);
    pi.addDelLine("eq");
    int j = 0;
    while (j < gids.size()) {
      Map<String, String> vals = new HashMap<String, String>();
      for (int i = 0; i < 10; i++) {
        String key = "BId" + i;
        if (gids.size() > j) {
          vals.put(key, gids.get(j));
        } else {
          vals.put(key, "");
        }
        j++;
      }
      pi.addParam(vals);
    }
    return pi;
  }

  /**
   * Describe <code>getGroupByUser</code> method : .
   * <br>w肵[U[܂ރO[v擾B
   *
   * @param uid a <code>String</code> : [U[ID
   * @return a <code>List&lt;String&gt;</code> : O[ṽXg
   * @throws Exception
   */
  public List<String> getGroupByUser(String uid) throws Exception {
    GroupUserSql gus = new GroupUserSql();
    PreparedItems pi = new PreparedItems();
    pi.setSysId(DistributeServlet.SYSID);
    pi.addDelLine("in");
    Map<String, String> vals = new HashMap<String, String>();
    vals.put("UserId", uid);
    pi.addParam(vals);
    pi = gus.getGroups(pi);
    if (pi.getRetVal().size() == 0) return new ArrayList<String>();

    List<String> ret = new ArrayList<String>();
    for (Map<String, String> dt : pi.getRetVal()) {
      ret.add(dt.get("GROUP_ID"));
    }
    return ret;
  }

  /**
   * Describe <code>getAllGroupByUser</code> method : .
   * <br>ẽO[v܂߃[U[SẴO[v擾B
   *
   * @param uid a <code>String</code> : [U[ID
   * @return a <code>List&lt;String&gt;</code> : O[ṽXg
   * @throws Exception
   */
  public List<String> getAllGroupByUser(String uid) throws Exception {
    GroupUserSql gus = new GroupUserSql();
    PreparedItems pi = new PreparedItems();
    pi.setSysId(DistributeServlet.SYSID);
    pi.addDelLine("in");
    Map<String, String> vals = new HashMap<String, String>();
    vals.put("UserId", uid);
    pi.addParam(vals);
    pi = gus.getGroups(pi);
    if (pi.getRetVal().size() == 0) return new ArrayList<String>();

    List<String> ret = new ArrayList<String>();
    for (Map<String, String> dt : pi.getRetVal()) {
      ret.add(dt.get("GROUP_ID"));
      for (String dtp : getAllParents(dt.get("GROUP_ID"))) {
        if (!ret.contains(dtp)) ret.add(dtp);
      }
    }
    return ret;
  }

  /**
   * Describe <code>checkUserInGroups</code> method : .
   * <br>w肳ꂽ[U[ꂩ̃O[vɑē邩`FbNB
   * <br>݂ꍇA^߂
   *
   * @param uid a <code>String</code> : [U[ID
   * @param groups a <code>List&lt;String&gt;</code> : O[vID̃Xg
   * @return a <code>boolean</code> : ݂ꍇAtrue
   * @return
   */
  public boolean checkUserInGroups(String uid, List<String> groups) {
    if (groups == null || groups.size() == 0 || uid == null || uid.length() == 0) return false;

    try {
      List<String> udt = getUserInGp(groups);
      return udt.contains(uid);
    } catch (Exception xe) {
      xe.printStackTrace();
    }
    return false;
  }

  /**
   * Describe <code>checkUserInAllGroup</code> method : .
   * <br>w肳ꂽ[U[eO[v܂ߊỸO[vɑē邩`FbNB
   * <br>݂ꍇA^߂
   *
   * @param uid a <code>String</code> : [U[ID
   * @param group a <code>String</code> : O[vID
   * @return a <code>boolean</code> : ݂ꍇAtrue
   * @throws Exception
   */
  public boolean checkUserInAllGroup(String uid, String group) {
    try {
      List<String> gdt = getAllGroupByUser(uid);
      return gdt.contains(group);
    } catch (Exception xe) {
      xe.printStackTrace();
    }
    return false;
  }

}
