package com.hamaf.hikyaku.security.access;

import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyaku.security.dto.HatubanDto;

/**
 * <p>^CgFHatubanAccess is .</p>
 * <p>Fԃe[ũANZX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/05/09</p>
 * @author yoshinori
 * @version 1.0
 */
public class HatubanAccess extends DefaultTableAccess {

	public enum HKUBUN {
		GROUP("G", 5, false),
		MESSAGE("M", 7, false);

		private String key;
		private int len;
		private boolean subk;
		HKUBUN(String k, int l, boolean sk) { key = k; len = l; subk = sk;}
		public String getKey() { return key; }
		public int getLen() { return len; }
		public boolean getSubk() { return subk; }

	};

	private final String TBLNM = "M_HATUBAN";

	/**
	 *  Creates a new <code>HatubanAccess.java</code> instance.
	 * <br>Default Constructor
	 */
	public HatubanAccess() {
    tableName = TBLNM;
//    super.setDebug();
	}

	public String getNextNo(HKUBUN kb, String key) throws Exception {
		HatubanDto hd = getHatubanDto(kb, key);
		hd = (HatubanDto)findByPrimaryKey(hd);
		if (hd.isNotFound()) {
			String mno = addNo("0", kb);
			hd.setItemValue(HatubanDto.MAX_NUMBER, mno);
			regist(hd);
			return mno;
		}
		String mno = addNo(hd.getItemValue(HatubanDto.MAX_NUMBER), kb);
		hd.setItemValue(HatubanDto.MAX_NUMBER, mno);
		update(hd);
		return mno;
	}

	private HatubanDto getHatubanDto(HKUBUN kb, String key) {
		HatubanDto hd = new HatubanDto();
		hd.setItemValue(HatubanDto.KUBUN, kb.getKey());
		if (kb.getSubk()) {
			hd.setItemValue(HatubanDto.KEY_VALUE, key);
		} else {
			hd.setItemValue(HatubanDto.KEY_VALUE, "key");
		}
		hd.setAllRequest();
		return hd;
	}

	private String addNo(String no, HKUBUN kb) {
		int len = kb.getLen();
		int ino = Integer.parseInt(no);
		ino++;
		no = String.valueOf(ino);
		if(no.length() > len) {
			return no.substring(no.length() - len);
		}
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < (len - no.length()); i++) {
			sb.append("0");
		}
		sb.append(no);
	  return sb.toString();
	}
}
