package com.hamaf.hikyaku.security.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.security.dto.GroupDto;
import com.hamaf.hikyaku.security.dto.GroupSearchDto;
import com.hamaf.hikyaku.security.process.GroupProcess;
import com.hamaf.hikyaku.security.ui.mapping.GroupInfMap;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFGroupAdd is .</p>
 * <p>FO[vo^pʏ</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/05/11</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class GroupAdd extends StandardCheckAndUpdate {

  private GroupProcess _gp = null;
  /**
   *  Creates a new <code>GroupAdd.java</code> instance.
   * <br>Default Constructor
   */
  public GroupAdd(GroupInfMap gim, GroupProcess gp) {
    _jim = gim;
    _gp = gp;
    _cfld = "GroupChk";
  }

  private final String ERRCD = "WCheckMsg";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#checkMaster(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage checkMaster(CommonMessage msg) throws Exception {
    GroupSearchDto gsd = new GroupSearchDto();
    gsd.setRetrieveValue(GroupSearchDto.GROUP_CODE, msg.getReqStr("gcode"));
    gsd = _gp.find(gsd);
    if (gsd.getKeys().size() > 0) {
      msg.setErrorStatus(STATUS.WARNING);
      msg.setResMsg("gcode", resource.getString(ERRCD));
    }
    return msg;
  }

  private final String ADDOK = "GroupAdd";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _gp.addGroup((GroupDto)dii);
    msg.setResMsg(ADDOK, "1");
    return msg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new GroupDto();
  }

}
