package com.hamaf.hikyaku.security.ui;

import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.process.GroupProcess;
import com.hamaf.hikyaku.tfunc.CommonMessages;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyaku.ui.dto.CommonSelectDto;
import com.hamaf.hikyaku.ui.dto.CommonSelectMapping;
import com.hamaf.hikyaku.ui.dto.CommonSelectSearchDto;

/**
 * <p>^CgFGroupSelect is .</p>
 * <p>Fz̃O[vIp̃O[vꗗ擾</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/05/25</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class GroupSelect extends StandardListProcess {
  
  private GroupProcess _gp = null;

  private String _preLod = null;

  /**
   *  Creates a new <code>GroupSelect.java</code> instance.
   * <br>Default Constructor
   * @param gmp
   * @param gp
   */
  public GroupSelect(GroupProcess gp, CommonSelectMapping csm) {
    _gp = gp;
    _jim = csm;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _gp.findSelectByKey((CommonSelectDto)dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    return null;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    if ("1".equals(_preLod)) {
      return rki;
    }
    return _gp.findSelect((CommonSelectSearchDto)rki);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new CommonSelectDto();
  }

  private final String R_GID = "cond";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    CommonSelectSearchDto cssd = new CommonSelectSearchDto();
    if (keyl.getRetrieve("searchVal").length() > 0) {
      cssd.setRetrieveValue(CommonSelectSearchDto.NM, "%" + keyl.getRetrieve("searchVal") + "%");
      cssd.setCondition(CommonSelectSearchDto.NM, "like");
    }
    String gid = keyl.getRetrieve(R_GID);
    StringBuilder sb = new StringBuilder();
    sb.append("'");
    sb.append(gid);
    sb.append("'");
    SecurityCheckUtils scu = new SecurityCheckUtils();
    try {
      List<String> pgps = scu.getAllParents(gid);
      if (pgps.size() > 0) {
        for (String pgid : pgps) {
          sb.append(",");
          sb.append("'");
          sb.append(pgid);
          sb.append("'");
        }
      }
    } catch (Exception xe) {
      xe.printStackTrace();
//      throw new IllegalRetrieveDataException(xe.getMessage(), keyl.getRetrieveAll());
    }
    cssd.setRetrieveValue(CommonSelectSearchDto.ID, sb.toString());
    cssd.setCondition(CommonSelectSearchDto.ID, "not in");
    return cssd;
  }

  private final String REQKEY = "title";
  private final String M_TTL = "dsptitle";
  private final String M_ACT = "oact";
  private final String ACT = "groupSelect";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ListProcessBase#spareAction(com.hamaf.hikyaku.dataobject.CommonMessage, java.lang.String)
   */
  @Override
  protected CommonMessage spareAction(CommonMessage msg, String act) {
    msg.setResMsg(M_ACT, ACT);
    
    _preLod = msg.getReq("preLoadList");
    String ttl = msg.getReqStr(REQKEY);
    if (ttl.length() > 0) {
      String nttl = CommonMessages.getMsg(ttl);
      if (nttl.length() > 0) msg.setResMsg(M_TTL, nttl);
    }
    return msg;
  }

}
