package com.hamaf.hikyaku.security.ui;

import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.security.access.MessageAccess;
import com.hamaf.hikyaku.security.dto.MessageDto;
import com.hamaf.hikyaku.security.dto.MessageSearchDto;
import com.hamaf.hikyaku.security.process.MessageProcess;
import com.hamaf.hikyaku.security.ui.mapping.MessageMap;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFMessageList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/01/26</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class MessageList extends StandardListProcess {

	 private MessageProcess _mp = null;

	/**
	 * Creates a new <code>MessageList.java</code> instance.
	 * <br>Default Constructor
	 * @param mm
	 * @param mp
	 */
	public MessageList(MessageMap mm, MessageProcess mp) {
		_jim = mm;
		_mp = mp;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
	 */
	@Override
	protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
			throws IllegalRetrieveDataException {
		MessageSearchDto msd = new MessageSearchDto();
		msd.setRetrieveValue(MessageSearchDto.TO_KUBUN, MessageAccess.TO_KUBUN.MANAGER.getVal());
		return msd;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
	 */
	@Override
	protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
			throws Exception {
		return _mp.find((MessageSearchDto)rki);
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new MessageDto();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected DetailItemsInterface callControl(DetailItemsInterface dii)
			throws Exception {
		return _mp.findByPrimarikey((MessageDto)dii);
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected String[] checkDelete(DetailItemsInterface dii) {
    if (delCheck(dii)) {
      String[] ret = {"contents", super.resource.getString("DelLine")};
      return ret;
    }
		return null;
	}

	private final String MSG_DEL = "deldsp";
	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#editItems(com.hamaf.hikyaku.dataobject.DetailItemsInterface, java.util.Map)
	 */
	@Override
	protected Map<String, String> editItems(DetailItemsInterface dii,
			Map<String, String> mp) throws Exception {
		if (!delCheck(dii)) {
			mp.put(MSG_DEL, "1");
		}
		return mp;
	}

}
