package com.hamaf.hikyaku.security.ui;

import java.text.MessageFormat;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFPasswordChangeIni is .</p>
 * <p>F</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/03/24</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class PasswordChangeIni extends ProcessBase {
  
  public static final String MSG_UID = "uid";

  private final String MSG_UNM = "uname";
  
  private final String MX_TAG = "password";
  private final String MX_MIN = "minlength";
  private final String MX_MAX = "maxlength";
  private final String MX_MIX = "mixed";
  private final String MX_PRE = "previous";
  
  private final String MSG_FMT1 = "PwdMsgFormat1";
  private final String MSG_FMT2 = "PwdMsgFormat2";
  private final String MSG_FMT3 = "PwdMsgFormat3";
  private final String MSG_FMT4 = "PwdMsgFormat4";
  private final String MSG_PRE = "PwdMsgPrevious";
  
  private final String COM_FMT = "format";
  private final String COM_PRE = "previous";

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    UserDto ud = (UserDto)session.getAttribute(LogInCheck.USER_INF);
    if (ud == null) {
      msg.setErrorStatus(STATUS.WARNING);
      return msg;
    }
    
    msg.setResMsg(MSG_UID, ud.getItemValue(UserDto.USER_ID));
    msg.setResMsg(MSG_UNM, ud.getItemValue(UserDto.NAME));
    
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    Map<String, String> dt = mxc.getItemValue(MX_TAG, "cd");
    
    StringBuilder sbftm = new StringBuilder();
    String val;
    val = dt.get(MX_MIN);
    if (val == null || val.length() == 0) val = "8";
    Object[] prm1 = {val};
    sbftm.append(MessageFormat.format(resource.getString(MSG_FMT1), prm1));
    val = dt.get(MX_MAX);
    if (val != null && val.length() > 0) {
      Object[] prm2 = {val};
      sbftm.append(MessageFormat.format(resource.getString(MSG_FMT2), prm2));
    }
    val = dt.get(MX_MIX);
    if ("yes".equals(val)) {
      sbftm.append(resource.getString(MSG_FMT3));
    }
    sbftm.append(resource.getString(MSG_FMT4));
    msg.setResMsg(COM_FMT, sbftm.toString());
    
    val = dt.get(MX_PRE);
    if ("yes".equals(val)) {
      msg.setResMsg(COM_PRE, resource.getString(MSG_PRE));
    }
    
    return msg;
  }

}
