package com.hamaf.hikyaku.security.ui;

import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.text.DateFormat;
import java.util.Locale;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.ComUtils;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFTopMessageSave.</p>
 * <p>FgbvʃbZ[W̓o^</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/04/19</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class TopMessageSave extends ProcessBase {

  private final String MSG_KEY = "topmsgmod";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    String emsg = checkKikan(msg);
    if (emsg != null) {
      msg.setErrorStatus(STATUS.WARNING);
      msg.addMessage(emsg);
      return msg;
    }
    
    try {
      wrtMsgFl(msg);
      msg.setResMsg(MSG_KEY, "1");
    } catch (Exception xe) {
      xe.printStackTrace();
      msg.setErrorStatus(STATUS.WARNING);
      msg.addMessage(xe.getMessage());
    }
    return msg;
  }
  
  private final String ERRM_FROM = "TMKikanErrFrom";
  private final String ERRM_TO = "TMKikanErrTo";
  private final String ERRM_TOOV = "TMKikanErrToOver";
  private String checkKikan(CommonMessage msg) {
    String fdt = msg.getReqStr(HeaderMessage.MSGFROM);
    String tdt = msg.getReqStr(HeaderMessage.MSGTO);
    if (checkDate(fdt)) {
      return resource.getString(ERRM_FROM);  
    }
    if (checkDate(tdt)) {
      return resource.getString(ERRM_TO);  
    }
    if (tdt.length() > 0 && tdt.compareTo(fdt) < 0) {
      return resource.getString(ERRM_TOOV);
    }
    return null;
  }
  private boolean checkDate(String item) {
    if (item == null || item.length() == 0) return false;
    Pattern _pt = Pattern.compile("[0-9]{4}/[0-9]{2}/[0-9]{2}");
    Matcher _mt = _pt.matcher(item);
    if (!_mt.matches()) {
      return true;
    }
    DateFormat df = DateFormat.getDateInstance(DateFormat.MEDIUM, Locale.JAPAN);
    df.setLenient(false);
    try {
      df.parse(item);
    } catch (Exception xe) {
      return true;
    }
    return false;
  }
  private void wrtMsgFl(CommonMessage msg) throws Exception {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(DistributeServlet.SYSID);
    String flnm = ComUtils.convPath(mxc.getConstant(HeaderMessage.MX_MFL), false);
    
    BufferedWriter bw = new BufferedWriter(
        new OutputStreamWriter(new FileOutputStream(flnm), "utf-8"));
    
    StringBuilder sb = new StringBuilder();
    String fdt = msg.getReqStr(HeaderMessage.MSGFROM);
    String tdt = msg.getReqStr(HeaderMessage.MSGTO);
    if (fdt.length() == 0) fdt = DateUtil.getDate();
    if (tdt.length() == 0) tdt = "9999/12/31";
    sb.append(fdt);
    sb.append(",");
    sb.append(tdt);
    bw.write(sb.toString());
    bw.newLine();
    bw.write(msg.getReqStr(HeaderMessage.TOPMSG));
    bw.close();
  }

}
