package com.hamaf.hikyaku.security.ui;

import java.text.MessageFormat;
import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.USE_FLG;
import com.hamaf.hikyaku.security.dto.GroupSearchDto;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.dto.VGroupDto;
import com.hamaf.hikyaku.security.process.GroupProcess;
import com.hamaf.hikyaku.security.process.UserProcess;
import com.hamaf.hikyaku.security.ui.mapping.UserInfMap;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFUserDel is .</p>
 * <p>F[U[̍폜pʏ</p>
 * <br>O[v̊Ǘ҂͍폜sƂB
 *
 * <p>쌠: Copyright (c) 2010/05/11</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class UserDel extends StandardCheckAndUpdate {

  private UserProcess _up = null;
  private GroupProcess _gp = null;

  /**
   *  Creates a new <code>UserDel.java</code> instance.
   * <br>Default Constructor
   * @param up
   */
  public UserDel(UserInfMap uim, UserProcess up, GroupProcess gp) {
    _jim = uim;
    _up = up;
    _gp = gp;
  }

  private final String UID = "uid";
  private final String MSGID = "UserDelErrGM";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#checkMaster(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage checkMaster(CommonMessage msg) throws Exception {
    GroupSearchDto gsd = new GroupSearchDto();
    gsd.setRetrieveValue(GroupSearchDto.MANAGER, msg.getReqStr(UID));
    gsd.setDel(USE_FLG.USE);
    gsd = _gp.find(gsd);
    if (gsd.getKeys().size() > 0) {
      StringBuilder sb = new StringBuilder();
      for (List<String> keys : gsd) {
        VGroupDto gd = new VGroupDto();
        gd.setItemValue(VGroupDto.GROUP_ID, keys.get(0));
        gd.setRequestItem(VGroupDto.GROUP_CODE);
        gd.setSysId(sysId);
        gd = _gp.findByPrimarykey(gd);
        sb.append(gd.getItemValue(VGroupDto.GROUP_CODE));
        sb.append(",");
      }
      sb.setLength(sb.length() - 1);
      Object[] prm = {sb.toString()};
      msg.setErrorStatus(STATUS.WARNING);
      msg.addMessage(MessageFormat.format(resource.getString(MSGID), prm));
    }
    return msg;
  }

  private final String MODOK = "UserMod";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _up.delete((UserDto)dii);
    msg.setResMsg(MODOK, "1");
    return msg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new UserDto();
  }

}
