package com.hamaf.hikyaku.security.ui;

import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.report.excel2003.ExcelDoc;
import com.hamaf.hikyaku.report.excel2003.ExcelSheet;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.process.UserProcess;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.ComUtils;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFUserExcel is .</p>
 * <p>F[U[ꗗXgiExcel)̍쐬</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/06/16</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class UserExcel extends ProcessBase {

  private UserProcess _up = null;

  private final String BASE_TAG = "excelBase";
  private final String BASE_EXL = "UserList.xml";

  /**
   *  Creates a new <code>UserExcel.java</code> instance.
   * <br>Default Constructor
   * @param up
   */
  public UserExcel(UserProcess up) {
    _up = up;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    StringBuilder path = new StringBuilder();
    path.append(ComUtils.convPath(mxc.getConstant(BASE_TAG), true));
    path.append(BASE_EXL);
    ExcelDoc ed = new ExcelDoc();
    ed.openBook(path.toString());
    ExcelSheet sht = ed.getSheet(0);

    setConst(sht);
    List<List<Object>> vals = getDetailVal();
    setDetail(sht, vals);
    msg.setWorkBuff(ed);
    msg.addMessage(BASE_EXL);
    return msg;
  }
  private final String[] GET_KEYS = {"UExlTitle", "UExlDateTIme", "UExlHEader", "UExlComment1", "UExlComment2", "UExlComment3"};
  private final String[] SET_KEYS = {"#ttl", "#date", "#heder", "#comm1", "#comm2", "#comm3"};
  private void setConst(ExcelSheet sht) throws Exception {
    for (int i = 0; i < GET_KEYS.length; i++) {
      String val = resource.getString(GET_KEYS[i]);
      switch (i) {
        case 1:
          StringBuilder sb = new StringBuilder();
          sb.append(val);
          sb.append(" ");
          sb.append(DateUtil.getDate());
          sb.append(" ");
          sb.append(DateUtil.getTime());
          setCell(sht, SET_KEYS[i], sb.toString());
          break;
        case 2:
          String[] hds = val.split(",");
          List<Object> vals = new ArrayList<Object>();
          for (int j = 0; j < hds.length; j++) {
            vals.add(hds[j]);
          }
          int[] pos = sht.searchCell(SET_KEYS[i]);
          sht.setRowValue(vals, pos[0], pos[1], null);
          break;
        default:
          setCell(sht, SET_KEYS[i], val);
          break;
      }
    }
  }
  private void setCell(ExcelSheet sht, String posval, String val) throws Exception {
    int[] pos = sht.searchCell(posval);
    sht.setCellValue(val, pos[0], pos[1], null);
  }
  private final String SET_LIST = "#start";
  private void setDetail(ExcelSheet sht, List<List<Object>> vals) throws Exception {
    int[] pos = sht.searchCell(SET_LIST);
    sht.copyAddValue(vals, pos[0], pos[1]);
  }
  private List<List<Object>> getDetailVal() throws Exception {
    KeyList kl = (KeyList)saveObj;
    List<List<Object>> vals = new ArrayList<List<Object>>();
    for (int i = 0; i < kl.getDataCount(); i++) {
      List<Object> val = new ArrayList<Object>();
      UserDto cd = getDetail(kl.getKey(i), kl);
      val.add(i + 1);
      val.add(cd.getItemValue(UserDto.USER_ID));
      val.add(cd.getItemValue(UserDto.NAME));
      val.add(cd.getItemValue(UserDto.ABBREV));
      val.add(cd.getItemValue(UserDto.ORGANIZATION));
      val.add(cd.getItemValue(UserDto.CONTACT));
      val.add(cd.getItemValue(UserDto.E_MAIL));
      val.add(cd.getItemValue(UserDto.ADMIN_FLG));
      vals.add(val);
    }
    return vals;
  }
  private UserDto getDetail(List<String> keys, KeyList keyl) throws Exception {
    UserDto cd = new UserDto();
    for (int i = 0; i < keys.size(); i++) {
      cd.setFldValue(keyl.getKeyFields().get(i), keys.get(i));
    }
    cd.setAllRequest();
    return (UserDto)_up.findByPrimarykey(cd, session);
  }

}
