package com.hamaf.hikyaku.security.ui;

import java.util.Map;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.security.access.UserAccess.PWD_FLG;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.dto.UserSearchDto;
import com.hamaf.hikyaku.security.process.UserProcess;
import com.hamaf.hikyaku.security.ui.mapping.UserInfMap;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFUserList is .</p>
 * <p>F[U[ꗗ̍쐬</p>
 * <br>
 * 
 * <p>쌠: Copyright (c) 2010/03/16</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class UserList extends StandardListProcess {

  private UserProcess _up = null;
  /**
   *  Creates a new <code>UserList.java</code> instance.
   * <br>Default Constructor
   */
  public UserList(UserInfMap uim, UserProcess up) {
    _jim = uim;
    _up = up;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _up.findByPrimarykey((UserDto)dii, session);
  }

  private final String DMSG = "DelLine";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    if (delCheck(dii)) {
      String[] ret = {"uname", resource.getString(DMSG)};
      return ret;
    }
    return null;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _up.find((UserSearchDto)rki);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new UserDto();
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    UserSearchDto usd = new UserSearchDto();
//    usd.setRetrieveValue(UserSearchDto.USER_ID, keyl.getRetrieve("ruid"));
//    usd.setCondition(UserSearchDto.USER_ID, "like");
    usd.setRetrieveValue(UserSearchDto.ORGANIZATION, keyl.getRetrieve("syozoku"));
    usd.setCondition(UserSearchDto.ORGANIZATION, "like");
    usd.setRetrieveValue(UserSearchDto.NAME, keyl.getRetrieve("namae"));
    usd.setCondition(UserSearchDto.NAME, "like");
    usd.setRetrieveValue(UserSearchDto.INITIALIZE_FLG, keyl.getRetrieve("riflg"));
    usd.setRetrieveValue(UserSearchDto.USER_TYPE, "g");
    usd.setOrderItem(UserDto.USER_ID, 1);
    return usd;
  }

  private final String MX_PWD = "pwdIniFlg";
  private final String MX_PWD_TAG = "pwdIniFlgName";
  private final String PSW_INI = "pswini";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#editItems(com.hamaf.hikyaku.dataobject.DetailItemsInterface, java.util.Map)
   */
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> mp) throws Exception {
    String pst = ((UserDto)dii).getItemValue(UserDto.INITIALIZE_FLG);
    if (!PWD_FLG.NORMAL.getVal().equals(pst)) {
      MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
      mp.put(PSW_INI, mxc.getTagValue(MX_PWD, pst, MX_PWD_TAG));
    }
    return mp;
  }

}
