package com.hamaf.hikyaku.system;

import java.util.Calendar;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.*;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgFSetStop is settinng and relese system stop.</p>
 * <p>FVXe̎gp~Aݒ肷NXłB</p>
 * <br>~A͑yї\莞Ԃɂo^\ƂȂĂ܂B
 *
 * <p>쌠: Copyright (c) 2004/01/31</p>
 * @author Hamanaka
 * @version 1.0
 */
public final class SetStop extends ProcessBase {

  public CommonMessage exec(CommonMessage msg) throws Exception {
    StopControl stc = StopControl.newInstance();
    String stop = msg.getReq("stop");

    msg.setErrorStatus(STATUS.NORMAL);
    if ("1".equals(msg.getReq("type"))) {
    	applyImmediately(msg);
      return msg;
    }
    
    Calendar cln = generateDate(msg);
    if ("1".equals(stop)) {
      stc.setStop(cln, msg.getReq("url"));
      msg.addMessage(resource.getString("StopMsg03"));
    }
    else {
      stc.setStart(cln);
      msg.addMessage(resource.getString("StopMsg04"));
    }
    msg.setResMsg("type", "0");
    msg.setResMsg("stop", stop);
    msg.setResMsg("url", stc.getJspUrl());
    msg.setWorkBuff(cln.getTime());
    return msg;
  }

  /**
   * Describe <code>applyImmediately</code> method : Kp.
   * <br>̒~A~̐ݒsȂB
   * <br>
   * @param msg a <code>CommonMessage</code> : 
   */
  private void applyImmediately(CommonMessage msg) {
  	StopControl stc = StopControl.newInstance();
  	String stop = msg.getReq("stop");
  	if ("1".equals(stop)) {
  		stc.setStop(msg.getReq("url"));
  		msg.addMessage(resource.getString("StopMsg01"));
  	}
  	else {
  		stc.setStart();
  		msg.addMessage(resource.getString("StopMsg02"));
  	}
  	msg.setResMsg("type", "1");
  	msg.setResMsg("stop", stop);
  	msg.setResMsg("url", stc.getJspUrl());
  }
  
  /**
   * Describe <code>generateDate</code> method : .
   * <br>w肳ꂽ~܂͒~̓tECalendarIuWFNg𐶐B
   * <br>
   * @param msga <code>CommonMessage</code> : 
   * @return a <code>Calendar</code> : 
   */
  private Calendar generateDate(CommonMessage msg) {
    String stop = msg.getReq("stop");
    int year = 0;
    int month = 0;
    int day = 0;
    int hour = 0;
    int minute = 0;
    if ("1".equals(stop)) {
      year = Integer.parseInt(msg.getReq("syear"));
      month = Integer.parseInt(msg.getReq("smonth")) - 1;
      day = Integer.parseInt(msg.getReq("sday"));
      hour = Integer.parseInt(msg.getReq("shour"));
      minute = Integer.parseInt(msg.getReq("sminute"));
    }
    else {
      year = Integer.parseInt(msg.getReq("eyear"));
      month = Integer.parseInt(msg.getReq("emonth")) - 1;
      day = Integer.parseInt(msg.getReq("eday"));
      hour = Integer.parseInt(msg.getReq("ehour"));
      minute = Integer.parseInt(msg.getReq("eminute"));
    }
    
    Calendar cln = Calendar.getInstance();
    cln.setLenient(false);
    cln.set(year, month, day, hour, minute, 0);
    return cln;
  }
}
