package com.hamaf.hikyaku.taglibs;

import java.text.MessageFormat;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.util.MessageUtil;

import static com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;

/**
 * <p>^CgFDispComFields is create Common hidden fields.</p>
 * <p>FʓIHiddentB[h𐶐</p>
 * <table border="1">
 *   <tr bgcolor="#eeeeff" >
 *     <td>vpeB</td>
 *     <td>K{^C</td>
 *     <td></td>
 *   </tr>
 *   <tr>
 *     <td>plgid</td>
 *     <td>C</td>
 *     <td>vOCID</td>
 *   </tr>
 *   <tr>
 *     <td>pid</td>
 *     <td>C</td>
 *     <td>vZXID</td>
 *   </tr>
 *   <tr>
 *     <td>act</td>
 *     <td>C</td>
 *     <td>ANV</td>
 *   </tr>
 *   <tr>
 *     <td>pageact</td>
 *     <td>C</td>
 *     <td>y[WANV</td>
 *   </tr>
 * </table>
 *
 * <p>쌠: Copyright (c) 2007/06/02</p>
 * @author Hamanaka
 * @version 1.0
 */
public class DispComFields extends TagSupport {

  private static final long serialVersionUID = -7254897585865210089L;

  private String _plgid = "";
  private String _pid = "";
  private String _act = "";
  private String _pageact = "";

  private static final String TXT =
    "  <input type=\"hidden\" name=\"{0}\" id=\"{0}\" value=\"{1}\">";

  /**
   * ^OJnɌĂяo
   *
   * @return <code>EVAL_BODY_TAG</code>
   * @throws JspException
   */
  public int doStartTag() throws JspException {
    wrtItem("pluginId", _plgid);
    wrtItem("processId", _pid);
    wrtItem("action", _act);
    wrtItem("pageAction", _pageact);
    wrtItem("currentPage", getCurrPage());
    wrtItem("pos", null);
    wrtItem("pageLine", "");
    wrtItem(COMMFLD.UPDT.getVal(), null);
    wrtItem(COMMFLD.UPTM.getVal(), null);

    release();
    return SKIP_BODY;
  }
  private void wrtItem(String fld, String val) throws JspException {
    try {
      if (val == null) {
        val = MessageUtil.getItem(pageContext.getRequest(), fld, false);
      }
      Object[] prm = {fld, val};
      pageContext.getOut().println(MessageFormat.format(TXT, prm));
    } catch (Exception ioe) {
      throw new JspException(ioe.getMessage());
    }
  }
  private String getCurrPage() {
    String proId;
    try {
      proId = (String)pageContext.getSession().getAttribute(DistributeServlet.KEY_SAVE_ID);
    } catch (IllegalStateException xe) {
      return "";
    }
    KeyList kl = (KeyList)pageContext.getSession().getAttribute(proId);
    if (kl == null) {
      return "";
    }
    return Integer.toString(kl.getCurrentPage());
  }

  /**
   * ^OIɌĂяo
   *
   * @return <code>EVAL_PAGE</code>
   * @throws JspException
   */
  public final int doEndTag() throws JspException {
    return EVAL_PAGE;
  }
  /**
   * @param act act ݒ肵܂B
   */
  public final void setAct(String act) {
    _act = act;
  }
  /**
   * @param pageact pageact ݒ肵܂B
   */
  public final void setPageact(String pageact) {
    _pageact = pageact;
  }
  /**
   * @param pid pid ݒ肵܂B
   */
  public final void setPid(String pid) {
    _pid = pid;
  }
  /**
   * @param plg plgid ݒ肵܂B
   */
  public final void setPlg(String plg) {
    _plgid = plg;
  }
  /**
   * ^O̓ԂZbg
   */
  public void release() {
    _plgid = "";
    _pid = "";
    _act = "";
    _pageact = "";
    super.release();
  }

}
