package com.hamaf.hikyaku.ui;

import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.JspItemsMapping;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.tfunc.CommonMessages;
import com.hamaf.hikyaku.ui.dto.CommonSelectDto;
import com.hamaf.hikyaku.ui.dto.CommonSelectMapping;
import com.hamaf.hikyaku.ui.dto.CommonSelectSearchDto;

/**
 * <p>^CgFCommonSelectList is Common Select List Process.</p>
 * <p>FʑIʂ̏sB</p>
 * <br>NMtB[h̕vsAIpꗗ𐶐B
 *
 * <p>쌠: Copyright (c) 2007/06/19</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class CommonSelectList extends StandardListProcess {

  private String _preLod = null;
  private DefaultTableAccess _dta = new DefaultTableAccess();

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setJspMapping()
   */
  @Override
  protected final JspItemsMapping setJspMapping() {
    return new CommonSelectMapping();
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#generateDetailDTO()
   */
  @Override
  protected final DetailItemsInterface newDataObj() {
    return new CommonSelectDto();
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected final DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _dta.findByPrimaryKey(dii);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    return null;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    if ("1".equals(_preLod)) {
      return rki;
    }
    return _dta.find(rki);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList, com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    RetrieveKeysInterface rki = new CommonSelectSearchDto();
    if (keyl.getRetrieve("searchVal").length() > 0) {
      rki.setRetrieveValue(CommonSelectSearchDto.NM, "%" + keyl.getRetrieve("searchVal") + "%");
      rki.setCondition(CommonSelectSearchDto.NM, "like");
    }
    rki.setConstCond(keyl.getRetrieve("cond"));
    return rki;
  }

  private final String REQKEY = "title";
  private final String M_TTL = "dsptitle";
  private final String M_PLG = "oplgid";
  private final String M_ACT = "oact";
  private final String ACT = "action";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ListProcessBase#spareAction(com.hamaf.hikyaku.dataobject.CommonMessage, java.lang.String)
   */
  @Override
  protected CommonMessage spareAction(CommonMessage msg, String act) {
    msg.setResMsg(M_PLG, sysId);
    msg.setResMsg(M_ACT, msg.getReqStr(ACT));

//    _dta.setDebug();
    _dta.setTableName(msg.getReq("targetTable"));
    _dta.setConnectionParameter(msg.getReqStr("connectParam"));
    _preLod = msg.getReq("preLoadList");
    String ttl = msg.getReqStr(REQKEY);
    if (ttl.length() > 0) {
      String nttl = CommonMessages.getMsg(ttl);
      if (nttl.length() > 0) {
        msg.setResMsg(M_TTL, nttl);
      } else {
        msg.setResMsg(M_TTL, ttl);
      }
    }
    return msg;
  }

}
