package com.hamaf.hikyaku.ui;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.util.DateUtil;


/**
 * <p>^CgFMonthCalendar is J_[ProcessBaseNX.</p>
 * <p>:ꃖ̃J_[ʗp̃f[^쐬B</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2004/11/26</p>
 * @author y-hamanaka
 * @version 1.0
 */
public final class MonthCalendar extends ProcessBase {

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    
    Calendar cal = null;
    if (msg.getReqStr("base").length() > 0) {
      cal = DateUtil.getCalendar(msg.getReqStr("base"));
      if (cal == null) {
        cal = getMonth("", "", 0);
      }
      else {
        cal.set(Calendar.DATE, 1);
      }
    }
    else {
      int offset = 0;
      if (msg.getReqStr("nextMonth").length() > 0 && msg.getReqStr("prevMonth").length() > 0) {
        offset = Integer.parseInt(msg.getReqStr("nextMonth"))
               - Integer.parseInt(msg.getReqStr("prevMonth"));
      }
      cal = getMonth(msg.getReqStr("year"), msg.getReqStr("month"), offset);
    }
    
    msg.setResMsg("year", String.valueOf(cal.get(Calendar.YEAR)));
    msg.setResMsg("month", String.valueOf(cal.get(Calendar.MONTH)+1));
    msg.setWorkBuff(getCalendar(cal));

    return msg;
  }
  
  /**
   * Describe <code>getMonth</code> method : w肵NȀ߂.
   * <br>NA͎w肪ꍇ́AVXeNgpB
   * 
   * @param year a <code>String</code> : N
   * @param month a <code>String</code> : 
   * @param offset an <code>int</code> : ̃ItZbgl
   * @return a <code>Calendar</code> : w肵N̂P
   */
  private Calendar getMonth(String year, String month, int offset) {
    Calendar cal = Calendar.getInstance();
    int iYear  = cal.get(Calendar.YEAR);
    int iMonth = cal.get(Calendar.MONTH);

    if(year.length() > 0){
      iYear = Integer.parseInt(year);
    }
    if(month.length() > 0){
      iMonth = Integer.parseInt(month) - 1;
    }

    cal.set(iYear, iMonth + offset, 1);
    return cal;
  }

  /**
   * Describe <code>getCalendar</code> method : create month data.
   * <br>wNɂJ_[ListŕԂ
   * <br>eTListɓYT̓ti[ListqƂȂ
   * 
   * @param cal a <code>Calendar</code> : 쐬N̂P
   * @return a <code>List&lt;List&gt;</code> : ꂩ̃J_[C[W
   */
  private List<List<String>> getCalendar(Calendar cal) {
    int startDayOfWeek = cal.get(Calendar.DAY_OF_WEEK);
    cal.add(Calendar.MONTH, 1);
    cal.add(Calendar.DATE, -1);    // ݒ

    List<List<String>> calList = new ArrayList<List<String>>();

    List<String> weekList = new ArrayList<String>();
    for (int ii = 1; ii < startDayOfWeek; ii++) {
      weekList.add("");
    }
    int dayOfWeek = startDayOfWeek;
    for (int ii = 1; ii <= cal.get(Calendar.DATE); ii++) {
      weekList.add(String.valueOf(ii));
      dayOfWeek++;
      if (dayOfWeek > 7) {
        calList.add(weekList);
        weekList = new ArrayList<String>();
        dayOfWeek = 1;
      }
    }
    if (dayOfWeek > 1) {
      for (int i = dayOfWeek + 1; i < 8; i++) {
        weekList.add("");
      }
      calList.add(weekList);
    }

    return calList;
  }

}
