package com.hamaf.hikyaku.ui;

import java.text.MessageFormat;
import java.util.Enumeration;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.logging.Logger;

import javax.servlet.ServletConfig;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.w3c.dom.Document;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.distribute.ControlXml;
import com.hamaf.hikyaku.distribute.DistributeServlet;
import com.hamaf.hikyaku.distribute.DistributeServlet.SVAL;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;

import static com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;

/**
 * <p>^CgFProcessBase is Process Bean base class.</p>
 * <p>FpJavaBeañx[XƂȂNXB</p>
 * <br>JSPƂ̎nf[^<code>CommonMessage</code>IuWFNgčs܂B
 * <br>
 * <br>`Ă郁\bh
 * <ul>
 *   <li> init : p\bh
 *   <li> exec : 又p̃\bh@ix[XNXłabstractŒ`Ă܂j
 *   <li> finish : Ip\bh
 * </ul>
 * <br>NXϐƂĈȉ̗̈悪`Ă܂B
 * <ul>
 *   <li> session : HttpSession - ZbV@IuWFNg
 *   <li> log : Logger - MO@IuWFNg
 *   <li>process : String - processId
 *   <li>clnm : String - Class Name
 *   <li>msgHed : String - process + clnm
 *   <li>saveObj : Object - ɐݒ肷sessionɕۊǂAprocessIdŎ擾܂
 *   <li>controlXml : t@CDOM`ۑĂ܂B
 * </ul>
 *
 * <p>쌠: Copyright (c) 2003/12/01</p>
 * @author Hamanaka
 * @version 1.0
 */
public abstract class ProcessBase {

  protected HttpServletRequest request;
  protected HttpServletResponse response;
  protected HttpSession session;
  protected Logger log = null;
  protected Object saveObj;
  protected Document controlXml = null;
  protected String sysId = null;
  protected String process = null;

  protected String clnm = null;
  protected String msgHed = null;

  protected ResourceBundle resource;
  protected ServletConfig sconfig;

  /**
   * Describe <code>init</code> method : create CommonMessage and initialize.
   * <br>ݒp̃b\hBCŏɌĂяoB
   * <br>e
   * <ul>
   *   <li> HttpServletRequest,HttpServletResponse,HttpSession NXϐɐݒ肷
   *   <li> saveObjSessionݒ肷B
   *   <li> CommonMessage𐶐AErrorStatusNormalɐݒ肷
   *   <li> CommonMessageHttpSessionݒ肷
   *   <li> CommonMessagẽNGXg̈HttpServretRequest̃p[^ݒ肷
   * </ul>
   * @param httpRequest : HttpServletRequest
   * @param httpResponse : HttpServletResponse
   * @param rsb : ResourceBundle
   * @param argSysId a <code>String</code> : VXeID
   * @param sval a <code>Map</code> : VXeMap
   * @return a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   */
  public final CommonMessage init(HttpServletRequest httpRequest,
                     HttpServletResponse httpResponse,
                     ResourceBundle rsb,
                     Map<SVAL, String> sval) {
    request = httpRequest;
    response = httpResponse;
    session = request.getSession();
    resource = rsb;
    sysId = sval.get(SVAL.sysId);
    process = sval.get(SVAL.ProcId);

    String kprocess = (String)session.getAttribute(DistributeServlet.KEY_SAVE_ID);
    saveObj = session.getAttribute(kprocess);

    setLogger();
    log.fine(msgHed + resource.getString("InitStart"));

    return newCommonMessage();
  }
  /**
   * Describe <code>setLogger</code> method : setteing Logger Object.
   * <br>Oo͗p̃K[𐶐B
   */
  private void setLogger() {
    controlXml = ControlXml.newInstance().getDoc(sysId);
    clnm = getClass().getName();
    Package pk = getClass().getPackage();
    String pknm = null;
    if (pk == null) {
      int k = clnm.lastIndexOf(".");
      if (k >= 0) {
        pknm = clnm.substring(0,k);
      }
      else {
        pknm = clnm;
      }
    }
    else {
      pknm = pk.getName();
    }
    log = Logger.getLogger(pknm);

    Object[] msg = {process, clnm};
    msgHed = MessageFormat.format(resource.getString("ProcessHeader"),msg);
  }

  /**
   * Describe <code>finish</code> method : fainal process.
   * <br>Ip̃\bhBCŌɌĂяoB
   * <br> saveObjsessionɕۑB
   * @param msg@a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   * @return a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   */
  public CommonMessage finish(CommonMessage msg) {
    log.fine(msgHed + resource.getString("FinishStart"));

    String process = (String)session.getAttribute(DistributeServlet.KEY_SAVE_ID);
    if (saveObj == null) {
      session.removeAttribute(process);
    }
    else {
      session.setAttribute(process, saveObj);
    }

    return msg;
  }

  /**
   * Describe <code>newCommonMessage</code> method : create new CommonMessage.
   * <br><code>CommonMessage</code>CX^XĖ߂B
   * <br> CommonMessagepNX߂ꍇɁAOverWrite܂B
   * @return a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   */
  protected CommonMessage newCommonMessage() {
    CommonMessage cm = new CommonMessage();
    cm.setErrorStatus(STATUS.NORMAL);
    cm.setSession(session);
    cm.setSysId(sysId);
//    cm.setCharCd((String)request.getAttribute(DistributeServlet.CHAR));
    cm.setCharCd(DistributeServlet.CHAR);

    for (Enumeration<?> enumt = request.getParameterNames(); enumt.hasMoreElements();) {
      String elm = (String)enumt.nextElement();
      cm.setReq(elm, request.getParameterValues(elm));
    }

    return cm;
  }

  /**
   * @param sconfig sconfig ݒ肵܂B
   */
  public void setSconfig(ServletConfig sconfig) {
    this.sconfig = sconfig;
  }

  /**
   * Describe <code>getUerDto</code> method : .
   * <br>ZbVɕێĂ郆[U[DTO߂B
   *
   * @return a <code>UserDto</code> :
   */
  protected UserDto getUerDto() {
    Object udt = session.getAttribute(LogInCheck.USER_INF);
    if (udt instanceof UserDto) {
      return (UserDto)udt;
    }
    return null;
  }

  /**
   * Describe <code>getUserID</code> method : .
   * <br>OC[U[̃[U[ID߂B
   *
   * @return a <code>String</code> : OC[U[ID
   */
  protected String getUserID() {
    UserDto ud = getUerDto();
    if (ud == null) return "";
    return ud.getItemValue(UserDto.USER_ID);
  }

  /**
   * Describe <code>exec</code> method : Process Execute.
   * <br>Ɩ`郁\bh
   * <br>
   * <br>Mf[^́A<code>CommonMessage</code>̃NGXgpMapɐݒ肳Ă܂B
   * <br>getReq(ږ)ÁAgetReq2String(ږ)\bhŎoo܂B
   * <br>
   * <br>JSPɓnf[^́A<code>CommonMessage</code>̃X|XpMapLisẗɁA
   * <br>setResMsg(ږAl)AyсAaddResList(Object)Őݒ肵܂B
   * <br>
   * <br>Yf[^ȂAڃ`FbÑG[ȂǑMʂ\ꍇ́A
   * <br>CommonMessageErrorStatusCOUTION܂WARNINGݒ肵A
   * <br>bZ[WpList  X|XpMAPɃG[ݒ肷B
   * <br>
   * <br>VXeQȂǂ̉񕜕s\ȃG[ꍇ́A
   * <br>CommonMessageErrorStatusERRORݒ肵A
   * <br>bZ[WpList  G[ݒ肷B
   * <br>
   * <br><b>saveObj</b>ɕۑf[^̓ZbVɕۊǂǍďoɂgp鎖o܂B
   * <br>
   * <br>O𓊂ƁAVXeQʂ\܂B
   * @param msg a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   * @return a <code>CommonMessage</code> : ʃbZ[WIuWFNg
   * @throws Exception
   */
  public abstract CommonMessage exec(CommonMessage msg) throws Exception;

}
