package com.hamaf.hikyaku.util;

import java.text.DecimalFormat;
import java.text.NumberFormat;

/**
 * <p>^Cg:l֌W̃[eBeBNX.</p>
 * <p>:l֌W̃[eBeB@\񋟂B</p>
 * <ul>
 *  <li>round(double, int) : wʒuŎľܓĖ߂
 *  <li>getAbsStr(String) : Βl߂
 *  <li>formatPict(String),formatPict(double) : ɕϊĖ߂
 *  <li>formatYen(String),formatYen(long) : z`ɂĖ߂
 *  <li>formatNingetu(String) : l^l`Ŗ߂
 *  <li>ninniti2Ningetu(String) : llɕϊĖ߂
 *  <li>selNum(String) : 琔l쐬
 * </ul>
 * <p>쌠: Copyright (c) 2004</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class NumUtil {
  static private String PICT_FORMAT = "###,###,###,###,##0.00";
  static private String NINGETU_FORMAT = "###,###,###,###,##0.00";

  /**
   * Describe <code>round</code> method : ľܓs.
   * <br><code>decimalPosition</code>̎̏ʒuŎľܓlvZ܂B
   * @param exp a <code>double</code> : ľܓ鐔l
   * @param decimalPosition an <code>int</code> : ľܓ̏ʒu
   * @return a <code>double</code> : ʂ̒l
   */
  public final static double round(double exp,int decimalPosition){
    double dbl = exp * Math.pow(10,decimalPosition);
    dbl = Math.round(dbl);
    return dbl / Math.pow(10,decimalPosition);
  }

  /**
   * w̕ilj̐Βl𕶎<code>String</code>ŕԂ.
   * @param val a <code>String</code>
   * @return a <code>String</code> Βlɕϊ
   */
  public final static String getAbsStr(String val){
    if(val == null || val.trim().length() == 0){
      return "";
    }
    return Integer.toString(Math.abs(Integer.parseInt(val)));
  }

  /**
   * w̒lu%vɕϊĕԂ.
   * @param val a a<code>String</code>FtH[}bgsilj
   * @return a a<code>String</code>FtH[}bg̕i999,999,999.99j
   */
  public final static String formatPict(String val){
    if(val == null || val.trim().length() == 0){
      return "";
    }
    return formatPict(Double.parseDouble(val));
  }

  /**
   * w̒lu%vɕϊĕԂ.
   * @param val a <code>double</code>FtH[}bgsl
   * @return a <code>String</code>FtH[}bg̕i999,999,999.99j
   */
  public final static String formatPict(double val){
    if(val == Double.NaN){
      return "";
    }

    double dVal = round(val * 100, 3);
    DecimalFormat dFormat = new DecimalFormat(PICT_FORMAT);

    return dFormat.format(dVal);
  }

  /**
   * w̒l~̃tH[}bgŕԂ.
   * @param val a <code>String</code>FtH[}bgsilj
   * @return a <code>String</code>FtH[}bg̕i\999,999,999j
   */
  public final static String formatYen(String val){
    if(val == null || val.trim().length() == 0){
      return "";
    }

    return formatYen(Math.round(Double.parseDouble(val)));
  }

  /**
   * w̒l~̃tH[}bgŕԂ.
   * @param val a <code>long</code>FtH[}bgsl
   * @return a <code>String</code>FtH[}bg̕i\999,999,999j
   */
  public final static String formatYen(long val){
    return NumberFormat.getCurrencyInstance().format(val);
  }

  /**
   * w̒ll/l̃tH[}bgŕԂ.
   * @param val a <code>String</code>FtH[}bgsilj
   * @return a <code>String</code>FtH[}bg̕i99.99j
   */
  public final static String formatNingetu(String val){
    if(val == null || val.trim().length() == 0){
      return "";
    }

    double dVal = round(Double.parseDouble(val), 2);
    DecimalFormat dFormat = new DecimalFormat(NINGETU_FORMAT);

    return dFormat.format(dVal);
  }

  /**
   * Describe <code>ninniti2Ningetu</code> method : ll֕ϊs.
   *
   * @param ninniti a <code>String</code> : 
   * @return a <code>String</code> : 
   */
  public final static String ninniti2Ningetu(String ninniti){
    if(ninniti == null || "".equals(ninniti) || "0".equals(ninniti)){
      return "";
    }
    return Double.toString(Double.parseDouble(ninniti) / 20);
  }

  /**
   * Describe <code>selNum</code> method.
   * <br>񂩂琔l<cpde>(0-9)</code>݂̂oāA
   * <br><b>long</b>̒lɕϊĖ߂B
   * @param s a <code>String</code> : ϊ镶
   * @return a <code>long</code> : ϊl
   */
  public final static long selNum(String s) {
    StringBuffer sb = new StringBuffer();
    for (int i = 0; i < s.length(); i++) {
      if (s.charAt(i) >= '0' && s.charAt(i) <= '9') {
        sb.append(s.charAt(i));
      }
    }
    if (sb.length() < 1) {
      return 0;
    }
    return Long.parseLong(sb.toString());
  }


  public static void main (String[] args) {
    System.out.println("-------- NumUtil Exec Sanple -----------------------");
    System.out.println(" round(123.456, 2) is " + round(123.456, 2));
    System.out.println(" getAbsStr(\"-9876\") is " + getAbsStr("-9876"));
    System.out.println(" formatPict(\"0.65435\") is " + formatPict("0.65435"));
    System.out.println(" formatYen(\"45120\") is " + formatYen("45120"));
    System.out.println(" formatNingetu(\"23\") is " + formatNingetu("23"));
    System.out.println(" ninniti2Ningetu(\"863.5\") is " + ninniti2Ningetu("863.5"));
    System.out.println(" selNum(\"\\2,034,560.-\") is " + selNum("\\2,034,560.-"));
    System.out.println("-------- NumUtil Sanple End  -----------------------");
  } // end of main ()
  
}
