package com.hamaf.hikyaku.util;

import java.util.*;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.*;

/**
 * <p>^Cg: Xpath ł́@Xml ANZX@c[@NX.</p>
 * <p>: Xml<code>(Document Object)</code>̑񋟂܂B</p>
 * <br> ElementXPath`ƂȂ܂B
 * <ul>
 *   <li> ʓIElement̎w@ : eElement/qElemet/Element EEE
 *   <li> JԂꍇ̎w@ :  eElement/qElemet<b>[n]</b>/Element <code>(n=0,1,2,3EEE)</code>
 *   <li> Agr[g̎w@ : eElement/qElemet/<b>@</b>qElement̃Agr[g
 *   <li> qGg̒lɂ錟 : Element[qGg=l]
 *   <li> lɂ錟 : Element[<b>@</b>Agr[g=l]
 * </ul>
 *
 * @author  Hamanaka
 * @version $Revision: 1.1 $, $Date: 2011/05/04 08:10:24 $, VK쐬
 */
public class XPathUtil {

  /**
   * Describe <code>setElementValue</code> method : value set to Element.
   * <br><b>Element</b>XPath FormatŎw肳ꂽElementƁAnꂽlݒ肷B
   * <br>ݒ肷<b>Element</b>Ɏq<b>Node</b>݂ꍇ͂폜܂B
   * <br>ݒ肷Gg݂͑Ȃΐ܂B
   * @param argElm an <code>Element</code> : 삷Element
   * @param setPath a <code>String</code> : lݒ肷GgXPath\
   * @param value a <code>String</code> : ݒ肷l
   * @exception Exception if an error occurs
   */
  public final static synchronized void setElementValue(Element argElm, String setPath, String value)
    throws Exception {
    Element setelm = getElementWithPath(argElm, XPathUtil.getTagPath(setPath));
    if (XPathUtil.getAttrName(setPath) == null) {
      Node childNode = setelm.getFirstChild();
      if (childNode != null) {
        setelm.removeChild(childNode);
      }
      if (value != null) {
        Document ddm = argElm.getOwnerDocument();
        setelm.appendChild(ddm.createTextNode(value));
        ddm = null;
      }
    }
    else {
      if (value == null) {
        value = "";
      }
      setelm.setAttribute(XPathUtil.getAttrName(setPath), value);
    }
  }

  /**
   * Describe <code>setElementValueAt</code> method : value set to orgDom Element At Befor Pos.
   * <br><b>Element</b>Ȃ̎w肵^ȎOɎw肳ꂽElementǉAnꂽlݒ肷B
   * <br>w肳ꂽeGg݂ȂΉ܂B
   * <br>w肳ꂽʒuGg݂Ȃ΍Ōɒǉ܂B
   * @param argElm an <code>Element</code> : 삷Element
   * @param parent a <code>String</code> : lݒ肷Gg̐eGgXPath\
   * @param addTag a <code>String</code> : ݒ肷^O̖
   * @param value a <code>String</code> : ݒ肷l
   * @param posTag a <code>String</code> : ̃^ȎOɃ^Oǉ
   * @throws java.lang.Exception
   */
  public final static synchronized void setElementValueAt(Element argElm, String parent, String addTag,
                               String value, String posTag)
      throws Exception {
    StringBuffer psb = new StringBuffer(parent);
    if (psb.charAt(psb.length() - 1) == '/') {
      psb.setLength(psb.length() - 1);
    }

    Element setelm = searchElementWithPath(argElm, psb.toString());
    if (setelm == null) {
      return;
    }

    psb.append("/");
    psb.append(posTag);
    Element poselm = searchElementWithPath(argElm, psb.toString());
    Document ddm = argElm.getOwnerDocument();
    Element addelm = ddm.createElement(addTag);
    if (value != null) {
      addelm.appendChild(ddm.createTextNode(value));
    }
    if (poselm == null) {
      setelm.appendChild(addelm);
    }
    else {
      setelm.insertBefore(addelm, poselm);
    }
    ddm = null;
  }

  /**
   * Describe <code>addChildElement</code> method : add Element child of path.
   * <br>Gg<b>name</b><b>path</b>̎qƂĒǉB
   * @param elm an <code>Element</code> : 삷Element
   * @param path a <code>String</code> : ǉeGgXPath
   * @param name a <code>String</code> : ǉGg
   * @param val a <code>String</code> : ǉGg̐ݒ肷l(<code>null</code>)
   * @exception Exception if an error occurs
   */
  public final static synchronized void addChildElement(Element elm, String path, String name, String val)
      throws Exception {
    Element parent = searchElementWithPath(elm, path);
    Document ddm = elm.getOwnerDocument();
    Element child = ddm.createElement(name);
    if (val != null && val.length() > 0) {
      Text txt = ddm.createTextNode(val);
      child.appendChild(txt);
    }
    parent.appendChild(child);
    ddm = null;
  }

  /**
   * Describe <code>getValueWithPath</code> method : get Element Value by XPath.
   * <br><b>Element</b>XPathŎw肳ꂽ^O<code>(Element)</code>̒l擾
   * @param elm an <code>Element</code> : Element
   * @param path a <code>String</code> : l擾ElementXPath
   * @return a <code>String</code> : 擾l
   */
  public final static synchronized String getValueWithPath(Element elm, String path) {
    XPath xp = XPathFactory.newInstance().newXPath();
    try {
      return xp.evaluate(path, elm);
    } catch (XPathExpressionException xe) {
      xe.printStackTrace();
    }
    return null;
    
  }

  /**
   * Describe <code>searchElementWithPath</code> method : Element search by XPath.
   * <br><b>Element</b>XPathŎw肳ꂽ^O<code>(Element)</code>擾
   * @param argElm an <code>Element</code> : Element
   * @param path a <code>String</code> : 擾ElementXPath
   * @return an <code>Element</code> : ʂElement
   */
  public final static synchronized Element searchElementWithPath(Element argElm, String path) {
    if (path == null || path.length() == 0 || path.equals(".")) {
      return argElm;
    }
    XPath xp = XPathFactory.newInstance().newXPath();
    try {
      return (Element)xp.evaluate(path, argElm, XPathConstants.NODE);
    } catch (XPathExpressionException xe) {
      xe.printStackTrace();
    }
    return null;

  }

  /**
   * Describe <code>searchElement</code> method : Search Element With Value.
   * <br>l܂͑lňvdNodeListƂĖ߂B
   *
   * @param argElm
   * @param path
   * @return a <code>NodeList</code> :
   */
  public final static synchronized NodeList searchElement(Element argElm, String path) {
    if (argElm == null || path == null || path.length() < 1) {
      return null;
    }
    XPath xp = XPathFactory.newInstance().newXPath();
    try {
      return (NodeList)xp.evaluate(path, argElm, XPathConstants.NODESET);
    } catch (XPathExpressionException xe) {
      xe.printStackTrace();
    }
    return null;
  }


  /**
   * Describe <code>deleteElement</code> method : Delete Element from Element.
   * <br>w肵ElementnꂽElement폜B
   * @param argElm an <code>Element</code> : 폜ƂElement
   * @param path a <code>String</code> : 폜ElementXPath
   */
  public final static synchronized void deleteElement(Element argElm, String path) {
    Element elm = searchElementWithPath(argElm, XPathUtil.getTagPath(path));
    if (XPathUtil.getAttrName(path) == null) {
      elm.getParentNode().removeChild(elm);
      return;
    }
    elm.removeAttribute(XPathUtil.getAttrName(path));
  }

  /**
   * Describe <code>deleteText</code> method : Delete Text from Element.
   * <br>w肳ꂽElementText<code>(TextNode)</code>폜B
   * @param argElm an <code>Element</code> : Text폜Element܂Element
   * @param path a <code>String</code> : Text폜ElementXPath
   */
  public final static synchronized void deleteText(Element argElm, String path) {
    Element elm = searchElementWithPath(argElm, path);
    elm.removeChild(elm.getFirstChild());
  }

  /**
   * Describe <code>generateXPath</code> method : Generate XPath String from Element Node.
   * <br>nꂽ<code>org.w3c.dom.Node</code>̃[gGgXPath𐶐B
   * @param nd a <code>Node</code> : XPath𐶐<code>Node</code>
   * @return a <code>String</code> : XPath
   */
  public final static synchronized String generateXPath(Node nd) {
    if (nd == null) {
      return "";
    }
    StringBuffer sb = new StringBuffer();
    if (nd.getNodeType() == Node.TEXT_NODE) {
      nd = nd.getParentNode();
    }
    if (nd.getNodeType() != Node.ELEMENT_NODE) {
//      System.out.println(nd.getNodeType());
      return nd.getNodeName();
    }
    if (nd.getParentNode() != null && nd.getParentNode().getNodeType() != Node.DOCUMENT_NODE) {
      sb.append(generateXPath(nd.getParentNode()));
      sb.append("/");
    }
    sb.append(nd.getNodeName());
    //JԂElement̑Ή
    Node prevNd = XmlUtil.getPreviousElement(nd);
    Node nextNd = XmlUtil.getNextElement(nd);
    if ((prevNd != null && prevNd.getNodeName().equals(nd.getNodeName())) ||
        (nextNd != null && nextNd.getNodeName().equals(nd.getNodeName()))) {
      int pos = 0;
      while (prevNd != null && prevNd.getNodeName().equals(nd.getNodeName())) {
        pos++;
        prevNd = XmlUtil.getPreviousElement(prevNd);
      }
      sb.append("[");
      sb.append(pos);
      sb.append("]");
    }

    return sb.toString();
  }

  //--------------------------------------------------------------------
  //  Declear private methods
  //--------------------------------------------------------------------
  /**
   * Describe <code>getElementWithPath</code> method : Element get and Create.
   * <br><b>doc</b>XPath`Ŏw肳ꂽ<code>Element</code>A
   * ߂܂B
   * <br>XPahtŐݒ肳ꂽ^O݂Ȃꍇ́A܂B
   * @param elm an <code>Element</code> : 삷Element
   * @param path a <code>String</code> : 擾ElementXPath
   * @return an <code>Element</code> : ʂElement
   */
  private static synchronized Element getElementWithPath(Element elm, String path)
    throws Exception {
    if (path == null || path.length() == 0 || path.equals(".")) {
      return elm;
    }

    StringTokenizer strt = new StringTokenizer(path, "/");
    Document ddm = XmlUtil.createDocument();

    XPath xp = XPathFactory.newInstance().newXPath();
    while (strt.hasMoreTokens()) {
      String tagName = strt.nextToken();
      Element elm2 = null;
      if (tagName.indexOf("[") < 0) {
        elm2 = (Element)xp.evaluate(tagName, elm, XPathConstants.NODE);
        if (elm2 == null) {
          elm2 = ddm.createElement(tagName);
          elm.appendChild(elm2);
        }
      }
      else {
        elm2 = (Element)xp.evaluate(tagName, elm, XPathConstants.NODE);
        while (elm2 == null) {
          elm2 = ddm.createElement(tagName.substring(0, tagName.indexOf("[")));
          elm.appendChild(elm2);
          elm2 = (Element)xp.evaluate(tagName, elm, XPathConstants.NODE);
        }
      }
      elm = elm2;
    }
    ddm = null;
    return elm;
  }

  /**
   * Describe <code>getTagPath</code> method : return Tag Name.
   * <br>Agr[g̎w肪ꍇɂ̒Õ^O߂B
   * <br> aaa/bbb/@attr ̂Ƃ aaa/bbb ߂B
   * @param xpath a <code>String</code> : Xpath̕
   * @return a <code>String</code> : ^O܂łXPath̕
   */
  private static synchronized String getTagPath(String xpath) {
    if (xpath.indexOf("/@") < 0) {
      return xpath;
    }
    return  xpath.substring(0,xpath.indexOf("/@"));
  }

  /**
   * Describe <code>getAttrName</code> method : return Attribute Name.
   * <br>Agr[gw肪ꍇɃAgr[g߂BAgr[g̎w肪Ȃꍇ<code>null</code>l߂܂B
   * <br> aaa/bbb/@ccc ̂Ƃ ccc ߂B
   * @param xpath a <code>String</code> : Xpath̕
   * @return a <code>String</code> : Agr[g
   */
  private static synchronized String getAttrName(String xpath) {
    if (xpath.indexOf("/@") < 0) {
      return null;
    }
    return  xpath.substring(xpath.indexOf("/@") + 2);
  }

}
