package com.hamaf.hikyakucms.sample.schedule.process;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyakucms.sample.schedule.access.SqlExec;
import com.hamaf.hikyakucms.sample.schedule.access.TargetAccess;
import com.hamaf.hikyakucms.sample.schedule.access.TargetAccess.TARGET_KBN;
import com.hamaf.hikyakucms.sample.schedule.dto.TargetDto;
import com.hamaf.hikyakucms.sample.schedule.dto.TargetSearchDto;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.PreparedItems;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.GroupDto;
import com.hamaf.hikyaku.security.dto.UserDto;

/**
 * <p>^CgFTargetProcess is .</p>
 * <p>FΏۃe[u֌W̏s</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/02/16</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class TargetProcess {

	private TargetAccess _ta = null;
	private SqlExec _se= null;
	private SecurityCheckUtils _scu = null;
	/**
	 * Creates a new <code>TargetProcess.java</code> instance.
	 * <br>Default Constructor
	 */
	public TargetProcess() {
		_ta = new TargetAccess();
		_se = new SqlExec();
		_scu = new SecurityCheckUtils();

//		_ta.setDebug();
	}

	/**
	 * Describe <code>find</code> method : .
	 * <br>Ώۃe[ǔB
	 *
	 * @param tsd a <code>TargetSearchDto</code>
	 * @return a <code>TargetSearchDto</code>
	 * @throws Exception
	 */
	public TargetSearchDto find(TargetSearchDto tsd) throws Exception {
		return (TargetSearchDto)_ta.find(tsd);
	}

	/**
	 * Describe <code>findKeys</code> method : .
	 * <br>Ώۃe[uAL[̈ꗗ߂B
	 *
	 * @param uid a <code>String</code> : user-id
	 * @param sysId  a <code>String</code> : vOCID
	 * @param kbn a <code>TARGET_KBN</code>
	 * @return a <code>List&lt;List&lt;String&gt;&gt; : L[̈ꗗ
	 * @throws Exception
	 */
	public List<List<String>> findKeys(String uid, String sysId, TARGET_KBN kbn) throws Exception {
		TargetSearchDto tsd = new TargetSearchDto();
		tsd.setRetrieveValue(TargetSearchDto.USER_ID, uid);
		tsd.setRetrieveValue(TargetSearchDto.KUBUN, kbn.getValue());
		tsd.setSysId(sysId);
		tsd.setOrderItem(TargetSearchDto.SEQ, 1);
		tsd.setOrderItem(TargetSearchDto.TARGET_ID, 2);
		tsd = (TargetSearchDto)_ta.find(tsd);
		return tsd.getKeys();
	}

	/**
	 * Describe <code>findTarget</code> method : .
	 * <br>Ώۃe[uAΏۃf[^̈ꗗ߂B
	 *
	 * @param uid a <code>String</code> : user-id
	 * @param sysId  a <code>String</code> : vOCID
	 * @param kbn a <code>TARGET_KBN</code>
	 * @return a <code>List&lt;String&gt; : ^[Qbg̈ꗗ
	 * @throws Exception
	 */
	public List<String> findTarget(String uid, String sysId, TARGET_KBN kbn) throws Exception {
		List<List<String>> keys = findKeys(uid, sysId, kbn);
		List<String> ret = new ArrayList<String>();
		for (List<String> key : keys) {
			ret.add(key.get(2));
		}
		return ret;
	}

	/**
	 * Describe <code>findByPrimaryKey</code> method : .
	 * <br>Ώۃe[ȕڍׂ擾B
	 *
	 * @param td a <code>TargetDto</code>
	 * @return a <code>TargetDto</code>
	 * @throws Exception
	 */
	public TargetDto findByPrimaryKey(TargetDto td) throws Exception {
		String svusr = td.getCommFld(COMMFLD.UUSR);
		td.clearRequest(TargetDto.NAME);
		td = (TargetDto)_ta.findByPrimaryKey(td);
		if (td.getItemValue(TargetDto.KUBUN).equals(TARGET_KBN.GROUP.getValue())) {
			GroupDto gd = _scu.getGroupInf(td.getItemValue(TargetDto.TARGET_ID), td.getCommFld(COMMFLD.UUSR));
			td.setItemValue(TargetDto.NAME,gd.getItemValue(GroupDto.NAME));
		} else {
			if (td.getItemValue(TargetDto.TARGET_ID).equals(svusr)) {
				UserDto ud = _scu.getUserInf(td.getItemValue(TargetDto.USER_ID), td.getCommFld(COMMFLD.UUSR));
				td.setItemValue(TargetDto.NAME,ud.getItemValue(UserDto.NAME));
			} else {
				UserDto ud = _scu.getUserInf(td.getItemValue(TargetDto.TARGET_ID), td.getCommFld(COMMFLD.UUSR));
				td.setItemValue(TargetDto.NAME,ud.getItemValue(UserDto.NAME));
			}
		}
		return td;
	}

	/**
	 * Describe <code>getUser2Group</code> method : .
	 * <br>[U[O[v̏߂B
	 * <br> {O[vID, , O[vCode}̈ꗗ`
	 *
	 * @param uid a <code>String</code> : [U[ID
	 * @return a <code>List&lt;List&lt;String&gt;&gt;</code> : ΏۃO[v̈ꗗ
	 * @throws Exception
	 */
	public List<List<String>> getUser2Group(String uid) throws Exception {
		List<List<String>> ret = new ArrayList<List<String>>();
		List<String> gids = _scu.getGroupByUser(uid);
		for (String gid : gids) {
			GroupDto gd = _scu.getGroupInf(gid, uid);
			List<String > dt = new ArrayList<String>();
			dt.add(gid);
			dt.add(gd.getItemValue(GroupDto.NAME));
			dt.add(gd.getItemValue(GroupDto.GROUP_CODE));
			ret.add(dt);
		}
		return ret;
	}

	/**
	 * Describe <code>getUserInGroup</code> method : .
	 * <br>O[vɎw肳ꂽ[U[̈ꗗ߂B
	 * <br> {[U[ID, , , gD}̈ꗗ`
	 *
	 * @param groups  a <code>List&lt;String&gt;</code> : O[vID̈ꗗ
	 * @param uid a <code>String</code> : v҂̃[U[ID
	 * @return a <code>List&lt;List&lt;String&gt;&gt;</code> : Ώۃ[U[̈ꗗ
	 * @throws Exception
	 */
	public List<List<String>> getUserInGroup(List<String> groups, String uid) throws Exception {
		List<List<String>> ret = new ArrayList<List<String>>();
		List<String> users = _scu.getUserInGp(groups);
		for (String user : users) {
			UserDto ud = _scu.getUserInf(user, uid);
			List<String > dt = new ArrayList<String>();
			dt.add(user);
			dt.add(ud.getItemValue(UserDto.NAME));
			dt.add(ud.getItemValue(UserDto.ABBREV));
			dt.add(ud.getItemValue(UserDto.ORGANIZATION));
			ret.add(dt);
		}
		return ret;
	}

	/**
	 * Describe <code>getUsers</code> method : .
	 * <br>\Ώێ҂̈ꗗ߂B
	 *
	 * @param uid  a <code>String</code> : v҂̃[U[ID
	 * @param sysId  a <code>String</code> : vOCID
	 * @return a <code>List&lt;String&gt;</code> : Ώۃ[U[̈ꗗ
	 * @throws Exception
	 */
	public List<String> getUsers(String uid, String sysId) throws Exception {
		List<String> uids = findTarget(uid, sysId, TARGET_KBN.USER);
		List<String> tgts = findTarget(uid, sysId, TARGET_KBN.GROUP);
		if (tgts.size() == 0) tgts = _scu.getGroupByUser(uid);
		List<String> gusr = _scu.getUserInGp(tgts);
		for (String uiddt : gusr) {
			if (!uids.contains(uiddt)) uids.add(uiddt);
		}
		return uids;
	}

	/**
	 * Describe <code>add</code> method : .
	 * <br>Ώۃe[u֓o^B
	 *
	 * @param td a <code>TargetDto</code>
	 * @throws Exception
	 */
	public void add(TargetDto td) throws Exception {
		td.clearRequest(TargetDto.NAME);
		td.setItemValue(TargetDto.NAME, null);
		_ta.regist(td);
	}

	/**
	 * Describe <code>addTarget</code> method : .
	 * <br>Ώۃe[u֓o^B
	 *
	 * @param uid  a <code>String</code> : [U[ID
	 * @param target  a <code>String</code> : ΏID
	 * @param seq  a <code>String</code> : \
	 * @param kbn  a <code>TARGET_KBN</code> :
	 * @param sysId  a <code>String</code> : vOCID
	 * @throws Exception
	 */
	public void addTarget(String uid, String target, String seq, TARGET_KBN kbn, String sysId) throws Exception {
		TargetDto td = new TargetDto();
		td.setItemValue(TargetDto.USER_ID, uid);
		td.setItemValue(TargetDto.KUBUN, kbn.getValue());
		td.setItemValue(TargetDto.TARGET_ID, target);
		td.setItemValue(TargetDto.SEQ, seq);
		td.setSysId(sysId);
		_ta.regist(td);
	}

	/**
	 * Describe <code>updateGroup</code> method : .
	 * <br>Ώۃe[ũO[vXVB
	 *
	 * @param uid   a <code>String</code> : [U[ID
	 * @param group a <code>List&lt;String&gt;</code> : ΏۃO[ṽXg
	 * @param sysId  a <code>String</code> : vOCID
	 * @throws Exception
	 */
	public void updateGroup(String uid, List<String> group, String sysId) throws Exception {
		PreparedItems pi = new PreparedItems();
    pi.setSysId(sysId);
    Map<String, Object> pm = new HashMap<String, Object>();
    pm.put("USER_ID", uid);
    pi.addParam(pm);
//    _se.setDebug();
    _se.deleteTarget(pi);

    int i = 0;
    for (String grp : group) {
    	i++;
			addTarget(uid, grp, String.valueOf(i), TARGET_KBN.GROUP, sysId);
		}
	}

	/**
	 * Describe <code>delete</code> method : .
	 * <br>Ώۃe[u̍폜B
	 *
	 * @param td a <code>TargetDto</code>
	 * @throws Exception
	 */
	public void delete(TargetDto td) throws Exception {
		_ta.deleteNoExclusion(td);
	}
}
