package com.hamaf.hikyakucms.sample.schedule.ui;

import com.hamaf.hikyakucms.sample.schedule.dto.CategoryDto;
import com.hamaf.hikyakucms.sample.schedule.process.CategoryProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.CategoryMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFCategoryUpdate is .</p>
 * <p>FJeS[̍XV</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/01/31</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class CategoryUpdate extends StandardCheckAndUpdate {

	private CategoryProcess _cp = null;

	/**
	 * Creates a new <code>CategoryUpdate.java</code> instance.
	 * <br>Default Constructor
	 */
	public CategoryUpdate() {
		_jim = new CategoryMap();
		_cp = new CategoryProcess();
	}

	private final String UPD_KBN = "upkbn";
	private final String MSG_OK = "updateok";
	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	protected CommonMessage callControl(DetailItemsInterface dii, CommonMessage msg)
			throws Exception {
		String kbn = msg.getReqStr(UPD_KBN);
		if (kbn.equals("a")) {
			_cp.regist((CategoryDto)dii);
			msg.setResMsg(MSG_OK, "1");
			return msg;
		}
		CategoryDto cd = new CategoryDto();
		cd.setItemValue(CategoryDto.CATEGORY_ID, dii.getItemValue(CategoryDto.CATEGORY_ID));
		cd.setSysId(dii.getSysId());
		cd = _cp.getDetail(cd);
		cd.setItemValue(CategoryDto.CATEGORY_NAME, dii.getItemValue(CategoryDto.CATEGORY_NAME));
		cd.setItemValue(CategoryDto.COLOR, dii.getItemValue(CategoryDto.COLOR));
//		cd.setItemValue(CategoryDto.USER_ID, dii.getItemValue(CategoryDto.USER_ID));
		_cp.update(cd);
		msg.setResMsg(MSG_OK, "1");
		return msg;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new CategoryDto();
	}

}
