package com.hamaf.hikyakucms.sample.schedule.ui;

import com.hamaf.hikyakucms.sample.schedule.dto.ScheduleSearchDto;
import com.hamaf.hikyakucms.sample.schedule.dto.VScheduleDto;
import com.hamaf.hikyakucms.sample.schedule.process.ScheduleProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.VScheduleMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.security.access.UserAccess.USER_TYPE;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFDailyList is .</p>
 * <p>F̌lXPW[̕\</p>
 * <br>NGXgp[^'day'̓t'offset','unit'̒lɑΉt̃XPW[񋟂B
 * <br>'day'ꍇ́A{ΏۓƂ܂B
 * <br>'unit''D'(),'M'(),'Y'(N)̉ꂩŎw肵܂B
 *
 * <p>쌠: Copyright (c) 2010/07/12</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class DailyList extends StandardListProcess {

  private final String REQ_DAY = "day";
  private final String REQ_WEEK = "week";
  private final String REQ_OFF = "offset";
  private final String REQ_UNIT = "unit";
  private final String RES_GUEST = "guest";
  private final String RES_UID = "uid";
  private final String RES_UNAME = "uname";

  private ScheduleProcess _sp;

  /**
   *  Creates a new <code>DailyList.java</code> instance.
   * <br>Default Constructor
   */
  public DailyList() {
    _sp = new ScheduleProcess();
    _jim = new VScheduleMap();
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface sd)
      throws Exception {
    return _sp.findviewbykey((VScheduleDto)sd, super.getUserID());
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface arg0) {
    return null;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface ssd)
      throws Exception {
    return _sp.find((ScheduleSearchDto)ssd);
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VScheduleDto();
  }

  private String _bday = null;
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList kyl)
      throws IllegalRetrieveDataException {
    ScheduleSearchDto ssd = new ScheduleSearchDto();
    ssd.setRetrieveValue(ScheduleSearchDto.USER_ID, kyl.getRetrieve(RES_UID));
    ssd.setRetrieveValue(ScheduleSearchDto.DAY, _bday);
    ssd.setOrderItem(ScheduleSearchDto.TIME_FROM, 1);
    ssd.setOrderItem(ScheduleSearchDto.TIME_TO, 2);
    return ssd;
  }

  /* (Javadoc Ȃ)
	 * @see com.hamaf.hikyaku.ui.ListProcessBase#spareAction(com.hamaf.hikyaku.dataobject.CommonMessage, java.lang.String)
	 */
	@Override
	protected CommonMessage spareAction(CommonMessage msg, String act)
			throws Exception {
    _bday = _sp.compDay(msg.getReqStr(REQ_DAY), msg.getReqStr(REQ_OFF), msg.getReqStr(REQ_UNIT));
    msg.setResMsg(REQ_DAY, _bday);
    String[] dts = {_bday};
    msg.setReq(REQ_DAY, dts);
    String yobi = "(" + DateUtil.getYoubi(_bday) + ")";
    msg.setResMsg(REQ_WEEK, yobi);
    dts[0] = yobi;
    msg.setReq(REQ_WEEK, dts);
    msg.setResMsg(REQ_OFF, "0");
    dts[0] = "0";
    msg.setReq(REQ_OFF, dts);
    msg.setResMsg(REQ_UNIT, "D");
    dts[0] = "D";
    msg.setReq(REQ_UNIT, dts);
    UserDto ud = super.getUerDto();
    if (!ud.getItemValue(UserDto.USER_TYPE).equals(USER_TYPE.GENERAL.getVal())) {
      msg.setResMsg(RES_GUEST, "1");
    }
  	String uid = msg.getReq(RES_UID);
  	if (uid == null || uid.length() == 0) {
  		msg.setResMsg(RES_UID, ud.getItemValue(UserDto.USER_ID));
  		dts[0] = ud.getItemValue(UserDto.USER_ID);
  		msg.setReq(RES_UID, dts);
  		msg.setResMsg(RES_UNAME, ud.getItemValue(UserDto.NAME));
  		dts[0] = ud.getItemValue(UserDto.NAME);
  		msg.setReq(RES_UNAME, dts);
  	}
		return msg;
	}

}
