package com.hamaf.hikyakucms.sample.schedule.ui;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyakucms.sample.schedule.dto.ScheduleSearchDto;
import com.hamaf.hikyakucms.sample.schedule.dto.VScheduleDto;
import com.hamaf.hikyakucms.sample.schedule.process.ScheduleProcess;
import com.hamaf.hikyakucms.sample.schedule.process.TargetProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.VScheduleMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFGroupDayList is .</p>
 * <p>F̃O[vXPW[̕\</p>
 * <br>NGXgp[^'day'̓t'offset','unit'̒lɑΉt̃XPW[񋟂B
 * <br>'day'ꍇ́A{ΏۓƂ܂B
 * <br>'unit''D'(),'M'(),'Y'(N)̉ꂩŎw肵܂B
 *
 * <p>쌠: Copyright (c) 2011/02/20</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class GroupDayList extends ProcessBase {

	private ScheduleProcess _sp = null;
	private TargetProcess _tp = null;
	private VScheduleMap _sm = null;
	private SecurityCheckUtils _scu = null;
	/**
	 * Creates a new <code>GroupDayList.java</code> instance.
	 * <br>Default Constructor
	 */
	public GroupDayList() {
		_sp = new ScheduleProcess();
		_tp = new TargetProcess();
		_sm = new VScheduleMap();
		_scu = new SecurityCheckUtils();
	}

	private final String REQ_DAY = "day";
  private final String REQ_OFF = "offset";
  private final String REQ_UNIT = "unit";
  private final String MSG_WEEK = "week";
	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	public CommonMessage exec(CommonMessage msg) throws Exception {
		List<String> uids = _tp.getUsers(getUserID(), sysId);
    String bday = _sp.compDay(msg.getReqStr(REQ_DAY), msg.getReqStr(REQ_OFF), msg.getReqStr(REQ_UNIT));
    for (String uid : uids) {
			msg = searchSchedule(uid, bday, msg);
		}

    msg.setResMsg(REQ_DAY, bday);
    msg.setResMsg(MSG_WEEK, DateUtil.getYoubi(bday));
    msg.setResMsg(REQ_OFF, "0");

		return msg;
	}

	private CommonMessage searchSchedule(String uid, String date, CommonMessage msg) throws Exception {
		ScheduleSearchDto ssd = new ScheduleSearchDto();
		ssd.setRetrieveValue(ScheduleSearchDto.USER_ID, uid);
		ssd.setRetrieveValue(ScheduleSearchDto.DAY, date);
    ssd.setOrderItem(ScheduleSearchDto.TIME_FROM, 1);
    ssd.setOrderItem(ScheduleSearchDto.TIME_TO, 2);
		ssd.setSysId(sysId);
		ssd = _sp.find(ssd);
		VScheduleDto sd = new VScheduleDto();
		sd.setItemValue(VScheduleDto.USER_ID, uid);
		sd.setAllRequest();
		sd.setSysId(sysId);
		if (ssd.getKeys().size() == 0) {
			msg.addResList(setDisplayItems(sd));
		} else {
			for (List<String> keys : ssd) {
				sd.setItemValue(VScheduleDto.SEQNO, keys.get(1));
				sd = _sp.findviewbykey(sd, getUserID());
				msg.addResList(setDisplayItems(sd));
			}
		}
		return msg;
	}

	private final String MSG_NAME = "username";
  private Map<String, String> setDisplayItems(DetailItemsInterface dii) throws Exception {
    Map<String, String> ret = new HashMap<String, String>();
    for (String kv : _sm) {
    	ret.put(kv, dii.getItemValue(_sm.getDtoNo(kv)));
    }
    UserDto ud = _scu.getUserInf(dii.getItemValue(VScheduleDto.USER_ID), getUserID());
    String rnm = ud.getItemValue(UserDto.ABBREV);
    if (rnm ==  null || rnm.length() == 0) {
    	ret.put(MSG_NAME, ud.getItemValue(UserDto.NAME));
    } else {
    	ret.put(MSG_NAME, rnm);
    }
    return ret;
  }

}
