package com.hamaf.hikyakucms.sample.schedule.ui;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.GroupDto;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFGroupSel is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/02/19</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class GroupSel extends ProcessBase {

	private SecurityCheckUtils _scu = null;
	/**
	 * Creates a new <code>GroupSel.java</code> instance.
	 * <br>Default Constructor
	 */
	public GroupSel() {
		_scu = new SecurityCheckUtils();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	public CommonMessage exec(CommonMessage msg) throws Exception {
		List<String> grpdt = new ArrayList<String>();
		String uid = getUserID();
		List<String> grps = _scu.getGroupByUser(uid);
		for (String grp : grps) {
			if (!grpdt.contains(grp)) {
				grpdt.add(grp);
			}
			List<String> cgp = _scu.getAllChildren(grp);
			for (String elm : cgp) {
				if (!grpdt.contains(elm)) {
					grpdt.add(elm);
				}
			}
		}
		for (String key : grpdt) {
			GroupDto gd = _scu.getGroupInf(key, uid);
			Map<String, String> rdt = new HashMap<String, String>();
			rdt.put("idVal", gd.getItemValue(GroupDto.GROUP_ID));
			rdt.put("nameVal", gd.getItemValue(GroupDto.NAME));
			rdt.put("sort", gd.getItemValue(GroupDto.GROUP_CODE));
			msg.addResList(rdt);
		}
		return msg;
	}

}
