package com.hamaf.hikyakucms.sample.schedule.ui;

import com.hamaf.hikyakucms.sample.schedule.dto.HolidayDto;
import com.hamaf.hikyakucms.sample.schedule.dto.HolidaySearchDto;
import com.hamaf.hikyakucms.sample.schedule.process.HolidayProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.HolidayMap;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFHolidayList is .</p>
 * <p>Fjꗗ\</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/01/29</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class HolidayList extends StandardListProcess {

	private HolidayProcess _hp = null;

	/**
	 * Creates a new <code>HolidayList.java</code> instance.
	 * <br>Default Constructor
	 */
	public HolidayList() {
		_jim = new HolidayMap();
		_hp = new HolidayProcess();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected DetailItemsInterface callControl(DetailItemsInterface dii)
			throws Exception {
		return _hp.getDetail((HolidayDto)dii);
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected String[] checkDelete(DetailItemsInterface dii) {
		if (delCheck(dii)) {
      String[] ret = {"holiday", super.resource.getString("DelLine")};
      return ret;
		}
		return null;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
	 */
	@Override
	protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
			throws Exception {
		return _hp.find((HolidaySearchDto)rki);
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new HolidayDto();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
	 */
	@Override
	protected RetrieveKeysInterface setRetrieveVal(KeyList kl)
			throws IllegalRetrieveDataException {
		HolidaySearchDto hsd = new HolidaySearchDto();
		String year = kl.getRetrieve("syear");
		if (year == null || year.length() == 0) {
			year = DateUtil.getYear();
			kl.getRetrieveAll().put("syear", year);
		}
		hsd.setRetrieveValue(HolidaySearchDto.YEAR, year);
		hsd.setOrderItem(HolidaySearchDto.MMDD, 1);
		return hsd;
	}

}
