package com.hamaf.hikyakucms.sample.sns.access;

import java.sql.SQLException;
import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyaku.access.ExclusionException;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyakucms.sample.sns.dto.CommunicationDto;

/**
 * <p>^CgFCommunicationAccess is .</p>
 * <p>FAe[ũANZXNX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/02/28</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class CommunicationAccess extends DefaultTableAccess {

  private final String TBLNM = "M_COMMUNICATION";
  private final String PARM = "hsmpl";

  /**
   * Creates a new <code>CommunicationAccess.java</code> instance.
   * <br>Default Constructor
   */
  public CommunicationAccess() {
    tableName = TBLNM;
    connectionParameter = PARM;
//    setDebug();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#regist(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void regist(DetailItemsInterface dii) throws SQLException {
    dii = completionDto(dii);
    super.regist(dii);
  }
  private DetailItemsInterface completionDto(DetailItemsInterface cd) {
    if (cd.isRequestItem(CommunicationDto.DAY_FROM) &&
        cd.getItemValue(CommunicationDto.DAY_FROM).length() != 10)
      cd.setItemValue(CommunicationDto.DAY_FROM, "0001/01/01");
    if (cd.isRequestItem(CommunicationDto.DAY_TO) &&
        cd.getItemValue(CommunicationDto.DAY_TO).length() != 10)
      cd.setItemValue(CommunicationDto.DAY_TO, "9999/12/31");
    if (cd.isRequestItem(CommunicationDto.DETAIL)) {
      String dtl = cd.getItemValue(CommunicationDto.DETAIL);
      if (dtl != null && dtl.length() > 0) cd.setItemValue(CommunicationDto.RET_DETAIL, dtl.replaceAll("<.+?>", ""));
    }
    return cd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#update(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void update(DetailItemsInterface dii) throws ExclusionException,
      SQLException {
    dii = completionDto(dii);
    super.update(dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#updateNoExclusion(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void updateNoExclusion(DetailItemsInterface dii) throws SQLException {
    dii = completionDto(dii);
    super.updateNoExclusion(dii);
  }



}
