package com.hamaf.hikyakucms.sample.sns.access;

import java.sql.SQLException;
import com.hamaf.hikyaku.access.DefaultTableAccess;
import com.hamaf.hikyaku.access.ExclusionException;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;

/**
 * <p>^CgFEnqueteAccess is .</p>
 * <p>FAP[ge[ũANZXNX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/25</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class EnqueteAccess extends DefaultTableAccess {

  private final String TBLNM = "M_ENQUETE";
  private final String TBLNMV = "V_ENQUETE_SEARCH";
  private final String PARM = "hsmpl";

  /**
   * Creates a new <code>EnqueteAccess.java</code> instance.
   * <br>Default Constructor
   */
  public EnqueteAccess() {
    connectionParameter = PARM;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#find(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  public RetrieveKeysInterface find(RetrieveKeysInterface rki)
      throws SQLException {
    tableName = TBLNMV;
    return super.find(rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#findByPrimaryKey(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public DetailItemsInterface findByPrimaryKey(DetailItemsInterface dii)
      throws SQLException {
    tableName = TBLNM;
    return super.findByPrimaryKey(dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#regist(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void regist(DetailItemsInterface dii) throws SQLException {
    tableName = TBLNM;
    super.regist(dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#update(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void update(DetailItemsInterface dii) throws ExclusionException,
      SQLException {
    tableName = TBLNM;
    super.update(dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#updateNoExclusion(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void updateNoExclusion(DetailItemsInterface dii) throws SQLException {
    tableName = TBLNM;
    super.updateNoExclusion(dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#delete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void delete(DetailItemsInterface dii) throws ExclusionException,
      SQLException {
    tableName = TBLNM;
    super.delete(dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.access.DefaultTableAccess#deleteNoExclusion(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  public void deleteNoExclusion(DetailItemsInterface dii) throws SQLException {
    tableName = TBLNM;
    super.deleteNoExclusion(dii);
  }

}
