package com.hamaf.hikyakucms.sample.sns.access;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.access.MultipleTableAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.AppendFileDto;
import com.hamaf.hikyakucms.sample.sns.dto.AppendFileSearchDto;
import com.hamaf.hikyakucms.sample.sns.dto.CommunicationDto;
import com.hamaf.hikyakucms.sample.sns.dto.RestrictionDto;
import com.hamaf.hikyakucms.sample.sns.dto.RestrictionSearchDto;

/**
 * <p>^CgFModifyCommunication is .</p>
 * <p>FAe[u֘A̍XV</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/01</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class ModifyCommunication extends MultipleTableAccess {

  private final String TBLCM = "M_COMMUNICATION";
  private final String TBLRS = "M_RESTRICTION";
  private final String TBLAF = "M_APPEND_FILE";
  private final String PARM = "hsmpl";

  /**
   * Creates a new <code>ModifyCommunication.java</code> instance.
   * <br>Default Constructor
   */
  public ModifyCommunication() {
    connectionParameter = PARM;
//    setDebug();
  }

  /**
   * Describe <code>addCommunication</code> method : .
   * <br>A̓o^B
   *
   * @param cd a <code>CommunicationDto</code> :
   * @throws Exception
   */
  public void addCommunication(CommunicationDto cd) throws Exception {
    cd = CompletionDto(cd);
    regist(TBLCM, cd);
  }
  private CommunicationDto CompletionDto(CommunicationDto cd) {
    if (cd.isRequestItem(CommunicationDto.DAY_FROM) &&
        cd.getItemValue(CommunicationDto.DAY_FROM).length() != 10)
      cd.setItemValue(CommunicationDto.DAY_FROM, "0001/01/01");
    if (cd.isRequestItem(CommunicationDto.DAY_TO) &&
        cd.getItemValue(CommunicationDto.DAY_TO).length() != 10)
      cd.setItemValue(CommunicationDto.DAY_TO, "9999/12/31");
    if (cd.isRequestItem(CommunicationDto.DETAIL)) {
      String dtl = cd.getItemValue(CommunicationDto.DETAIL);
      if (dtl != null && dtl.length() > 0) cd.setItemValue(CommunicationDto.RET_DETAIL, dtl.replaceAll("<.+?>", ""));
    }
    return cd;
  }

  /**
   * Describe <code>modCommunication</code> method : .
   * <br>A̍XVB
   *
   * @param cd a <code>CommunicationDto</code> :
   * @throws Exception
   */
  public void modCommunication(CommunicationDto cd) throws Exception {
    cd = CompletionDto(cd);
    update(TBLCM, cd);
  }

  /**
   * Describe <code>delCommunication</code> method : .
   * <br>A̍폜B
   *
   * @param cd a <code>CommunicationDto</code> :
   * @throws Exception
   */
  public void delCommunication(CommunicationDto cd) throws Exception {
    delete(TBLCM, cd);
  }

  /**
   * Describe <code>addRestriction</code> method : .
   * <br>o^B
   *
   * @param cd a <code>CommunicationDto</code> :
   * @throws Exception
   */
  public void addRestriction(CommunicationDto cd) throws Exception {
    RestrictionDto rd = new RestrictionDto();
    rd.setItemValue(RestrictionDto.CATEGORY, HATSUBAN2_KBN.COMMUNICATION.getKey());
    rd.setItemValue(RestrictionDto.KEY_SEQNO, cd.getItemValue(CommunicationDto.SEQNO));
    rd.setSysId(cd.getSysId());
    List<String> dts = cd.getRestrictionList();
    for (String group : dts) {
      rd.setItemValue(RestrictionDto.GROUP_ID, group);
      regist(TBLRS, rd);
    }
  }

  /**
   * Describe <code>delRestrictionAll</code> method : .
   * <br>ASeqNoɊY鐧ׂč폜B
   *
   * @param seqno a <code>String</code> : ÃV[PXԍ
   * @param sysid a <code>String</code> : vOCID
   * @throws Exception
   */
  public void delRestrictionAll(String seqno, String sysid) throws Exception {
    RestrictionSearchDto rsd = new RestrictionSearchDto();
    rsd.setRetrieveValue(RestrictionSearchDto.CATEGORY, HATSUBAN2_KBN.COMMUNICATION.getKey());
    rsd.setRetrieveValue(RestrictionSearchDto.KEY_SEQNO, seqno);
    rsd.setSysId(sysid);
    RestrictionAccess ra = new RestrictionAccess();
    rsd = (RestrictionSearchDto)ra.find(rsd);
    RestrictionDto rd = new RestrictionDto();
    rd.setSysId(sysid);
    for (List<String> keys : rsd) {
      for (int j = 0; j < keys.size(); j++) {
        rd.setItemValue(j, keys.get(j));
      }
      deleteNoExclusion(TBLRS, rd);
    }
  }
  public void delRestrictionAll(CommunicationDto cd) throws Exception {
    delRestrictionAll(cd.getItemValue(CommunicationDto.SEQNO), cd.getSysId());
  }

  /**
   * Describe <code>delAppendFileAll</code> method : .
   * <br>ASeqNoɊYYtt@Cׂč폜B
   *
   * @param seqno a <code>String</code> : ÃV[PXԍ
   * @param sysid a <code>String</code> : vOCID
   * @return a <code>List&lt;String&gt;</code> : 폜t@C̎̃t@CpX̃Xg
   * @throws Exception
   */
  public List<String> delAppendFileAll(String seqno, String sysid) throws Exception {
    List<String> ret = new ArrayList<String>();
    AppendFileSearchDto afsd = new AppendFileSearchDto();
    afsd.setRetrieveValue(AppendFileSearchDto.KEY_SEQNO, seqno);
    afsd.setSysId(sysid);
    AppendFileAccess afa = new AppendFileAccess();
    afsd =(AppendFileSearchDto)afa.find(afsd);
    AppendFileDto afd = new AppendFileDto();
    afd.setSysId(sysid);
    for (List<String> keys : afsd) {
      for (int i = 0; i < keys.size(); i++) {
        afd.setItemValue(i, keys.get(i));
      }
      afd = (AppendFileDto)afa.findByPrimaryKey(afd);
      ret.add(afd.getItemValue(AppendFileDto.ENTITY_PATH));
      delete(TBLAF, afd);
    }
    return ret;
  }
  public List<String> delAppendFileAll(CommunicationDto cd) throws Exception {
    return delAppendFileAll(cd.getItemValue(CommunicationDto.SEQNO), cd.getSysId());
  }

  /**
   * Describe <code>delEntityFile</code> method : .
   * <br>w肳ꂽt@C폜B
   *
   * @param flnm a <code>String</code> : t@CpX
   */
  public void delEntityFile(String flnm) {
    File fl = new File(flnm);
    try {
      if (fl.exists()) fl.delete();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

}
