package com.hamaf.hikyakucms.sample.sns.access;

import java.io.File;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.access.MultipleTableAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerDto;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerSearchDto;
import com.hamaf.hikyakucms.sample.sns.dto.AppendFileDto;
import com.hamaf.hikyakucms.sample.sns.dto.AppendFileSearchDto;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.dto.QuestionDto;
import com.hamaf.hikyakucms.sample.sns.dto.QuestionSearchDto;
import com.hamaf.hikyakucms.sample.sns.dto.RestrictionDto;
import com.hamaf.hikyakucms.sample.sns.dto.RestrictionSearchDto;

/**
 * <p>^CgFModifyEnquete is .</p>
 * <p>FAP[ge[u֘A̍XV</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/25</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class ModifyEnquete extends MultipleTableAccess {

  private final String TBLEN = "M_ENQUETE";
  private final String TBLQU = "M_QUESTION";
  private final String TBLAN = "M_ANSWER";
  private final String TBLRS = "M_RESTRICTION";
  private final String TBLAF = "M_APPEND_FILE";
  private final String PARM = "hsmpl";

  /**
   * Creates a new <code>ModifyEnquete.java</code> instance.
   * <br>Default Constructor
   */
  public ModifyEnquete() {
    connectionParameter = PARM;
//  setDebug();
  }

  public void addEnquete(EnqueteDto ed) throws Exception {
    ed = CompletionDto(ed);
    regist(TBLEN, ed);
  }
  private EnqueteDto CompletionDto(EnqueteDto ed) {
    if (ed.isRequestItem(EnqueteDto.DAY_FROM) &&
        ed.getItemValue(EnqueteDto.DAY_FROM).length() != 10)
      ed.setItemValue(EnqueteDto.DAY_FROM, "0001/01/01");
    if (ed.isRequestItem(EnqueteDto.DAY_TO) &&
        ed.getItemValue(EnqueteDto.DAY_TO).length() != 10)
      ed.setItemValue(EnqueteDto.DAY_TO, "9999/12/31");
    return ed;
  }


  /**
   * Describe <code>modEnquete</code> method : .
   * <br>A̍XVB
   *
   * @param ed a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public void modEnquete(EnqueteDto ed) throws Exception {
    ed = CompletionDto(ed);
    update(TBLEN, ed);
  }

  /**
   * Describe <code>delEnquete</code> method : .
   * <br>A̍폜B
   *
   * @param ed a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public void delEnquete(EnqueteDto ed) throws Exception {
    deleteNoExclusion(TBLEN, ed);
  }

  /**
   * Describe <code>addQuestion</code> method : .
   * <br>⍀ڃe[uo^B
   *
   * @param ed a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public void addQuestion(EnqueteDto ed) throws Exception {
    QuestionDto qd = new QuestionDto();
    qd.setItemValue(QuestionDto.ENQUETE_SEQNO, ed.getItemValue(EnqueteDto.SEQNO));
    qd.setSysId(ed.getSysId());
    DecimalFormat df = new DecimalFormat("000");
    int i = 0;
    List<String[]> dts = ed.getQuestionList();
    for (String[] cont : dts) {
      i++;
      qd.setItemValue(QuestionDto.Q_SEQNO, df.format(i));
      qd.setItemValue(QuestionDto.CONTENTS, cont[0]);
      regist(TBLQU, qd);
    }
  }

  /**
   * Describe <code>delQuestionAll</code> method : .
   * <br>AP[gSeqNoɊY鎿⍀ڏׂč폜B
   *
   * @param ed a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public void delQuestionAll(EnqueteDto ed) throws Exception {
    QuestionSearchDto qsd = new QuestionSearchDto();
    qsd.setRetrieveValue(QuestionSearchDto.ENQUETE_SEQNO, ed.getItemValue(EnqueteDto.SEQNO));
    qsd.setSysId(ed.getSysId());
    QuestionAccess qa = new QuestionAccess();
    qsd = (QuestionSearchDto)qa.find(qsd);
    QuestionDto qd = new QuestionDto();
    qd.setSysId(ed.getSysId());
    for (List<String> keys : qsd) {
      for (int j = 0; j < keys.size(); j++) {
        qd.setItemValue(j, keys.get(j));
      }
      deleteNoExclusion(TBLQU, qd);
    }
  }

  /**
   * Describe <code>delAnswerAll</code> method : .
   * <br>AP[gSeqNoɊY𓚏ׂč폜B
   *
   * @param ed a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public void delAnswerAll(EnqueteDto ed) throws Exception {
    AnswerSearchDto asd = new AnswerSearchDto();
    asd.setRetrieveValue(AnswerSearchDto.ENQUETE_SEQNO, ed.getItemValue(EnqueteDto.SEQNO));
    asd.setSysId(ed.getSysId());
    AnswerAccess aa = new AnswerAccess();
    asd = (AnswerSearchDto)aa.find(asd);
    AnswerDto ad = new AnswerDto();
    ad.setSysId(ed.getSysId());
    for (List<String> keys : asd) {
      for (int i = 0; i < keys.size(); i++) {
        ad.setItemValue(i, keys.get(i));
      }
      deleteNoExclusion(TBLAN, ad);
    }
  }

  /**
   * Describe <code>addRestriction</code> method : .
   * <br>o^B
   *
   * @param ed a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public void addRestriction(EnqueteDto ed) throws Exception {
    RestrictionDto rd = new RestrictionDto();
    rd.setItemValue(RestrictionDto.CATEGORY, HATSUBAN2_KBN.ENRUETE.getKey());
    rd.setItemValue(RestrictionDto.KEY_SEQNO, ed.getItemValue(EnqueteDto.SEQNO));
    rd.setSysId(ed.getSysId());
    List<String> dts = ed.getRestrictionList();
    for (String group : dts) {
      rd.setItemValue(RestrictionDto.GROUP_ID, group);
      regist(TBLRS, rd);
    }
  }

  /**
   * Describe <code>delRestrictionAll</code> method : .
   * <br>ASeqNoɊY鐧ׂč폜B
   *
   * @param seqno a <code>String</code> : ÃV[PXԍ
   * @param sysid a <code>String</code> : vOCID
   * @throws Exception
   */
  public void delRestrictionAll(String seqno, String sysid) throws Exception {
    RestrictionSearchDto rsd = new RestrictionSearchDto();
    rsd.setRetrieveValue(RestrictionSearchDto.CATEGORY, HATSUBAN2_KBN.ENRUETE.getKey());
    rsd.setRetrieveValue(RestrictionSearchDto.KEY_SEQNO, seqno);
    rsd.setSysId(sysid);
    RestrictionAccess ra = new RestrictionAccess();
    rsd = (RestrictionSearchDto)ra.find(rsd);
    RestrictionDto rd = new RestrictionDto();
    rd.setSysId(sysid);
    for (List<String> keys : rsd) {
      for (int j = 0; j < keys.size(); j++) {
        rd.setItemValue(j, keys.get(j));
      }
      deleteNoExclusion(TBLRS, rd);
    }
  }
  public void delRestrictionAll(EnqueteDto ed) throws Exception {
    delRestrictionAll(ed.getItemValue(EnqueteDto.SEQNO), ed.getSysId());
  }

  /**
   * Describe <code>delAppendFileAll</code> method : .
   * <br>ASeqNoɊYYtt@Cׂč폜B
   *
   * @param seqno a <code>String</code> : ÃV[PXԍ
   * @param sysid a <code>String</code> : vOCID
   * @return a <code>List&lt;String&gt;</code> : 폜t@C̎̃t@CpX̃Xg
   * @throws Exception
   */
  public List<String> delAppendFileAll(String seqno, String sysid) throws Exception {
    List<String> ret = new ArrayList<String>();
    AppendFileSearchDto afsd = new AppendFileSearchDto();
    afsd.setRetrieveValue(AppendFileSearchDto.KEY_SEQNO, seqno);
    afsd.setSysId(sysid);
    AppendFileAccess afa = new AppendFileAccess();
    afsd =(AppendFileSearchDto)afa.find(afsd);
    AppendFileDto afd = new AppendFileDto();
    afd.setSysId(sysid);
    for (List<String> keys : afsd) {
      for (int i = 0; i < keys.size(); i++) {
        afd.setItemValue(i, keys.get(i));
      }
      afd = (AppendFileDto)afa.findByPrimaryKey(afd);
      ret.add(afd.getItemValue(AppendFileDto.ENTITY_PATH));
      delete(TBLAF, afd);
    }
    return ret;
  }
  public List<String> delAppendFileAll(EnqueteDto ed) throws Exception {
    return delAppendFileAll(ed.getItemValue(EnqueteDto.SEQNO), ed.getSysId());
  }

  /**
   * Describe <code>delEntityFile</code> method : .
   * <br>w肳ꂽt@C폜B
   *
   * @param flnm a <code>String</code> : t@CpX
   */
  public void delEntityFile(String flnm) {
    File fl = new File(flnm);
    try {
      if (fl.exists()) fl.delete();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
}
