package com.hamaf.hikyakucms.sample.sns.managerUi;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyakucms.sample.sns.dto.VCommunicationDto;
import com.hamaf.hikyakucms.sample.sns.dto.VCommunicationSearchDto;
import com.hamaf.hikyakucms.sample.sns.process.CommunicationProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.VCommunicationMap;

/**
 * <p>^CgFCommunicationList is .</p>
 * <p>FǗҗpAʒmꗗ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class CommunicationList extends StandardListProcess {

  private CommunicationProcess _cp = null;
  private boolean _ret = false;

  /**
   * Creates a new <code>CommunicationList.java</code> instance.
   * <br>Default Constructor
   */
  public CommunicationList() {
    _jim = new VCommunicationMap();
    _cp = new CommunicationProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl) throws IllegalRetrieveDataException {
    VCommunicationSearchDto vcsd = new VCommunicationSearchDto();
    if (keyl.getRetrieve("ret").length() == 0) return vcsd;

    _ret = true;
    vcsd.setRetrieveValue(VCommunicationSearchDto.GENRE, keyl.getRetrieve("sgener"));
    vcsd.setRetrieveValue(VCommunicationSearchDto.MANAGER, keyl.getRetrieve("smanager"));
    vcsd.setRetrieveValue(VCommunicationSearchDto.CHECK_FLG, keyl.getRetrieve("scheck"));
    vcsd.setRetrieveValue(VCommunicationSearchDto.GROUP_ID, keyl.getRetrieve("sgroup"));
    if (keyl.getRetrieve("sdayf").length() > 0) {
      vcsd.setRetrieveValue(VCommunicationSearchDto.DAY_FROM, keyl.getRetrieve("sdayf"));
      vcsd.setCondition(VCommunicationSearchDto.DAY_FROM, "<=");
    }
    if (keyl.getRetrieve("sdayt").length() > 0) {
      vcsd.setRetrieveValue(VCommunicationSearchDto.DAY_TO, keyl.getRetrieve("sdayt"));
      vcsd.setCondition(VCommunicationSearchDto.DAY_TO, "<=");
    }
    String sval = keyl.getRetrieve("sval");
    if (sval != null && sval.length() > 0) {
      sval = "%" + sval + "%";
      vcsd.setRetrieveValue(VCommunicationSearchDto.RETVAL, sval);
      vcsd.setCondition(VCommunicationSearchDto.RETVAL, "LIKE");
    }
    sval = keyl.getRetrieve("sentryName");
    if (sval != null && sval.length() > 0) {
      sval = "%" + sval + "%";
      vcsd.setRetrieveValue(VCommunicationSearchDto.ENTRY_NAME, sval);
      vcsd.setCondition(VCommunicationSearchDto.ENTRY_NAME, "LIKE");
    }
    vcsd.setOrderItem(VCommunicationSearchDto.SEQNO, -1);
    return vcsd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki) throws Exception {
    if (_ret) rki = _cp.find((VCommunicationSearchDto)rki);
    return rki;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VCommunicationDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii) throws Exception {
    return _cp.getDetail((VCommunicationDto)dii);
  }

  private final String MSG_DEL = "*** 폜Ă܂ ***";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    if (delCheck(dii)) {
      String[] ddt = {"contents", MSG_DEL};
      return ddt;
    }
    return null;
  }

}
