package com.hamaf.hikyakucms.sample.sns.managerUi;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.ui.StandardDetailProcess;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.process.EnqueteProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.EnqueteMap;

/**
 * <p>^CgFEnqueteDetail is .</p>
 * <p>FǗҗpAP[gڍ׎擾</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/04</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class EnqueteDetail extends StandardDetailProcess {

  private EnqueteProcess _ep = null;
  private SecurityCheckUtils _scu = null;

  /**
   * Creates a new <code>EnqueteDetail.java</code> instance.
   * <br>Default Constructor
   */
  public EnqueteDetail() {
    _jim = new EnqueteMap();
    _ep = new EnqueteProcess();
    _scu = new SecurityCheckUtils();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new EnqueteDto();
  }

  private List<String[]> _svQue = null;
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    EnqueteDto ed = _ep.getDetail((EnqueteDto)dii);
    _svQue = ed.getQuestionList();
    return ed;
  }

  private final String MSG_MN = "managerName";
  private final String MSG_QDTL = "qcontens";
  private final String MSG_QSEQ = "qSeq";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#editItems(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage editItems(CommonMessage msg) throws Exception {
    if (msg.getResMsg("dayTo").startsWith("9999")) msg.setResMsg("dayTo", "");

    UserDto ud = _scu.getUserInf(msg.getResMsg("manager"), getUserID());
    String mnm = ud.getItemValue(UserDto.ABBREV);
    if (mnm == null || mnm.length() == 0) mnm = ud.getItemValue(UserDto.NAME);
    msg.setResMsg(MSG_MN, mnm);

    msg = setQuestion(msg);
    return super.editItems(msg);
  }
  private CommonMessage setQuestion(CommonMessage msg) throws Exception {
    for (String[] qdts : _svQue) {
      Map<String, String> qdt = new HashMap<String, String>();
      qdt.put(MSG_QDTL, qdts[0]);
      qdt.put(MSG_QSEQ, qdts[1]);
      msg.addResList(qdt);
    }
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#setKeys(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    String ps = msg.getReqStr("pos");
    String seq = msg.getReqStr("seqNo");
    if (ps.length() > 0) return false;
    dii.setItemValue(EnqueteDto.SEQNO, seq);
    return true;
  }

}
