package com.hamaf.hikyakucms.sample.sns.managerUi;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.dto.GenreDto;
import com.hamaf.hikyakucms.sample.sns.process.GenreProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.GenreMap;

/**
 * <p>^CgFGenreUpdate is .</p>
 * <p>FW}X^̍XV</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/11</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class GenreUpdate extends StandardUpdateProcess {

  private GenreProcess _gp = null;

  /**
   * Creates a new <code>GenreUpdate.java</code> instance.
   * <br>Default Constructor
   */
  public GenreUpdate() {
    _jim = new GenreMap();
    _gp = new GenreProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new GenreDto();
  }

  private final String UPD_KBN = "upkbn";
  private final String MSG_OK = "updateok";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    String kbn = msg.getReqStr(UPD_KBN);
    if (kbn.equals("a")) {
      _gp.regist((GenreDto)dii);
      msg.setResMsg(MSG_OK, "1");
      return msg;
    }
    GenreDto gd = new GenreDto();
    gd.setItemValue(GenreDto.GENRE_ID, dii.getItemValue(GenreDto.GENRE_ID));
    gd.setSysId(sysId);
    gd = _gp.getDetail(gd);
    gd.setItemValue(GenreDto.GENRE_NAME, dii.getItemValue(GenreDto.GENRE_NAME));
    gd.setItemValue(GenreDto.COLOR, dii.getItemValue(GenreDto.COLOR));
    _gp.update(gd);
    msg.setResMsg(MSG_OK, "1");
    return msg;
  }

}
