package com.hamaf.hikyakucms.sample.sns.managerUi;

import java.util.Calendar;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.sns.dto.SoliloquyDto;
import com.hamaf.hikyakucms.sample.sns.dto.SoliloquySearchDto;
import com.hamaf.hikyakucms.sample.sns.process.SoliloquyProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.SoliloquyMap;

/**
 * <p>^CgFSoliloquyList is .</p>
 * <p>FǗҗpƂ茾ꗗ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/04/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class SoliloquyList extends StandardListProcess {

  private SoliloquyProcess _sp = null;
  private boolean _ret = false;

  /**
   * Creates a new <code>SoliloquyList.java</code> instance.
   * <br>Default Constructor
   */
  public SoliloquyList() {
    _jim = new SoliloquyMap();
    _sp = new SoliloquyProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    SoliloquySearchDto ssd = new SoliloquySearchDto();
    if (keyl.getRetrieve("ret").length() == 0) return ssd;

    _ret = true;
    ssd.setRetrieveValue(SoliloquySearchDto.ENTRY_USER, keyl.getRetrieve("suser"));
    String dayf = keyl.getRetrieve("sdayFrom");
    String dayt = keyl.getRetrieve("sdayTo");
    if (dayt == null || dayt.length() == 0) {
      if (dayf == null || dayf.length() == 0) {
        dayt = DateUtil.getDate();
        dayf = DateUtil.addDateTime(dayt, Calendar.MONTH, -6);
      } else {
        dayt = DateUtil.addDateTime(dayf, Calendar.MONTH, 6);
      }
    } else {
      if (dayf == null || dayf.length() == 0) {
        dayf = DateUtil.addDateTime(dayt, Calendar.MONTH, -6);
      }
    }
    StringBuilder sb2 = new StringBuilder();
    sb2.append("'");
    sb2.append(dayf);
    sb2.append(" 00:00:00' AND '");
    sb2.append(dayt);
    sb2.append(" 99:99:99'");
    ssd.setRetrieveValue(SoliloquySearchDto.ENTRY_DATE, sb2.toString());
    ssd.setCondition(SoliloquySearchDto.ENTRY_DATE, "BETWEEN");

    String val = keyl.getRetrieve("sval");
    if (val != null && val.length() > 0) {
      StringBuilder sb = new StringBuilder();
      sb.append("'%");
      sb.append(val);
      sb.append("%'");
      ssd.setRetrieveValue(SoliloquySearchDto.RET_DETAIL, sb.toString());
      ssd.setCondition(SoliloquySearchDto.RET_DETAIL, "LIKE");
    }
    ssd.setOrderItem(SoliloquySearchDto.ENTRY_DATE, -1);
    ssd.setOrderItem(SoliloquySearchDto.SEQNO, -2);
    return ssd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    if (_ret) rki = _sp.find((SoliloquySearchDto)rki);
    return rki;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new SoliloquyDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _sp.getDetail((SoliloquyDto)dii);
  }

  private final String MSG_DEL = "*** 폜܂ ***";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    if (delCheck(dii)) {
      String[] ddt = {"entryName", MSG_DEL};
      return ddt;
    }
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ListProcessBase#spareAction(com.hamaf.hikyaku.dataobject.CommonMessage, java.lang.String)
   */
  @Override
  protected CommonMessage spareAction(CommonMessage msg, String act)
      throws Exception {
    String edt = msg.getResMsg("sentday");
    if (edt == null || edt.length() > 0) {
      String[] dt = {DateUtil.getDate()};
      msg.setReq("sentday", dt);
    }
    return msg;
  }

}
