package com.hamaf.hikyakucms.sample.sns.process;

import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyakucms.sample.sns.access.AnswerAccess;
import com.hamaf.hikyakucms.sample.sns.access.VAnswerCountAccess;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerDto;
import com.hamaf.hikyakucms.sample.sns.dto.AnswerSearchDto;
import com.hamaf.hikyakucms.sample.sns.dto.VAnswerCountDto;
import com.hamaf.hikyakucms.sample.sns.dto.VAnswerCountSearchDto;

/**
 * <p>^CgFAnswerProcess is .</p>
 * <p>F񓚏̏NX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/25</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AnswerProcess {

  private AnswerAccess _aa = null;
  private VAnswerCountAccess _vaca = null;
  private SecurityCheckUtils _scu = null;

  /**
   * Creates a new <code>AnswerProcess.java</code> instance.
   * <br>Default Constructor
   */
  public AnswerProcess() {
    _aa = new AnswerAccess();
    _vaca = new VAnswerCountAccess();
    _scu = new SecurityCheckUtils();
//    _aa.setDebug();
  }

  /**
   * Describe <code>find</code> method : .
   * <br>񓚏̌B
   *
   * @param asd a <code>AnswerSearchDto</code> :
   * @return a <code>AnswerSearchDto</code> :
   * @throws Exception
   */
  public AnswerSearchDto find(AnswerSearchDto asd) throws Exception {
    return (AnswerSearchDto)_aa.find(asd);
  }

  /**
   * Describe <code>getDetail</code> method : .
   * <br>񓚏̏ڍ׎擾B
   *
   * @param ad a <code>AnswerDto</code> :
   * @return a <code>AnswerDto</code> :
   * @throws Exception
   */
  public AnswerDto getDetail(AnswerDto ad) throws Exception {
    ad.clearRequest(AnswerDto.USER_NAME);
    ad = (AnswerDto)_aa.findByPrimaryKey(ad);
    UserDto ud = _scu.getUserInf(ad.getItemValue(AnswerDto.USER_ID), ad.getCommFld(COMMFLD.UUSR));
    String unm = ud.getItemValue(UserDto.ABBREV);
    if (unm == null || unm.length() == 0) unm = ud.getItemValue(UserDto.NAME);
    ad.setItemValue(AnswerDto.USER_NAME, unm);
    return ad;
  }

  /**
   * Describe <code>isAnswer</code> method : .
   * <br>AP[gɊY[U[񓚂Ă邩`FbNB
   * <br>񓚂ĂꍇA ^(true)߂
   *
   * @param seqNo a <code>String</code> : AP[gNo
   * @param uid a <code>String</code> : [U[ID
   * @param sysId a <code>String</code> : vOCID
   * @return a <code>boolean</code> : 񓚂ĂꍇA^
   * @throws Exception
   */
  public boolean isAnswer(String seqNo, String uid, String sysId) throws Exception {
   AnswerSearchDto asd = new AnswerSearchDto();
   asd.setRetrieveValue(AnswerSearchDto.ENQUETE_SEQNO, seqNo);
   if (uid != null && uid.length() > 0) asd.setRetrieveValue(AnswerSearchDto.USER_ID, uid);
   asd.setSysId(sysId);
   asd = (AnswerSearchDto)_aa.find(asd);
   return asd.getKeys().size() > 0;
  }

  /**
   * Describe <code>getNotAnsUser</code> method : .
   * <br>񓚂̃[U[̈ꗗ擾B
   * <br>[[U[, [U[ID]̃Xg߂B
   *
   * @param seqNo a <code>String</code> : AP[gNo
   * @param gids a <code>List&lt;String&gt;</code> : ΏۃO[v̈ꗗ
   * @param sysId a <code>String</code> : vOCID
   * @param uid a <code>String</code> : v҂̃[U[ID
   * @return
   * @throws Exception
   */
  public List<String[]> getNotAnsUser(String seqNo, List<String> gids,
      String sysId, String uid) throws Exception {
    List<String[]> ret = new ArrayList<String[]>();
    List<String> uids = getAnsUser(seqNo, sysId);
    List<String> chkUid = null;
    if (gids == null || gids.size() == 0) {
      chkUid = _scu.getUserAll();
    } else {
      chkUid = _scu.getUserInGp(gids);
    }
    for (String auid : chkUid) {
      if (!uids.contains(auid)) {
        UserDto ud = _scu.getUserInf(auid, uid);
        String unm = ud.getItemValue(UserDto.ABBREV);
        if (unm == null || unm.length() == 0) unm = ud.getItemValue(UserDto.NAME);
        String[] dt = {unm, auid};
        ret.add(dt);
      }
    }
    return ret;
  }
  private List<String> getAnsUser(String seqNo, String sysId) throws Exception {
    AnswerSearchDto asd = new AnswerSearchDto();
    asd.setRetrieveValue(AnswerSearchDto.ENQUETE_SEQNO, seqNo);
    asd.setSysId(sysId);
    asd = (AnswerSearchDto)_aa.find(asd);
    List<String> ret = new ArrayList<String>();
    for (List<String> keys : asd) {
      String user = keys.get(2);
      if (!ret.contains(user)) ret.add(user);
    }
    return ret;
  }

  /**
   * Describe <code>regist</code> method : .
   * <br>񓚏̓o^B
   *
   * @param ad a <code>AnswerDto</code> :
   * @throws Exception
   */
  public void regist(AnswerDto ad) throws Exception {
    ad.clearRequest(AnswerDto.USER_NAME);
    if (ad.getQseqs() == null) {
      _aa.regist(ad);
      return;
    }
    List<String> seqs = ad.getQseqs();
    for (String qseq : seqs) {
      ad.setItemValue(AnswerDto.Q_SEQNO, qseq);
      _aa.regist(ad);
    }
  }

  /**
   * Describe <code>delAll</code> method : .
   * <br>AP[gNoŊY[U[̉񓚂ׂč폜B
   *
   * @param seqNo a <code>String</code> : AP[gNo
   * @param uid a <code>String</code> : [U[ID
   * @param sysId a <code>String</code> : vOCID
   * @throws Exception
   */
  public void delAll(String seqNo, String uid, String sysId) throws Exception {
    AnswerSearchDto asd = new AnswerSearchDto();
    asd.setRetrieveValue(AnswerSearchDto.ENQUETE_SEQNO, seqNo);
    asd.setRetrieveValue(AnswerSearchDto.USER_ID, uid);
    asd.setSysId(sysId);
    asd = (AnswerSearchDto)_aa.find(asd);
    AnswerDto ad = new AnswerDto();
    ad.setSysId(sysId);
    for (List<String> keys : asd) {
      for (int i = 0; i < keys.size(); i++) {
        ad.setItemValue(i, keys.get(i));
      }
      _aa.deleteNoExclusion(ad);
    }
  }

  /**
   * Describe <code>findAnsCount</code> method : .
   * <br>񓚌擾pB
   *
   * @param vacsd a <code>VAnswerCountSearchDto</code> :
   * @return a <code>VAnswerCountSearchDto</code> :
   * @throws Exception
   */
  public VAnswerCountSearchDto findAnsCount(VAnswerCountSearchDto vacsd) throws Exception {
    return (VAnswerCountSearchDto)_vaca.find(vacsd);
  }

  /**
   * Describe <code>getAnsCount</code> method : .
   * <br>Cm̎擾B
   *
   * @param vacd a <code>getAnsCount</code> :
   * @return a <code>getAnsCount</code> :
   * @throws Exception
   */
  public VAnswerCountDto getAnsCount(VAnswerCountDto vacd) throws Exception {
    return (VAnswerCountDto)_vaca.findByPrimaryKey(vacd);
  }

  /**
   * Describe <code>getSays</code> method : .
   * <br>w肳ꂽAP[g̈ӌ擾B
   * <br>{ӌ, [U[}̃Xg߂
   *
   * @param seqNo a <code>String</code> : AP[gԍ
   * @param sysId a <code>String</code> : vOCID
   * @return a <code>List&lt;String&gt;</code : ӌ̃Xg
   * @throws Exception
   */
  public List<String[]> getSays(String seqNo, String uid, String sysId) throws Exception {
    AnswerSearchDto asd = new AnswerSearchDto();
    asd.setRetrieveValue(AnswerSearchDto.ENQUETE_SEQNO, seqNo);
    asd.setRetrieveValue(AnswerSearchDto.SAYS, "NOT NULL");
    asd.setCondition(AnswerSearchDto.SAYS, "IS");
    asd.setSysId(sysId);
    asd = (AnswerSearchDto)_aa.find(asd);
    AnswerDto ad = new AnswerDto();
    ad.setSysId(sysId);
    ad.setRequestItem(AnswerDto.SAYS);
    List<String[]> ret = new ArrayList<String[]>();
    for (List<String> keys : asd) {
      for (int i = 0; i < keys.size(); i++) {
        ad.setItemValue(i, keys.get(i));
      }
      ad = (AnswerDto)_aa.findByPrimaryKey(ad);
      UserDto ud = _scu.getUserInf(ad.getItemValue(AnswerDto.USER_ID), uid);
      String unm = ud.getItemValue(UserDto.ABBREV);
      if (unm == null || unm.length() == 0) unm = ud.getItemValue(UserDto.NAME);
      String[] dt = {ad.getItemValue(AnswerDto.SAYS), unm};
      ret.add(dt);
    }
    return ret;
  }
}
