package com.hamaf.hikyakucms.sample.sns.process;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.util.ComUtils;
import com.hamaf.hikyakucms.sample.sns.access.AppendFileAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.AppendFileDto;
import com.hamaf.hikyakucms.sample.sns.dto.AppendFileSearchDto;

/**
 * <p>^CgFAppendFileProcess is .</p>
 * <p>FYtt@C񏈗</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/04</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AppendFileProcess {

  private final String TAG_PATH = "SaveFilePAth";

  private AppendFileAccess _afa = null;
  private Hatsuban2Access _ha = null;

  /**
   * Creates a new <code>AppendFileProcess.java</code> instance.
   * <br>Default Constructor
   */
  public AppendFileProcess() {
    _afa = new AppendFileAccess();
    _ha = new Hatsuban2Access();
  }

  /**
   * Describe <code>find</code> method : .
   * <br>Ytt@ČB
   *
   * @param afsd a <code>AppendFileSearchDto</code>
   * @return a <code>AppendFileSearchDto</code>
   * @throws Exception
   */
  public AppendFileSearchDto find(AppendFileSearchDto afsd) throws Exception {
    return (AppendFileSearchDto)_afa.find(afsd);
  }

  /**
   * Describe <code>findByPrimarKkey</code> method : .
   * <br>Ytt@C̏ڍ׎擾B
   *
   * @param afd a <code>AppendFileDto</code>
   * @return a <code>AppendFileDto</code>
   * @throws Exception
   */
  public AppendFileDto findByPrimarKkey(AppendFileDto afd) throws Exception {
    return (AppendFileDto)_afa.findByPrimaryKey(afd);
  }

  /**
   * Describe <code>regist</code> method : .
   * <br>Ytt@C̓o^B
   *
   * @param afd a <code>AppendFileDto</code>
   * @throws Exception
   */
  public void regist(AppendFileDto afd) throws Exception {
    afd = setFileInf(afd);
    _afa.regist(afd);
    copyFile(afd);

  }
  private AppendFileDto setFileInf(AppendFileDto afd) throws Exception {
    StringBuilder sb = new StringBuilder();
    sb.append(afd.getItemValue(AppendFileDto.CATEGORY));
    sb.append(afd.getItemValue(AppendFileDto.KEY_SEQNO));
    String nno = _ha.getNextNo(HATSUBAN2_KBN.FILE, sb.toString(), afd.getSysId());
    afd.setItemValue(AppendFileDto.SEQNO, nno);

    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(afd.getSysId());
    StringBuilder cpf = new StringBuilder();
    cpf.append(ComUtils.convPath(mxc.getConstant(TAG_PATH), true).replaceAll("\\\\", "/"));
    cpf.append(afd.getItemValue(AppendFileDto.CATEGORY));
    File bdir = new File(cpf.toString());
    bdir.mkdirs();
    cpf.append("/");
    cpf.append(sb);
    cpf.append("_");
    cpf.append(nno);
    String ftyp = afd.getItemValue(AppendFileDto.FILE_TYPE);
    if (ftyp != null && ftyp.length() > 0) {
      cpf.append(".");
      cpf.append(ftyp);
    }
    afd.setItemValue(AppendFileDto.ENTITY_PATH, cpf.toString());
    return afd;
  }
  private void copyFile(AppendFileDto afd) throws Exception {
    File org = new File(afd.getTempFilePath());
    File nfl = new File(afd.getItemValue(AppendFileDto.ENTITY_PATH));
    org.renameTo(nfl);
  }

  /**
   * Describe <code>modComment</code> method : .
   * <br>Ytt@C̃RgXVB
   *
   * @param afd a <code>AppendFileDto</code>
   * @throws Exception
   */
  public void modComment(AppendFileDto afd)  throws Exception {
    afd.clearRequest(AppendFileDto.DISP_FILE);
    afd.clearRequest(AppendFileDto.ENTITY_PATH);
    afd.clearRequest(AppendFileDto.FILE_SIZE);
    afd.clearRequest(AppendFileDto.FILE_TYPE);
    _afa.updateNoExclusion(afd);
  }

  public final String[] fileFields = {"category", "keySeq", "seqNo", "dispFile", "entityPth", "comment", "fileType", "fileSize"};
  /**
   * Describe <code>getInfMap</code> method : .
   * <br>Ytt@C","ŘAƂĖ߂B
   *
   * @param kbn a <code>HATSUBAN2_KBN</code> :
   * @param keySeq a <code>String</code> : ΏەseqNo
   * @param sysId a <code>String</code> :
   * @return a <code>Map&lt;fileFields, String&gt;</code> : Ytt@C
   * @throws Exception
   */
  public Map<String, String> getInfMap(HATSUBAN2_KBN kbn, String keySeq, String sysId) throws Exception {
    AppendFileSearchDto afsd = new AppendFileSearchDto();
    afsd.setRetrieveValue(AppendFileSearchDto.CATEGORY, HATSUBAN2_KBN.COMMUNICATION.getKey());
    afsd.setRetrieveValue(AppendFileSearchDto.KEY_SEQNO, keySeq);
    afsd.setSysId(sysId);
    afsd = (AppendFileSearchDto)_afa.find(afsd);
    AppendFileDto afd = new AppendFileDto();
    afd.setSysId(sysId);
    StringBuilder[] dt = new StringBuilder[6];
    for (List<String> pks : afsd) {
      for (int i = 0; i < pks.size(); i++) {
        afd.setItemValue(i, pks.get(i));
      }
      afd = (AppendFileDto)_afa.findByPrimaryKey(afd);
      for (int i = 0; i < fileFields.length; i++) {
        dt[i].append(afd.getItemValue(i));
        dt[i].append(",");
      }
    }
    if (dt[0].length() > 0) {
      for (int i = 0; i < dt.length; i++) {
        dt[i].setLength(dt[i].length() - 1);
      }
    }
    Map<String, String> afdt = new HashMap<String, String>();
    for (int i = 0; i < fileFields.length; i++) {
      afdt.put(fileFields[i], dt[i].toString());
    }
    return afdt;
  }

  /**
   * Describe <code>delete</code> method : .
   * <br>Ytt@C̍폜B
   *
   * @param afd a <code>AppendFileDto</code>
   * @throws Exception
   */
  public void delete(AppendFileDto afd) throws Exception {
    _afa.deleteNoExclusion(afd);
    File fl = new File(afd.getItemValue(AppendFileDto.ENTITY_PATH));
    fl.delete();
  }

}
