package com.hamaf.hikyakucms.sample.sns.process;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.GroupDto;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyakucms.sample.sns.access.BoardAccess;
import com.hamaf.hikyakucms.sample.sns.dto.BoardDto;
import com.hamaf.hikyakucms.sample.sns.ui.BoardList;

/**
 * <p>^CgFBoardProcess is .</p>
 * <p>FfNX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/28</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class BoardProcess {

  private BoardAccess _ba = null;
  private SecurityCheckUtils _scu = null;

  /**
   * Creates a new <code>BoardProcess.java</code> instance.
   * <br>Default Constructor
   */
  public BoardProcess() {
    _ba = new BoardAccess();
    _scu = new SecurityCheckUtils();
  }


  /**
   * Describe <code>getDetail</code> method : .
   * <br>f̏ڍ׏擾B
   *
   * @param bd a <code>BoardDto</code> :
   * @return a <code>BoardDto</code> :
   * @throws Exception
   */
  public BoardDto getDetail(BoardDto bd) throws Exception {
    bd = completionDto(bd);
    bd = (BoardDto)_ba.findByPrimaryKey(bd);

    String gid = bd.getItemValue(BoardDto.GROUP_ID);
    if (BoardList.ALL_ID.equals(gid)) {
      bd.setItemValue(BoardDto.GROUP_NAME, "S[U[");
      bd.setItemValue(BoardDto.GROUP_CODE, "All User");
    } else {
      GroupDto gd = _scu.getGroupInf(gid, bd.getCommFld(COMMFLD.UUSR));
      bd.setItemValue(BoardDto.GROUP_NAME, gd.getItemValue(GroupDto.NAME));
      bd.setItemValue(BoardDto.GROUP_CODE, gd.getItemValue(GroupDto.GROUP_CODE));
    }

    String lusr = bd.getItemValue(BoardDto.LAST_UPUSER);
    if (lusr != null && lusr.length() > 0) {
      UserDto ud = _scu.getUserInf(lusr, bd.getCommFld(COMMFLD.UUSR));
      String unm = ud.getItemValue(UserDto.ABBREV);
      if (unm == null || unm.length() == 0) unm = ud.getItemValue(UserDto.NAME);
      bd.setItemValue(BoardDto.USER_NAME, unm);
    }
    return bd;
  }
  private BoardDto completionDto(BoardDto bd) {
    bd.clearRequest(BoardDto.GROUP_NAME);
    bd.clearRequest(BoardDto.GROUP_CODE);
    bd.clearRequest(BoardDto.USER_NAME);
    return bd;
  }

  /**
   * Describe <code>modify</code> method : .
   * <br>f̍XVB
   *
   * @param bd a <code>BoardDto</code> :
   * @throws Exception
   */
  public void modify(BoardDto bd) throws Exception {
    bd = completionDto(bd);
    bd.setItemValue(BoardDto.LAST_UPUSER, bd.getCommFld(COMMFLD.UUSR));
    String chk = bd.getCommFld(COMMFLD.UPDT);
    if (chk == null || chk.length() == 0) {
      _ba.regist(bd);
    } else {
      _ba.update(bd);
    }
  }
}
