package com.hamaf.hikyakucms.sample.sns.process;

import java.util.List;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyakucms.sample.sns.access.EnqueteAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access;
import com.hamaf.hikyakucms.sample.sns.access.ModifyEnquete;
import com.hamaf.hikyakucms.sample.sns.access.QuestionAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.dto.QuestionContDto;
import com.hamaf.hikyakucms.sample.sns.dto.VEnqueteSearchDto;

/**
 * <p>^CgFEnqueteProcess is .</p>
 * <p>FAP[gNX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/25</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class EnqueteProcess {

  private EnqueteAccess _ea = null;
  private Hatsuban2Access _ha = null;
  private QuestionAccess _qa = null;

  /**
   * Creates a new <code>EnqueteProcess.java</code> instance.
   * <br>Default Constructor
   */
  public EnqueteProcess() {
    _ea = new EnqueteAccess();
    _ha = new Hatsuban2Access();
    _qa = new QuestionAccess();

//    _ea.setDebug();
  }

  /**
   * Describe <code>find</code> method : .
   * <br>AP[ǧB
   *
   * @param vesd a <code>VEnqueteSearchDto</code> :
   * @return a <code>VEnqueteSearchDto</code> :
   * @throws Exception
   */
  public VEnqueteSearchDto find(VEnqueteSearchDto vesd) throws Exception {
    return (VEnqueteSearchDto)_ea.find(vesd);
  }

  /**
   * Describe <code>findByPrimaryKey</code> method : .
   * <br>AP[g̏ڍ׎擾B
   *
   * @param ed a <code>EnqueteDto</code> :
   * @return a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public EnqueteDto findByPrimaryKey(EnqueteDto ed) throws Exception {
    return (EnqueteDto)_ea.findByPrimaryKey(ed);
  }

  /**
   * Describe <code>getDetail</code> method : .
   * <br>AP[g̏ڍ׎擾B
   * <br>⍀ڂ̐ݒ܂B
   *
   * @param ed a <code>EnqueteDto</code> :
   * @return a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public EnqueteDto getDetail(EnqueteDto ed) throws Exception {
    ed = (EnqueteDto)_ea.findByPrimaryKey(ed);
    QuestionContDto qcd = new QuestionContDto();
    qcd.setRetrieveValue(QuestionContDto.ENQUETE_SEQNO, ed.getItemValue(EnqueteDto.SEQNO));
    qcd.setSysId(ed.getSysId());
    qcd = (QuestionContDto)_qa.find(qcd);
    for (List<String> dts : qcd) {
      String[] dt = {dts.get(0), dts.get(1)};
      ed.addQuestion(dt);
    }
    return ed;
  }

  /**
   * Describe <code>regist</code> method : .
   * <br>AP[g̓o^B
   *
   * @param ed a <code>EnqueteDto</code> :
 * @return a <code>String</code> : ԂSeqNo
   * @throws Exception
   */
  public String regist(EnqueteDto ed) throws Exception {
    String nno = _ha.getNextNo(HATSUBAN2_KBN.ENRUETE, null, ed.getSysId());
    ed.setItemValue(EnqueteDto.SEQNO, nno);
     String mng = ed.getItemValue(EnqueteDto.MANAGER);
     if (mng == null || mng.length() == 0) ed.setItemValue(EnqueteDto.MANAGER, ed.getCommFld(COMMFLD.UUSR));
     if ("1".equals(ed.getItemValue(EnqueteDto.ALL_FLG))) {
       ed.addRestriction(RestrictionProcess.ALL_USERID);
     }
     ed.addRestriction(ed.getItemValue(EnqueteDto.MANAGER));
     ModifyEnquete me = new ModifyEnquete();
     try {
       me.addEnquete(ed);
       me.addQuestion(ed);
       me.addRestriction(ed);
     }
     catch (Exception ex) {
       me.rollBack();
       throw ex;
     }
     me.commit();
     return nno;
  }

  /**
   * Describe <code>update</code> method : .
   * <br>AP[g̍XVB
   *
   * @param ed a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public void update(EnqueteDto ed) throws Exception {
    String mng = ed.getItemValue(EnqueteDto.MANAGER);
    if (mng == null || mng.length() == 0) ed.setItemValue(EnqueteDto.MANAGER, ed.getCommFld(COMMFLD.UUSR));
    if ("1".equals(ed.getItemValue(EnqueteDto.ALL_FLG))) {
      ed.addRestriction(RestrictionProcess.ALL_USERID);
    }
    ed.addRestriction(ed.getItemValue(EnqueteDto.MANAGER));
    ModifyEnquete me = new ModifyEnquete();
    try {
      me.modEnquete(ed);
      me.delQuestionAll(ed);
      me.delRestrictionAll(ed);
      me.addQuestion(ed);
      me.addRestriction(ed);
    }
    catch (Exception ex) {
      me.rollBack();
      throw ex;
    }
    me.commit();
  }

  /**
   * Describe <code>delete</code> method : .
   * <br>AP[g̍폜B
   *
   * @param ed a <code>EnqueteDto</code> :
   * @throws Exception
   */
  public void delete(EnqueteDto ed) throws Exception {
    ModifyEnquete md = new ModifyEnquete();
    try {
      md.delEnquete(ed);
      md.delQuestionAll(ed);
      md.delRestrictionAll(ed);
      md.delAnswerAll(ed);
      List<String> flnms = md.delAppendFileAll(ed);
      for (String flnm : flnms) {
        md.delEntityFile(flnm);
      }
    }
    catch (Exception ex) {
      md.rollBack();
      throw ex;
    }
    md.commit();
  }

}
