package com.hamaf.hikyakucms.sample.sns.process;

import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.GroupDto;
import com.hamaf.hikyakucms.sample.sns.access.RestrictionAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.RestrictionSearchDto;

/**
 * <p>^CgFRestrictionProcess is .</p>
 * <p>FΏۃO[v̏</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class RestrictionProcess {

  public static final String ALL_USERID = "system_setting_all_user";

  private RestrictionAccess _ra = null;
  private SecurityCheckUtils _scu = null;
  /**
   * Creates a new <code>RestrictionProcess.java</code> instance.
   * <br>Default Constructor
   */
  public RestrictionProcess() {
    _ra = new RestrictionAccess();
    _scu = new SecurityCheckUtils();
  }

  /**
   * Describe <code>getGroups</code> method : .
   * <br>ΏۃO[v̏񃊃Xg擾B
   * <br>{O[vID, O[v}̃Xg߂B
   *
   * @param kbn a <code>HATSUBAN2_KBN</code>
   * @param keySeq a <code>String</code> : SeqNo
   * @param sysId a <code>String</code> : vOCID
   * @param uid a <code>String</code> : v郆[U[ID
   * @return a <code>List&lt;String[]&gt;</code> : ΏۃO[ṽXg
   * @throws Exception
   */
  public List<String[]> getGroups(HATSUBAN2_KBN kbn, String seq, String sysId, String uid) throws Exception {
    List<String[]> ret = new ArrayList<String[]>();
    RestrictionSearchDto rsd = new RestrictionSearchDto();
    rsd.setRetrieveValue(RestrictionSearchDto.CATEGORY, kbn.getKey());
    rsd.setRetrieveValue(RestrictionSearchDto.KEY_SEQNO, seq);
    rsd.setSysId(sysId);
    rsd = (RestrictionSearchDto)_ra.find(rsd);
    for (List<String> keys : rsd) {
      GroupDto gd = _scu.getGroupInf(keys.get(2), uid);
      if (!gd.isNotFound()) {
        String[] dt = {keys.get(2), gd.getItemValue(GroupDto.NAME)};
        ret.add(dt);
      }
    }
    return ret;
  }

  /**
  * Describe <code>getGropuCondition</code> method : .
  * <br> 'IN'ŎgpO[vI̕𐶐B
  *
  * @param uid a <code>String</code> : ҂̃[U[ID
  * @return a <code>String</code> : 
  */
 public String getGropuCondition(String uid, boolean uadd) {
    List<String> grps = null;
    try {
      grps = _scu.getGroupByUser(uid);
    } catch (Exception ex) {
      grps = new ArrayList<String>();
    }
    grps.add(ALL_USERID);
    if (uadd) grps.add(uid);
    StringBuilder sb = new StringBuilder();
    for (String grp : grps) {
     sb.append("'");
     sb.append(grp);
     sb.append("',");
    }
    sb.setLength(sb.length() - 1);
    return sb.toString();
  }

   /**
    * Describe <code>checkIngroup</code> method : .
    * <br>w肳ꂽ[U[','ŘAꂩ̃O[vɑē邩`FbNB
    * <br>݂ꍇA^߂
    *
    * @param uid a <code>String</code> : [U[ID
    * @param groups a <code>String</code> : ","ŘAO[vID
    * @return a <code>boolean</code> : ݂ꍇAtrue
    */
   public boolean checkIngroup(String uid, String groups) {
     if (groups == null || groups.length() == 0) return false;
     String[] grps = groups.split(",");
     List<String> grpl = new ArrayList<String>();
     for (int i = 0; i < grps.length; i++) {
       grpl.add(grps[i]);
     }
     return _scu.checkUserInGroups(uid, grpl);
   }

}
