package com.hamaf.hikyakucms.sample.sns.process;

import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.sns.access.FootprintsAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access;
import com.hamaf.hikyakucms.sample.sns.access.SoliloquyAccess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.FootprintsSearchDto;
import com.hamaf.hikyakucms.sample.sns.dto.SoliloquyDto;
import com.hamaf.hikyakucms.sample.sns.dto.SoliloquySearchDto;

/**
 * <p>^CgFSoliloquyProcess is .</p>
 * <p>FƂ茾̏NX</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/29</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class SoliloquyProcess {

  public static final String PUBLIC = "System_set_all_user";

  private SoliloquyAccess _sa = null;
  private FootprintsAccess _fa = null;
  private Hatsuban2Access _ha = null;
  private SecurityCheckUtils _scu = null;

  /**
   * Creates a new <code>SoliloquyProcess.java</code> instance.
   * <br>Default Constructor
   */
  public SoliloquyProcess() {
    _sa = new SoliloquyAccess();
    _fa = new FootprintsAccess();
    _ha = new Hatsuban2Access();
    _scu = new SecurityCheckUtils();

//    _sa.setDebug();
  }

  public SoliloquySearchDto find(SoliloquySearchDto ssd) throws Exception {
    return (SoliloquySearchDto)_sa.find(ssd);
  }

  public SoliloquyDto getDetail(SoliloquyDto sd) throws Exception {
    completionDto(sd);
    sd = (SoliloquyDto)_sa.findByPrimaryKey(sd);
    UserDto ud = _scu.getUserInf(sd.getItemValue(SoliloquyDto.ENTRY_USER), sd.getCommFld(COMMFLD.UUSR));
    String unm = ud.getItemValue(UserDto.ABBREV);
    if (unm == null || unm.length() == 0) unm = ud.getItemValue(UserDto.NAME);
    sd.setItemValue(SoliloquyDto.ENTRY_NAME, unm);
    sd.setItemValue(SoliloquyDto.ICON, ud.getItemValue(UserDto.ICON_UMU));

    FootprintsSearchDto fsd = new FootprintsSearchDto();
    fsd.setRetrieveValue(FootprintsSearchDto.CATEGORY, HATSUBAN2_KBN.SOLILOQUY.getKey());
    fsd.setRetrieveValue(FootprintsSearchDto.KEY_SEQNO, sd.getItemValue(SoliloquyDto.SEQNO));
    fsd.setSysId(sd.getSysId());
    fsd = (FootprintsSearchDto)_fa.find(fsd);
    int cnt = fsd.getKeys().size();
    sd.setItemValue(SoliloquyDto.FOOT_COUNT, Integer.toString(cnt));
    return sd;
  }
  private SoliloquyDto completionDto(SoliloquyDto sd) throws Exception {
    sd.clearRequest(SoliloquyDto.FOOT_COUNT);
    sd.clearRequest(SoliloquyDto.ENTRY_NAME);
    sd.clearRequest(SoliloquyDto.ICON);
    return sd;
  }

  /**
   * Describe <code>regist</code> method : .
   * <br>Ƃ茾̓o^B
   *
   * @param sd a <code>SoliloquyDto</code> :
   * @throws Exception
   */
  public void regist(SoliloquyDto sd) throws Exception {
    sd.setItemValue(SoliloquyDto.SEQNO,
        _ha.getNextNo(HATSUBAN2_KBN.SOLILOQUY, null, sd.getSysId()));
    sd = completionDto(sd);
    if ("1".equals(sd.getItemValue(SoliloquyDto.PUBLISHING))) {
      sd.setItemValue(SoliloquyDto.TARGET, PUBLIC);
    } else {
      sd.setItemValue(SoliloquyDto.TARGET, sd.getCommFld(COMMFLD.UUSR));
    }
    sd.setItemValue(SoliloquyDto.ENTRY_USER, sd.getCommFld(COMMFLD.UUSR));
    StringBuilder sb = new StringBuilder();
    sb.append(DateUtil.getDate());
    sb.append(" ");
    sb.append(DateUtil.getTime());
    sd.setItemValue(SoliloquyDto.ENTRY_DATE, sb.toString());
    String dt = sd.getItemValue(SoliloquyDto.DETAIL);
    sd.setItemValue(SoliloquyDto.RET_DETAIL, dt.replaceAll("<.+?>", ""));
    _sa.regist(sd);
  }

  /**
   * Describe <code>delete</code> method : .
   * <br>Ƃ茾̍폜B
   *
   * @param sd a <code>SoliloquyDto</code> :
   * @throws Exception
   */
  public void delete(SoliloquyDto sd) throws Exception {
    _sa.deleteNoExclusion(sd);
  }
}
