package com.hamaf.hikyakucms.sample.sns.ui;

import java.util.ArrayList;
import java.util.List;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.report.excel2003.ExcelDoc;
import com.hamaf.hikyaku.report.excel2003.ExcelSheet;
import com.hamaf.hikyaku.ui.ProcessBase;
import com.hamaf.hikyaku.util.ComUtils;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.dto.VAnswerCountDto;
import com.hamaf.hikyakucms.sample.sns.dto.VAnswerCountSearchDto;
import com.hamaf.hikyakucms.sample.sns.process.AnswerProcess;
import com.hamaf.hikyakucms.sample.sns.process.EnqueteProcess;

/**
 * <p>^CgFAnswerCountExcel is .</p>
 * <p>FAP[gʂExcelo͏</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/27</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AnswerCountExcel extends ProcessBase {

  private static final String BASE_TAG = "ExcelBasePAth";
  private static final String BASE_EXL = "EnqueteAnswerList.xml";

  private AnswerProcess _ap = null;
  private EnqueteProcess _ep = null;

  /**
   * Creates a new <code>AnswerCountExcel.java</code> instance.
   * <br>Default Constructor
   */
  public AnswerCountExcel() {
    _ap = new AnswerProcess();
    _ep = new EnqueteProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    StringBuilder path = new StringBuilder();
    path.append(ComUtils.convPath(mxc.getConstant(BASE_TAG), true));
    path.append(BASE_EXL);
    ExcelDoc ed = new ExcelDoc();
    ed.openBook(path.toString());
    ExcelSheet sht = ed.getSheet(0);
    String seqNo = msg.getReqStr("seqNo");
    sht = setTitle(sht, seqNo);
    sht = setQuestion(sht, seqNo);
    sht = setSays(sht, seqNo);
    msg.setWorkBuff(ed);
    return msg;
  }
  private ExcelSheet setTitle(ExcelSheet es, String seqNo) throws Exception {
    EnqueteDto ed = new EnqueteDto();
    ed.setItemValue(EnqueteDto.SEQNO, seqNo);
    ed.setSysId(sysId);
    ed.setAllRequest();
    ed = _ep.findByPrimaryKey(ed);
    int[] pos = es.searchCell("#title");
    es.setCellValue(ed.getItemValue(EnqueteDto.CONTENTS), pos[0], pos[1], null);
    pos = es.searchCell("#detail");
    es.setCellValue(ed.getItemValue(EnqueteDto.DETAIL), pos[0], pos[1], null);
    return es;
  }
  private ExcelSheet setQuestion(ExcelSheet es, String seqNo) throws Exception {
    VAnswerCountSearchDto vacsd = new VAnswerCountSearchDto();
    vacsd.setRetrieveValue(VAnswerCountSearchDto.ENQUETE_SEQNO, seqNo);
    vacsd.setSysId(sysId);
    vacsd = _ap.findAnsCount(vacsd);
    VAnswerCountDto vacd = new VAnswerCountDto();
    vacd.setSysId(sysId);
    vacd.setAllRequest();
    List<List<Object>> dts = new ArrayList<List<Object>>();
    for (List<String> keys : vacsd) {
      for (int i = 0; i < keys.size(); i++) {
        vacd.setItemValue(i, keys.get(i));
      }
      vacd = _ap.getAnsCount(vacd);
      List<Object> rdt = new ArrayList<Object>();
      rdt.add(vacd.getItemValue(VAnswerCountDto.CONTENTS));
      rdt.add(vacd.getItemValue(VAnswerCountDto.ANS));
      dts.add(rdt);
    }
    int[] pos = es.searchCell("#question");
    es.copyAddValue(dts, pos[0], pos[1]);
    return es;
  }
  private ExcelSheet setSays(ExcelSheet es, String seqNo) throws Exception {
    List<String[]> dt = _ap.getSays(seqNo, getUserID(), sysId);
    int[] pos = es.searchCell("#says");
    if (dt.size() == 0) {
      es.deleteRow(pos[0]);
      return es;
    }
    List<List<Object>> dts = new ArrayList<List<Object>>();
    for (String[] val : dt) {
      List<Object> rdt = new ArrayList<Object>();
      rdt.add(val[0]);
      rdt.add(val[1]);
      dts.add(rdt);
    }
    es.copyAddValue(dts, pos[0], pos[1]);
    return es;
  }

}
