package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.process.EnqueteProcess;

/**
 * <p>^CgFEnqueteFinish is .</p>
 * <p>FAP[g̊o^</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/28</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class EnqueteFinish extends StandardUpdateProcess {

  private EnqueteProcess _ep = null;

  /**
   * Creates a new <code>EnqueteFinish.java</code> instance.
   * <br>Default Constructor
   */
  public EnqueteFinish() {
    _ep = new EnqueteProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#setItems()
   */
  @Override
  protected void setItems() {
    addItem("seqNo", EnqueteDto.SEQNO);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new EnqueteDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    EnqueteDto ed = (EnqueteDto)dii;
    ed.setItemValue(EnqueteDto.FINISH_DAY, DateUtil.getDate());
    _ep.update(ed);
    return msg;
  }

}
