package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;
import com.hamaf.hikyaku.util.DateUtil;
import com.hamaf.hikyakucms.sample.sns.dto.EnqueteDto;
import com.hamaf.hikyakucms.sample.sns.process.EnqueteProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.EnqueteMap;

/**
 * <p>^CgFEnqueteUpdate is .</p>
 * <p>FAP[g̓o^EXV</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/25</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class EnqueteUpdate extends StandardCheckAndUpdate {

  public static final String MSG_QUS = "questions";

  private final String CHK_FLDR = "EnqueteUpdate";
  private EnqueteProcess _ep = null;

  /**
   * Creates a new <code>EnqueteUpdate.java</code> instance.
   * <br>Default Constructor
   */
  public EnqueteUpdate() {
    _jim = new EnqueteMap();
    _ep = new EnqueteProcess();
    _cfld = CHK_FLDR;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new EnqueteDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    if (msg.getReqStr("allFlg").length() == 0) dii.setItemValue(EnqueteDto.ALL_FLG, "");
    if (msg.getReqStr("multiFlg").length() == 0) dii.setItemValue(EnqueteDto.MUTLTI_FLG, "");
    if (msg.getReqStr("saysFlg").length() == 0) dii.setItemValue(EnqueteDto.SAYS_FLG, "");
    EnqueteDto ed = (EnqueteDto)dii;
    if (!msg.getReqStr("allFlg").equals("1")) {
      ed.setItemValue(EnqueteDto.ALL_FLG, "0");
      String[] rest = msg.getReqStr(CommunicationDetail.MSG_GID).split(",");
      for (int i = 0; i < rest.length; i++) {
        ed.addRestriction(rest[i]);
      }
    }
    String[] ques = msg.getReqValus(MSG_QUS);
    for (int i = 0; i < ques.length; i++) {
      if (ques[i] != null && ques[i].length() > 0) {
        String[] dt = {ques[i], ""};
        ed.addQuestion(dt);
      }
    }
    String seq = dii.getItemValue(EnqueteDto.SEQNO);
    if (seq == null || seq.length() == 0) {
      String nno = _ep.regist(ed);
      msg.setResMsg("seqNo", nno);
    } else {
      _ep.update(ed);
    }
    return msg;
  }

  private final String ERR_TDY = "IߋtɂȂĂ܂B";
  private final String ERR_GRP = "ΏۃO[v܂͑S[UIĂ܂B";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#checkRelation(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage checkRelation(CommonMessage msg) throws Exception {
    String tdy = msg.getReqStr("dayTo");
    if (tdy != null && tdy.length() > 0) {
      if (tdy.compareTo(DateUtil.getDate()) < 0) {
        msg.setErrorStatus(STATUS.WARNING);
        msg.setResMsg("dayTo", ERR_TDY);
      }
    }
    String alf = msg.getReqStr("allFlg");
    if ("1".equals(alf)) return msg;

    String grp = msg.getReqStr(CommunicationDetail.MSG_GID);
    if (grp.length() == 0) {
      msg.setErrorStatus(STATUS.WARNING);
      msg.setResMsg("groupdsp", ERR_GRP);
    }
    return msg;
  }

}
