package com.hamaf.hikyakucms.sample.sns.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;
import com.hamaf.hikyakucms.sample.sns.access.Hatsuban2Access.HATSUBAN2_KBN;
import com.hamaf.hikyakucms.sample.sns.dto.SoliloquyDto;
import com.hamaf.hikyakucms.sample.sns.process.FootprintsProcess;
import com.hamaf.hikyakucms.sample.sns.process.SoliloquyProcess;
import com.hamaf.hikyakucms.sample.sns.ui.mapping.SoliloquyMap;

/**
 * <p>^CgFSoliloquyDelete is .</p>
 * <p>FƂ茾̍폜</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/30</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class SoliloquyDelete extends StandardUpdateProcess {

  private SoliloquyProcess _sp = null;
  private FootprintsProcess _fp = null;

  /**
   * Creates a new <code>SoliloquyDelete.java</code> instance.
   * <br>Default Constructor
   */
  public SoliloquyDelete() {
    _jim = new SoliloquyMap();
    _sp = new SoliloquyProcess();
    _fp = new FootprintsProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new SoliloquyDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    _sp.delete((SoliloquyDto)dii);
    _fp.delFootprints(HATSUBAN2_KBN.SOLILOQUY, dii.getItemValue(SoliloquyDto.SEQNO), sysId);
    return msg;
  }

}
