/**
 *
 */
package com.hamaf.hikyakucms.sample.wiki.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;
import com.hamaf.hikyakucms.sample.wiki.dto.WikiDocDto;
import com.hamaf.hikyakucms.sample.wiki.process.WikiDocProcess;
import com.hamaf.hikyakucms.sample.wiki.ui.mapping.WikiDocMap;

/**
 * <p>^CgFWikiAdd is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/12</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WikiAdd extends StandardCheckAndUpdate {

  private WikiDocProcess _wdp = null;

  /**
   * Creates a new <code>WikiAdd</code> instance.
   * <br>Default Constructor
   */
  public WikiAdd() {
    _wdp = new WikiDocProcess();
    _jim = new WikiDocMap();
    _cfld = "WikiAdd";
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage cmsg) throws Exception {
    WikiDocDto wdd = (WikiDocDto)dii;
    wdd.setDocument(cmsg.getReqStr(WikiDetail.CONTENTS));
    _wdp.addNew(wdd);
    cmsg.setResMsg(WikiDetail.DOCNO, wdd.getItemValue(WikiDocDto.WIKI_NO));
    return cmsg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new WikiDocDto();
  }

}
