package com.hamaf.hikyakucms.sample.wiki.ui;

import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;
import com.hamaf.hikyakucms.sample.wiki.dto.WikiDocDto;
import com.hamaf.hikyakucms.sample.wiki.process.WikiDocProcess;
import com.hamaf.hikyakucms.sample.wiki.ui.mapping.WikiDocMap;

/**
 * <p>^CgFWikiUpdate is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/12</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WikiUpdate extends StandardCheckAndUpdate {

  private WikiDocProcess _wdp = null;

  /**
   * Creates a new <code>WikiUpdate</code> instance.
   * <br>Default Constructor
   */
  public WikiUpdate() {
    _wdp = new WikiDocProcess();
    _jim = new WikiDocMap();
    _cfld = "WikiAdd";
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage cmsg) throws Exception {
    WikiDocDto wdd = (WikiDocDto)dii;
    wdd.setDocument(cmsg.getReqStr(WikiDetail.CONTENTS));
    wdd.setChapter(cmsg.getReqStr(WikiDetail.CHAPTER));
    wdd.setSection(cmsg.getReqStr(WikiDetail.SECTION));
    _wdp.editDoc(wdd);
    cmsg.setResMsg(WikiDetail.CHAPTER, "0");
    cmsg.setResMsg(WikiDetail.SECTION, "0");
    return cmsg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new WikiDocDto();
  }

}
