package com.hamaf.hikyakucms.sample.wiki.util;

import java.io.BufferedReader;
import java.io.Reader;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

/**
 * <p>^CgFWikiFaining is .</p>
 * <p>FWikiHtml`ɕϊ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WikiFaining {
  /**
   * Creates a new <code>WikiFaining</code> instance.
   *
   */
  public WikiFaining() {
  }

  private Stack<String> _stk = new Stack<String>();
  private WikiFormatter _wf = new WikiFormatter();
  private int _vbt = 0;

  public String faining(Reader dt) throws Exception {
    List<String> inDt = orthopedicsLine(dt);
    StringBuilder sb = new StringBuilder();
    for (String inb : inDt) {
      if (inb.length() == 0) {
        sb.append(pairOut(""));
        if (_vbt == 0) sb.append("<p/>");
      } else {
        sb.append(convLine(inb));
      }
      sb.append("\n");
    }
    sb.append(pairOut(""));
    return sb.toString();
  }
  private String convLine(String inb) {
    List<DefReprace> wfl = getFormater();
    StringBuilder sb = new StringBuilder();
//     System.out.println("## input data : " + inb);

    for (DefReprace dp : wfl) {
      if (dp.getType() != null) {
        if (inb.matches(dp.getFrom())) {
          String tp = dp.getType();
          sb.append(pairOut(tp));
          inb = inb.replaceFirst(dp.getFrom(), dp.getTo());
          if (tp.charAt(0) == 'v') {
            _vbt = Integer.parseInt(tp.substring(1));
          } else if (!tp.equals("l")) {
            if (_stk.empty() || !tp.equals(_stk.peek())) {
              sb.append(cnvType(tp, false));
              _stk.push(tp);
            }
            if (tp.equals("table")) {
              sb.append(createTbl(inb));
              inb = "";
            }
          }
          sb.append(inb);
          inb = sb.toString();
          break;
        }
      } else {
        inb = inb.replaceAll(dp.getFrom(), dp.getTo());
      }
    }
    return inb;
  }
  private String createTbl(String inb) {
    String[] cols = inb.split(",");
    StringBuilder sb = new StringBuilder();
    sb.append("<tr>\n");
    for (int i = 0; i < cols.length; i++) {
      sb.append("<td");
      if (cols[i].charAt(0) == ' ') {
        if (cols[i].charAt(cols[i].length() - 1) == ' ') {
          sb.append(" align='center'");
        } else {
          sb.append(" align='right'");
        }
      }
      sb.append(">");
      sb.append(cols[i]);
      sb.append("</td>\n");
    }
    sb.append("</tr>\n");
    return sb.toString();
  }
  private List<DefReprace> getFormater() {
    switch (_vbt) {
    case 1:
      return _wf.getFormatter();
    case 2:
      return _wf.getFormatterVerbatim();
    }
    return _wf.getFormatterAll();
  }
  private String pairOut(String type) {
    if (_stk.empty()) return "";
    if (type.length() == 3) {
      String lvl = _stk.peek();
      if (lvl.length() == 3) {
        if (type.charAt(2) > lvl.charAt(2)) return "";
      }
    }

    StringBuilder sb = new StringBuilder();
    while (!_stk.empty() && !_stk.peek().equals(type)) {
      sb.append(cnvType(_stk.pop(), true));
    }
    return sb.toString();
  }
  private String cnvType(String type, boolean end) {
    StringBuilder sb = new StringBuilder();
    if (end) {
      sb.append("</");
    } else {
      sb.append("<");
    }
    if (type.length() != 3) {
      sb.append(type);
    } else {
      sb.append(type.substring(0, 2));
    }
    sb.append(">\n");
    return sb.toString();
  }

  private static final String FirstChr = " *-+?:,";
  private List<String> orthopedicsLine(Reader dt) throws Exception {
    BufferedReader brd = new BufferedReader(dt);
    String buf = brd.readLine();
    List<String> ldt = new ArrayList<String>();
    boolean isVerbatim = false;
    StringBuilder svb = new StringBuilder();
    while (buf != null) {
      if (buf.startsWith("--(") || buf.startsWith("---(")) {
        isVerbatim = true;
      }
      if (isVerbatim || buf.length() == 0 || FirstChr.indexOf(buf.charAt(0)) >= 0) {
        if (svb.length() > 0) ldt.add(svb.toString());
        svb = new StringBuilder();
        if (buf.length() == 0) ldt.add("");
        if (buf.length() > 1 && buf.charAt(0) == '*') {
          ldt.add(buf);
          buf = "";
        }
      }
      if (buf.startsWith("--)") || buf.startsWith("---)")) {
        isVerbatim = false;
      }
      svb.append(buf);
      buf = brd.readLine();
    }
    if (svb.length() > 0) {
      ldt.add(svb.toString());
    }
    return ldt;
  }

}
