package com.hamaf.hikyakucms.sample.wiki.util;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>^CgFWikiFormatter is .</p>
 * <p>FWikip̕ϊݒ菈</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/09/05</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class WikiFormatter {
  List<DefReprace> _fmtall = new ArrayList<DefReprace>();
  List<DefReprace> _fmt = new ArrayList<DefReprace>();
  List<DefReprace> _fmtev = new ArrayList<DefReprace>();

  public WikiFormatter() {
    setFormat();
  }
  private void setFormat() {
    _fmtall.add(new DefReprace("&", "&amp;"));
    _fmtall.add(new DefReprace("<", "&lt;"));
    _fmtall.add(new DefReprace(">", "&gt;"));
    _fmtall.add(new DefReprace("''''''","<b></b>"));
    // C
    _fmtall.add(new DefReprace("'{5}(.+?)'{5}", "<i><b>$1</b></i>"));
    _fmtall.add(new DefReprace("'{3}(.+?)'{3}", "<i>$1</i>"));
    _fmtall.add(new DefReprace("'{2}(.+?)'{2}", "<b>$1</b>"));
    // r
    _fmtall.add(new DefReprace("@ruby\\((.+?),(.+?)\\)",
                               "<ruby><rb>$1</rb><rp>(</rp><rt>$2</rt><rp>)</rp></ruby>"));
    // 摜
    _fmtall.add(new DefReprace("http://(.+?)(.gif|.jpg|.jpeg|.png|.GIF|.JPG|.JPEG|.PNG)",
                               "<img src='$0'>"));
    // N
    _fmtall.add(new DefReprace("@link\\((.+?),(.+?)\\)",
                               "<a href='$2' target='_blank'>$1</a>"));
    _fmtall.add(new DefReprace("([^(=')])(http://[-a-zA-Z0-9+&@#/%?=~_|!:,.;]+)",
                               "$1<a href='$2' target='_blank'>$2</a>"));
    _fmtall.add(new DefReprace("\\[\\[(.+?)\\]\\]",
                               "<a href=dummy onclick=\"ref('$1'); return false;\">$1</a>"));
    // o[xC^
    _fmtall.add(new DefReprace("^---\\(", "<pre>", "v2"));
    _fmtall.add(new DefReprace("^--\\(", "<pre>", "v1"));
    _fmtall.add(new DefReprace("^---\\)", "</pre>", "v0"));
    _fmtall.add(new DefReprace("^--\\)", "</pre>", "v0"));

    _fmtev.add(new DefReprace("^---\\)", "</pre>", "v0"));
    _fmtev.add(new DefReprace("^--\\)", "</pre>", "v0"));

    // i
    _fmt.add(new DefReprace("^ (.*)", "<br>\n$0", "l"));
    // 
    _fmt.add(new DefReprace("^-{4,}(.*)", "\n<hr/>\n$1", "l"));
    // p
    _fmt.add(new DefReprace("^:(.+?):(.*)","<dt>$1</dt><dd>$2</dd>", "dl"));
    // ӏ
    _fmt.add(new DefReprace("^(-|\\+){2}-(.+?)", "<li>$2", "ul3"));
    _fmt.add(new DefReprace("^(-|\\+){2}\\+(.+?)", "<li>$2", "ol3"));
    _fmt.add(new DefReprace("^(-|\\+)-(.+?)", "<li>$2", "ul2"));
    _fmt.add(new DefReprace("^(-|\\+)\\+(.+?)", "<li>$2", "ol2"));
    _fmt.add(new DefReprace("^-(.+?)", "<li>$1", "ul1"));
    _fmt.add(new DefReprace("^\\+(.+?)", "<li>$1", "ol1"));
    // p
    _fmt.add(new DefReprace("^\\?{3}(.+)",
       "<blockquote><blockquote><blockquote>$1</blockquote></blockquote></blockquote>", "l"));
    _fmt.add(new DefReprace("^\\?{2}(.+)",
                            "<blockquote><blockquote>$1</blockquote></blockquote>", "l"));
    _fmt.add(new DefReprace("^\\?{1}(.+)", "<blockquote>$1</blockquote>"));
    // e[u
    _fmt.add(new DefReprace("^,(.*)", "$1", "table"));
    // o
    _fmt.add(new DefReprace("^\\*{3}(.*)", "<h4>$1</h4>", "l"));
    _fmt.add(new DefReprace("^\\*{2}(.*)", "<h3>$1</h3><edit>", "l"));
    _fmt.add(new DefReprace("^\\*{1}(.*)", "<h2>$1</h2><edit>", "l"));
  }

  public List<DefReprace> getFormatter() {
    return _fmtall;
  }
  public List<DefReprace> getFormatterVerbatim() {
    return _fmtev;
  }
  public List<DefReprace> getFormatterAll() {
    List<DefReprace> ret = new ArrayList<DefReprace>();
    ret.addAll(_fmtall);
    ret.addAll(_fmt);
    return ret;
  }

}
