package com.hamaf.business.generaldoc.ui;

import java.io.File;
import java.util.Set;

import com.hamaf.business.generaldoc.dto.AppendFileDto;
import com.hamaf.business.generaldoc.process.AppendFileProcess;
import com.hamaf.business.generaldoc.ui.mapping.AppendFileMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.dataobject.MultiCommonMessage;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.ui.MultipartProcessBase;
import com.hamaf.hikyaku.util.ComUtils;

/**
 * <p>^CgFAppendAdd is .</p>
 * <p>FYtt@C̓o^</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/22</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AppendAdd extends MultipartProcessBase {

  private final String MSG_OK = "AppendFileAdd";
  private AppendFileProcess _afp = null;
  /**
   * Creates a new <code>AppendAdd.java</code> instance.
   * <br>Default Constructor
   */
  public AppendAdd() {
    _afp = new AppendFileProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    MultiCommonMessage mcm = (MultiCommonMessage)msg;
    AppendFileDto afd = setItemValue(mcm);
    _afp.regist(afd);
    mcm.setResMsg(MSG_OK, "1");
    return mcm;
  }

  private AppendFileDto setItemValue(MultiCommonMessage msg) {
    AppendFileDto afd = new AppendFileDto();
    AppendFileMap afm = new AppendFileMap();
    Set<String> reqnms = msg.getReqKeys();
    for (String fld : afm) {
      if (reqnms.contains(fld)) {
        afd.setItemValue(afm.getDtoNo(fld), msg.getReq(fld));
      }
    }
    afd.setTempFilePath(msg.getTempFileUrl());
    String fnm = msg.getFileName();
    int p = fnm.lastIndexOf(File.separator);
    afd.setItemValue(AppendFileDto.DISP_FILE, fnm.substring(p + 1));
    afd.setItemValue(AppendFileDto.CONTENT, msg.getContentType());
    afd.setItemValue(AppendFileDto.FILE_SIZE, ComUtils.convertFileSize(msg.getFileSize()));
    p = fnm.lastIndexOf(".");
    if (p > 0 && fnm.length() > p) afd.setItemValue(AppendFileDto.FILE_TYPE, fnm.substring(p + 1));

    Set<String> reqfld = msg.getReqKeys();
    for (COMMFLD fld : COMMFLD.values()) {
      if (reqfld.contains(fld.getVal())) {
        afd.setCommFld(fld, msg.getReq(fld.getVal()));
      }
    }
    Object udt = session.getAttribute(LogInCheck.USER_INF);
    if (udt != null && udt instanceof UserDto) {
      afd.setCommFld(COMMFLD.UUSR, ((UserDto)udt).getItemValue(UserDto.USER_ID));
    }
    afd.setSysId(sysId);
    return afd;
  }

}
