package com.hamaf.business.generaldoc.ui;

import com.hamaf.business.generaldoc.dto.AppendFileDto;
import com.hamaf.business.generaldoc.dto.AppendFileSearchDto;
import com.hamaf.business.generaldoc.process.AppendFileProcess;
import com.hamaf.business.generaldoc.ui.mapping.AppendFileMap;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFAppendList is .</p>
 * <p>FYtt@Cꗗ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/03/15</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AppendList extends StandardListProcess {

  private AppendFileProcess _afp = null;
  /**
   * Creates a new <code>AppendList.java</code> instance.
   * <br>Default Constructor
   */
  public AppendList() {
    _jim = new AppendFileMap();
    _afp = new AppendFileProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
      throws IllegalRetrieveDataException {
    AppendFileSearchDto afsd = new AppendFileSearchDto();
    afsd.setRetrieveValue(AppendFileSearchDto.CATEGORY,
        keyl.getRetrieve("category"));
    afsd.setRetrieveValue(AppendFileSearchDto.KEY_SEQNO,
        keyl.getRetrieve("keySeq"));
    afsd.setOrderItem(AppendFileSearchDto.SEQNO, -1);
    return afsd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _afp.find((AppendFileSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new AppendFileDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _afp.findByPrimarKkey((AppendFileDto)dii);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface dii) {
    return null;
  }

}
