package com.hamaf.business.generaldoc.ui;

import com.hamaf.business.generaldoc.dto.GeneralDocDto;
import com.hamaf.business.generaldoc.process.GeneralDocProcess;
import com.hamaf.business.generaldoc.ui.mapping.GeneralDocMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.ui.StandardDetailProcess;

/**
 * <p>^CgFGeneralDetail is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/28</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class GeneralDetail extends StandardDetailProcess {

  private GeneralDocProcess _gdp = null;
  private SecurityCheckUtils _scu = null;
  
  /**
   * Creates a new <code>GeneralDetail</code> instance.
   * <br>Default Constructor
   */
  public GeneralDetail() {
    _jim = new GeneralDocMapping();
    _gdp = new GeneralDocProcess();
    _scu = new SecurityCheckUtils();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _gdp.getDetaail((GeneralDocDto)dii);
  }

  private final String MSG_UNM = "uname";
  @Override
  protected CommonMessage editItems(CommonMessage argMsg) throws Exception {
    String uid = argMsg.getResMsg("addUser");
    UserDto ud = _scu.getUserInf(uid, getUserID());
    argMsg.setResMsg(MSG_UNM, ud.getItemValue(UserDto.NAME));
    String did = argMsg.getResMsg("docId");
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    String gtp = mxc.getTagValue("gentype", did, "gentypeName");
    argMsg.setResMsg("GenType", gtp);
    return argMsg;
  }

  @Override
  protected boolean setKeys(DetailItemsInterface dii, CommonMessage msg) {
    String seq = msg.getReqStr("seqNo");
    if (seq.length() > 0) {
      dii.setItemValue(GeneralDocDto.SEQNO, seq);
      return true;
    }
    seq = msg.getReqStr("keyValue");
    if (seq.length() > 0) {
      dii.setItemValue(GeneralDocDto.SEQNO, seq);
      return true;
    }
    return false;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardDetailProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new GeneralDocDto();
  }

}
