package com.hamaf.business.workflow.access;

import com.hamaf.business.workflow.dto.HatsubanDto;
import com.hamaf.hikyaku.access.DefaultTableAccess;

/**
 * <p>^CgFHatsubanAccess is .</p>
 * <p>FM_HATSUBAN(ԃ}X^)ANZXpNX</p>
 * <br>
 *
 * <p>쌠: Copyright c2012/10/03</p>
 * @author @USR
 * @version 1.0
 */
public class HatsubanAccess extends DefaultTableAccess {

  public enum HATSUBAN_KBN {
    FLOW("F", 5, false),
    DOCUMENT("D", 9, false),
    GENERAL("G", 7, false),
    FILE("A", 7, true);

    private String key;
    private int len;
    private boolean subk;
    HATSUBAN_KBN(String k, int l, boolean sk) { key = k; len = l; subk = sk;}
    public String getKey() { return key; }
    public int getLen() { return len; }
    public boolean getSubk() { return subk; }

  };

  private final String TBLNM = "M_HATSUBAN";
  private final String PARM = "hkbusiness";

  /**
   *  Creates a new <code>HatsubanAccess.java</code> instance.
   * <br>Default Constructor
   */
  public HatsubanAccess() {
    tableName = TBLNM;
    connectionParameter = PARM;
//    super.setDebug();
  }

  public String getNextNo(HATSUBAN_KBN kb, String key, String sysId) throws Exception {
    HatsubanDto hd = getHatubanDto(kb, key, sysId);
    hd = (HatsubanDto)findByPrimaryKey(hd);
    if (hd.isNotFound()) {
      String mno = addNo("0", kb);
      hd.setItemValue(HatsubanDto.MAX_NUMBER, mno);
      regist(hd);
      return mno;
    }
    String mno = addNo(hd.getItemValue(HatsubanDto.MAX_NUMBER), kb);
    hd.setItemValue(HatsubanDto.MAX_NUMBER, mno);
    update(hd);
    return mno;
  }

  private HatsubanDto getHatubanDto(HATSUBAN_KBN kb, String key, String sysId) {
    HatsubanDto hd = new HatsubanDto();
    hd.setItemValue(HatsubanDto.KUBUN, kb.getKey());
    hd.setSysId(sysId);
    if (kb.getSubk()) {
      hd.setItemValue(HatsubanDto.KEY_VALUE, key);
    } else {
      hd.setItemValue(HatsubanDto.KEY_VALUE, "key");
    }
    hd.setAllRequest();
    return hd;
  }

  private String addNo(String no, HATSUBAN_KBN kb) {
    int len = kb.getLen();
    int ino = Integer.parseInt(no);
    ino++;
    no = String.valueOf(ino);
    if(no.length() > len) {
      return no.substring(no.length() - len);
    }
    StringBuilder sb = new StringBuilder();
    for (int i = 0; i < (len - no.length()); i++) {
      sb.append("0");
    }
    sb.append(no);
    return sb.toString();
  }

}
