package com.hamaf.business.workflow.ui;

import java.util.List;
import java.util.Map;

import com.hamaf.business.workflow.dto.VDfAuthorizerDto;
import com.hamaf.business.workflow.dto.VDfAuthorizerSearchDto;
import com.hamaf.business.workflow.process.AgentProcess;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.VDfAuthorizerMapping;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFAgencyApprovalList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/15</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AgencyApprovalList extends StandardListProcess {

  private DocumentFlowProcess _dfp = null;
  private AgentProcess _ap = null;

  /**
   * Creates a new <code>AgencyApprovalList</code> instance.
   * <br>Default Constructor
   */
  public AgencyApprovalList() {
    _jim = new VDfAuthorizerMapping();
    _dfp = new DocumentFlowProcess();
    _ap = new AgentProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _dfp.getAuthorizerDetail((VDfAuthorizerDto)dii);
  }

  private final String RES_UNAME = "uname";
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> mp) throws Exception {
    mp.put(RES_UNAME, ((VDfAuthorizerDto)dii).getName());
    return mp;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface argArg0) {
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _dfp.findAuthorize((VDfAuthorizerSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDfAuthorizerDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    VDfAuthorizerSearchDto vdasd = new VDfAuthorizerSearchDto();
    String usr = klst.getRetrieve("suser");
    if (usr == null || usr.length() == 0) {
      try {
        List<String> luser = _ap.findUsers(getUserID(), sysId);
        StringBuilder sb = new StringBuilder();
        for (String uid : luser) {
          sb.append("'");
          sb.append(uid);
          sb.append("',");
        }
        if (sb.length() > 0) {
          sb.setLength(sb.length() - 1);
        } else {
          sb.append("'_who_'");
        }
        vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER, sb.toString());
        vdasd.setCondition(VDfAuthorizerSearchDto.AUTHORIZER, "in");
      } catch (Exception ex) {
        new IllegalRetrieveDataException(ex.getMessage(), null);
      }
    } else {
      vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER, usr);
    }
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER_KUBUN, "C");
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.STATUS, "C");
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.APPLICANT_NAME,
        klst.getRetrieve("sname"));
    vdasd.setCondition(VDfAuthorizerSearchDto.APPLICANT_NAME, "like");
    
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_REQUEST, 1);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_REQUEST, 2);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.AUTHORIZER, 3);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DOCUMENT_ID, 4);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DOCUMENT_NO, 5);
    return vdasd;
  }

}
