package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.AgentDto;
import com.hamaf.business.workflow.dto.AgentSearchDto;
import com.hamaf.business.workflow.process.AgentProcess;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFAgentList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/09</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AgentList extends StandardListProcess {

  private AgentProcess _ap = null;
  /**
   * Creates a new <code>AgentList</code> instance.
   * <br>Default Constructor
   */
  public AgentList() {
    _ap = new AgentProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _ap.getDetail((AgentDto)dii);
  }

  public static final String RES_AGENT = "agent";
  private final String RES_AUTHORIZER = "user";
  private final String RES_NAME = "name";
  @Override
  protected void setItems() {
    addItem(RES_AUTHORIZER, AgentDto.AUTHORIZER);
    addItem(RES_AGENT, AgentDto.AGENT);
    addItem(RES_NAME, AgentDto.AGENT_NAME);
  }

  private final String MSG_DEL = "*** 폜Ă܂ ***";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface argArg0) {
    if (delCheck(argArg0)) {
      String[] ret = {RES_NAME, MSG_DEL};
      return ret;
    }
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _ap.find((AgentSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new AgentDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    AgentSearchDto asd = new AgentSearchDto();
    asd.setRetrieveValue(AgentSearchDto.AUTHORIZER, super.getUserID());
    asd.setOrderItem(AgentSearchDto.AGENT, 1);
    return asd;
  }

}
