package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.AgentDto;
import com.hamaf.business.workflow.process.AgentProcess;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;

/**
 * <p>^CgFAgentMod is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/09</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class AgentMod extends StandardUpdateProcess {

  private AgentProcess _ap = null;
  /**
   * Creates a new <code>AgentMod</code> instance.
   * <br>Default Constructor
   */
  public AgentMod() {
    _ap = new AgentProcess();
  }

  private final String UPKBN = "upkbn";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    dii.setItemValue(AgentDto.AUTHORIZER, getUserID());
    dii.setItemValue(AgentDto.AGENT, msg.getReq(AgentList.RES_AGENT));
    String kbn = msg.getReqStr(UPKBN).toLowerCase();
    if (kbn.startsWith("a")) {
      _ap.addNew((AgentDto)dii);
    } else if (kbn.startsWith("d")) {
      _ap.delete((AgentDto)dii);
    }
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new AgentDto();
  }

}
