package com.hamaf.business.workflow.ui;

import java.util.ArrayList;
import java.util.List;

import com.hamaf.business.workflow.dto.DocumentFlowDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.DocumentFlowMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFApprovalRequest is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/14</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class ApprovalRequest extends StandardCheckAndUpdate {

  private DocumentFlowProcess _dfp = null;
  /**
   * Creates a new <code>ApprovalRequest</code> instance.
   * <br>Default Constructor
   */
  public ApprovalRequest() {
    _jim = new DocumentFlowMapping();
    _dfp = new DocumentFlowProcess();
  }

  public static final String MSG_DOCNO = "docNo";
  public static final String MSG_GROPID = "groupId";
  public static final String MSG_USERS = "userId";
  public static final String MSG_CHECK = "chkTyp";
  
  private final String MSG_END = "F˗̓o^܂B";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    List<String> lusr = new ArrayList<String>();
    String usrs = msg.getReqStr(MSG_USERS);
    if (usrs.length() > 0) {
      String[] ausr = usrs.split(",");
      for (int i = 0; i < ausr.length; i++) {
        lusr.add(ausr[i]);
      }
    }
    String dno = _dfp.addNew((DocumentFlowDto)dii, msg.getReqStr(MSG_GROPID), lusr, msg.getReqStr(MSG_CHECK));
    msg.setResMsg(MSG_DOCNO, dno);
    msg.setResMsg(MSG_GROPID, "");
    msg.setResMsg(MSG_USERS, "");
    msg.setResMsg(MSG_CHECK, "");
    msg.addMessage(MSG_END);
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new DocumentFlowDto();
  }

}
