package com.hamaf.business.workflow.ui;

import java.util.ArrayList;
import java.util.List;

import com.hamaf.business.workflow.dto.DfAuthorizerDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.DfAuthorizerMapping;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardUpdateProcess;

/**
 * <p>^CgFApprove is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/14</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class Approve extends StandardUpdateProcess {

  private DocumentFlowProcess _dfp = null;
  
  /**
   * Creates a new <code>Approve</code> instance.
   * <br>Default Constructor
   */
  public Approve() {
    _jim = new DfAuthorizerMapping();
    _dfp = new DocumentFlowProcess();
  }

  private final String MSG_END = "F͏I܂B";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    if (!getUserID().equals(dii.getItemValue(DfAuthorizerDto.AUTHORIZER))) {
      dii.setItemValue(DfAuthorizerDto.AGENT, getUserID());
    }
    List<String> lusr = new ArrayList<String>();
    String usrs = msg.getReqStr(ApprovalRequest.MSG_USERS);
    if (usrs.length() > 0) {
      String[] ausr = usrs.split(",");
      for (int i = 0; i < ausr.length; i++) {
        lusr.add(ausr[i]);
      }
    }
    _dfp.approval((DfAuthorizerDto)dii, msg.getReqStr(ApprovalRequest.MSG_GROPID),
        lusr, msg.getReqStr(ApprovalRequest.MSG_CHECK));
    msg.setResMsg("status", "E");
    msg.addMessage(MSG_END);
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardUpdateProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new DfAuthorizerDto();
  }

}
