package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.BaseFlowDto;
import com.hamaf.business.workflow.dto.BaseFlowSearchDto;
import com.hamaf.business.workflow.process.BaseFlowProcess;
import com.hamaf.business.workflow.ui.mapping.BaseFlowMapping;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFBaseFlowList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/09</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class BaseFlowList extends StandardListProcess {

  private BaseFlowProcess _bfp = null;
  
  /**
   * Creates a new <code>BaseFlowList</code> instance.
   * <br>Default Constructor
   */
  public BaseFlowList() {
    _jim = new BaseFlowMapping();
    _bfp = new BaseFlowProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _bfp.getFlowDetail((BaseFlowDto)dii);
  }

  private final String MSG_DEL = "*** 폜Ă܂ ***";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface argArg0) {
    if (delCheck(argArg0)) {
      String[] ret = {"name", MSG_DEL};
      return ret;
    }
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _bfp.findFlow((BaseFlowSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new BaseFlowDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    BaseFlowSearchDto bfsd = new BaseFlowSearchDto();
    bfsd.setOrderItem(BaseFlowDto.FLOW_NO, 1);
    String val = klst.getRetrieve("sname");
    if (val != null && val.length() > 0) {
      bfsd.setRetrieveValue(BaseFlowSearchDto.NAME, "%" + val + "%");
      bfsd.setCondition(BaseFlowSearchDto.NAME, "like");
    }
    
    return bfsd;
  }

}
