package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.dto.DocumentInfDto;
import com.hamaf.business.workflow.process.DocumentInfProcesss;
import com.hamaf.business.workflow.ui.mapping.DocInfMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFDocInfAdd is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/09</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class DocInfAdd extends StandardCheckAndUpdate {

  private DocumentInfProcesss _dip = null;
 
  /**
   * Creates a new <code>DocInfAdd</code> instance.
   * <br>Default Constructor
   */
  public DocInfAdd() {
    _cfld = "DocInfAdd";
    _jim = new DocInfMap();
    _dip = new DocumentInfProcesss();
  }

  private final String UPKBN = "upkbn";
  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    String kbn = msg.getReqStr(UPKBN).toLowerCase();
    if (kbn.startsWith("a")) {
      _dip.addNew((DocumentInfDto)dii);
    } else if (kbn.startsWith("m")) {
      _dip.update((DocumentInfDto)dii);
    }
    return msg;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new DocumentInfDto();
  }

}
