package com.hamaf.business.workflow.ui;

import com.hamaf.business.workflow.access.BaseLevelAccess.AUTHORIZER_KUBUN;
import com.hamaf.business.workflow.dto.BaseLevelDto;
import com.hamaf.business.workflow.process.BaseFlowProcess;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.security.ui.LogInCheck;
import com.hamaf.hikyaku.ui.ProcessBase;

/**
 * <p>^CgFNextLevel is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/24</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class NextLevel extends ProcessBase {

  private BaseFlowProcess _bfp = null;
  
  /**
   * Creates a new <code>NextLevel</code> instance.
   * <br>Default Constructor
   */
  public NextLevel() {
    _bfp = new BaseFlowProcess();
  }

  private final String MSG_FLOWNO = "flowNo";
  private final String MSG_LEVEL = "level";
  
  private final String RMSG_GROUPID = "groupId";
  private final String RMSG_USERIDS = "userId";
  private final String RMSG_GROUP_NAME = "groupNm";
  private final String RMSG_USERS_NAME = "userNm";
  private final String RMSG_USERS_DNAME = "userNmDsp";
  private final String RMSG_CHECK_TYPE = "chkTyp";

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.ProcessBase#exec(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  public CommonMessage exec(CommonMessage msg) throws Exception {
    BaseLevelDto bld = createDto();
    bld.setItemValue(BaseLevelDto.FLOW_NO, msg.getReqStr(MSG_FLOWNO));
    bld.setItemValue(BaseLevelDto.LEVEL, addOne(msg.getReqStr(MSG_LEVEL)));
    bld.setItemValue(BaseLevelDto.AUTHORIZER_KUBUN, AUTHORIZER_KUBUN.AUTHORIZE.getVal());
    bld = _bfp.getLeveDetail(bld);
    if (bld.isNotFound()) return msg;
    
    msg.setResMsg(RMSG_CHECK_TYPE, bld.getItemValue(BaseLevelDto.CHECK_TYPE));
    msg.setResMsg(RMSG_GROUPID, bld.getGroups());
    msg.setResMsg(RMSG_GROUP_NAME, bld.getGnames());
    msg.setResMsg(RMSG_USERIDS, bld.getUsers());
    msg.setResMsg(RMSG_USERS_NAME, bld.getUnames());
    msg.setResMsg(RMSG_USERS_DNAME, bld.getUnames().replaceAll(",", "\n"));
    return msg;
  }

  private BaseLevelDto createDto() {
    BaseLevelDto bld = new BaseLevelDto();
    bld.setSysId(sysId);
    Object udt = session.getAttribute(LogInCheck.USER_INF);
    if (udt != null && udt instanceof UserDto) {
      bld.setCommFld(COMMFLD.UUSR, ((UserDto)udt).getItemValue(UserDto.USER_ID));
    }
    bld.setAllRequest();
    return bld;
  }
  
  private String addOne(String no) throws Exception {
    int ino = Integer.parseInt(no);
    ino++;
    return String.valueOf(ino);
  }
  
}
