package com.hamaf.business.workflow.ui;

import java.util.Map;

import com.hamaf.business.workflow.access.DocumentFlowAccess.FLOW_RESULT;
import com.hamaf.business.workflow.dto.VDocumentFlowDto;
import com.hamaf.business.workflow.dto.VDocumentFlowSearchDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.VDocumentFlowMapping;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFRequestList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/15</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class RequestList extends StandardListProcess {

  private DocumentFlowProcess _dfp = null;

  /**
   * Creates a new <code>RequestList</code> instance.
   * <br>Default Constructor
   */
  public RequestList() {
    _jim = new VDocumentFlowMapping();
    _dfp = new DocumentFlowProcess();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _dfp.getDocInf((VDocumentFlowDto)dii);
  }

  private final String REQ_STVAL = "stval";
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> mp) throws Exception {
    MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
    mp.put(REQ_STVAL, mxc.getTagValue("result",
        dii.getItemValue(VDocumentFlowDto.RESULT), "resultName"));
    return mp;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface argArg0) {
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    return _dfp.findDocFlow((VDocumentFlowSearchDto)rki);
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDocumentFlowDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList klst)
      throws IllegalRetrieveDataException {
    VDocumentFlowSearchDto vdfsd = new VDocumentFlowSearchDto();
    vdfsd.setRetrieveValue(VDocumentFlowSearchDto.APPLICANT, getUserID());
    String srt = klst.getRetrieve("sresult");
    if (srt == null || srt.length() == 0) srt = FLOW_RESULT.APPROVAL_IN.getVal();
    vdfsd.setRetrieveValue(VDocumentFlowSearchDto.RESULT, srt);
    vdfsd.setRetrieveValue(VDocumentFlowSearchDto.APP_DATE,
        klst.getRetrieve("sdate"));
    vdfsd.setCondition(VDocumentFlowSearchDto.APP_DATE, ">=");
    
    if (FLOW_RESULT.APPROVAL_IN.getVal().equals(klst.getRetrieve(srt))) {
      vdfsd.setOrderItem(VDocumentFlowSearchDto.APP_DATE, 1);
      vdfsd.setOrderItem(VDocumentFlowSearchDto.APP_TIME, 2);
    } else {
      vdfsd.setOrderItem(VDocumentFlowSearchDto.APP_DATE, -1);
      vdfsd.setOrderItem(VDocumentFlowSearchDto.APP_TIME, -2);
    }
    vdfsd.setOrderItem(VDocumentFlowSearchDto.DOCUMENT_NO, 3);
    return vdfsd;
  }

}
