package com.hamaf.business.workflow.ui;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.hamaf.business.workflow.access.BaseLevelAccess.AUTHORIZER_KUBUN;
import com.hamaf.business.workflow.access.DfAuthorizerAccess.AUTHORIZER_STATUS;
import com.hamaf.business.workflow.access.DfAuthorizerAccess.NOTIFICATION;
import com.hamaf.business.workflow.access.DocumentFlowAccess.FLOW_RESULT;
import com.hamaf.business.workflow.dto.VDfAuthorizerDto;
import com.hamaf.business.workflow.dto.VDfAuthorizerSearchDto;
import com.hamaf.business.workflow.process.DocumentFlowProcess;
import com.hamaf.business.workflow.ui.mapping.VDfAuthorizerMapping;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFTopDispList is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2012/10/26</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class TopDispList extends StandardListProcess {

  private DocumentFlowProcess _dfp = null;
  /**
   * Creates a new <code>TopDispList</code> instance.
   * <br>Default Constructor
   */
  public TopDispList() {
    _dfp = new DocumentFlowProcess();
    _jim = new VDfAuthorizerMapping();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected DetailItemsInterface callControl(DetailItemsInterface dii)
      throws Exception {
    return _dfp.getAuthorizerDetail((VDfAuthorizerDto)dii);
  }

  private final String RET_MSG = "dspmsg";
  @Override
  protected Map<String, String> editItems(DetailItemsInterface dii,
      Map<String, String> map) throws Exception {
    StringBuilder sb = new StringBuilder();
    if (AUTHORIZER_KUBUN.PLACER.getVal().equals(dii.getItemValue(VDfAuthorizerDto.AUTHORIZER_KUBUN))) {
      sb.append("u");
    } else {
      sb.append(dii.getItemValue(VDfAuthorizerDto.APPLICANT_NAME));
      sb.append("u");
    }
    sb.append(dii.getItemValue(VDfAuthorizerDto.DOCUMENT_NAME));
    sb.append("v");
    if (AUTHORIZER_KUBUN.NOTIFICATION.getVal().equals(dii.getItemValue(VDfAuthorizerDto.AUTHORIZER_KUBUN))) {
      sb.append("̏F˗Ɋւʒm܂B");
    } else if (AUTHORIZER_KUBUN.AUTHORIZE.getVal().equals(dii.getItemValue(VDfAuthorizerDto.AUTHORIZER_KUBUN))) {
      if (AUTHORIZER_STATUS.CHECKING.getVal().equals(dii.getItemValue(VDfAuthorizerDto.STATUS))) {
        sb.append("̏F˗Ă܂B");
      } else {
        sb.append("̏F˗۔F܂AmFĂB");
      }
    } else {
      if (FLOW_RESULT.APPROVED.getVal().equals(dii.getItemValue(VDfAuthorizerDto.RESULT))) {
        sb.append("F");
      } else {
        sb.append("۔F");
      }
      sb.append("܂BmFĂB");
    }
    map.put(RET_MSG, sb.toString());
    return map;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
   */
  @Override
  protected String[] checkDelete(DetailItemsInterface argArg0) {
    return null;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
   */
  @Override
  protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
      throws Exception {
    VDfAuthorizerSearchDto vdasd = (VDfAuthorizerSearchDto)rki;
    vdasd = _dfp.findAuthorize(vdasd);
    List<List<String>> svKey = new ArrayList<List<String>>();
    svKey.addAll(vdasd.getKeys());
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.NOTIFICATION, "");
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.STATUS, AUTHORIZER_STATUS.CHECKING.getVal());
    vdasd.clearKeys();
    vdasd = _dfp.findAuthorize(vdasd);
    for (List<String> key : vdasd.getKeys()) {
      if (!svKey.contains(key)) svKey.add(key);
    }
    vdasd.clearKeys();
    vdasd.setKeys(svKey);
    return vdasd;
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new VDfAuthorizerDto();
  }

  /* ( Javadoc)
   * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
   */
  @Override
  protected RetrieveKeysInterface setRetrieveVal(KeyList argArg0)
      throws IllegalRetrieveDataException {
    VDfAuthorizerSearchDto vdasd = new VDfAuthorizerSearchDto();
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.AUTHORIZER, getUserID());
    vdasd.setRetrieveValue(VDfAuthorizerSearchDto.NOTIFICATION, NOTIFICATION.NOTIFICATION_IN.getVal());
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DATE_REQUEST, 1);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.TIME_REQUEST, 2);
    vdasd.setOrderItem(VDfAuthorizerSearchDto.DOCUMENT_NO, 3);
    return vdasd;
  }

}
